Attribute VB_Name = "ARCH1"
Option Explicit

Global CSVPropInfo(200) As HistDisplayType, NOCXCSVProps%
Global ServerPropInfo() As HistDisplayType, NOCXServerProps%
Global OCXPropertyListFlag%, OCXFormCaption$, OCXConfigDirectory$

Type ArchiveServerInfo
  HistoryServerName As String
  DataServerName As String
  ConfigFileName As String
  StateServerName As String
  MachineName As String
  ConfigFilePath As String
End Type

Global Const NUMEQP = 1000
Global Const NUMDEV = 100
Global Const MaxStrings = 500
Global Const MaxPoints = 4000 '20000 ' 4000
Global Const MaxCurves = 10
Global Const MaxPlots = 10
Global Const MaxDevices = 10000
Global NMachines

Global ComJob$, ComFacility$, FormLoaded As Boolean
Global Const CommandArchiver$ = "ARCHIVER"
Global Const CommandLHistChooser$ = "LHCHOOSER"
Global Const CommandLHistClient$ = "LHCLIENT"
Global UseFileServerFlag As Boolean

Global ArchiveServerTestNames$(10), NArchiveServerTestNames%

Global Const OpMinus = "-"
Global Const OpPlus = "+"
Global Const OpMult = "*"
Global Const OpDiv = "/"
Global Const ErrorValue! = 1E+20
Global DisplayModes$(8), DisplayModeIndexes%(8), NDisplayModes%

Global Const CArchivers = 0
Global Const LHistoryChooser = 1
Global Const LHistoryClient = 2

Global Const RelativeScale = 0
Global Const AbsoluteScale = 1
Global ArchiveMode%, ScalingMode%, SwitchingScalingFlag As Boolean
Global SkipLoading%

Global Const OneHour& = 3600
Global Const OneDay& = 24 * OneHour

Global devNames() As String, NDevs%
Global devNameBuff(MaxDevices, MaxCurves) As String

Global Const CopyOffset = MaxCurves

Global Const NTDBunches = 12 ' Number of bunches in TTF-TD Archives...
Global SwitchingWindows As Boolean
Global LiveData As Boolean

Global Const MaxZooms = 10
Global NZooms%, ZoomLimits#(MaxZooms, 3)
Global ArchiveStart&, ArchiveStop&, KeepZoom#(3)
Global SelectedTrace%(1), SelectedTracePlotIndex&(1), SelectedPlotArrayTrace%

Global ArchStringDataBuffer(MaxStrings, MaxCurves * 2) As NAME32I
Global ArchDataBuffer(MaxPoints, MaxCurves * 2) As DBLDBL
Global ArchData(MaxPoints, MaxCurves * 2) As DBLDBL
Global ArchTimeBins#(MaxPoints, MaxCurves * 2)
Global PlotData(MaxPoints, MaxCurves * 2) As DBLDBL

Global ArrayData!(), ArrayRefData!(), PlotArrayData!(), RefAxisData!()
Global ArrayDataSize&, ArrayDataTimeStamp&, ArrayDataKeyword$
Global ArrayINTData%(), ArrayProp$, ArrayServerDevName$, ArrayLinkIndex&

Global ActivePlot%, ArchiveTS&, ReferenceTS&
Global ArchiveTSIndex%, KinoIndex%, KinoFrames%, KinoCursor%, ChubbyFactor!
Global KinoFlag As Boolean

Global ExtraDigitFlag As Boolean, DLabWidthDefault%, DUnitLeftDefault%, DHelpLeftDefault%

Global filterDataBuffer(MaxPoints, 10) As FLTINT, filterDataBufferNPoints&(10)
Global filterTextBuffer(MaxPoints / 10, 10) As NAME32I
Global filterAcquired As Boolean
Global filterString As String

Global YCursorArray!(1), XCursorArray&(1), DNameToIndex%(MaxCurves * 2), IndexToDName%(MaxCurves * 2)
Global ACOPDefaultMode&, ACOPDefaultWidth&, ACOPDisplayModes&(10), ACOPBarModeFlag As Boolean
Global gArchiveServer$, gDataServer$, SelectedMachine%, SelectedConfig%

Global gArchiveServerInfo() As ArchiveServerInfo ' ReDim in getArchiveServerInfo()
Global nConfiguredArchiveServers As Integer, UserConfigOK As Boolean
Global Const ConfFiles = 500
Global SetFile$(), SetHelp$(), SetDir$()     ' ReDim in getArchiveServerInfo()
Global NElem%(), NSet%()          ' ReDim in getArchiveServerInfo()

'Global fdat(MaxPoints, MaxCurves) As Single
'Global ltim(MaxPoints, MaxCurves) As Long
'Global xdat(MaxPoints, MaxCurves) As Long
Global ydat(MaxPoints, MaxCurves) As Single
Global xdat0&(MaxPoints), ydat0!(MaxPoints)
Global xdat1&(MaxPoints), ydat1!(MaxPoints)
Global xdat2(MaxPoints) As Long
Global ydat2(MaxPoints) As Single
Global ydat3(MaxPoints) As Single


Global Nmax_last(MaxCurves) As Integer
Global ih_last(MaxCurves) As Integer
Global xIndex As Integer, OptXIndex%
Global yIndex As Integer, OptYIndex%
Global saveConfigCanceled As Boolean
Global saveConfigFileName As String
Global saveConfigDescription As String

Global nl$
Global Win_Sec&(10)
Global datstr As String * 32
Global param%, Index%, iplotable%
Global StartUp%
Global TargetYear As Integer

Global F_load As Integer

Global col_field(10) As Long
Global SelectBits&(16)

Global nparam%
Global Const DBPATH$ = "l:\database\archive\"
Global ConfPath$, UserConfPath$, HelpFilePath$, HistoryPath$, UserHistoryPath$, HistoryOCXPath$, HistoryOCXUserConfigPath$
Global UserConfigSubDirectory$, ConfigPath$
Global rtyp As String * 1
Type FECSTRUCT: eqm As String
                prop As String
                dev As String
                EqNo As Integer
                len As Integer
                fmt As String
                reclen As Integer
                rectyp As Integer
                tstamp As Integer
                vnum As Integer
                Comment As String
                responsible As String
                recIndex As Integer
End Type
Global fec(NUMEQP) As FECSTRUCT
Global vname$(NUMEQP, NUMDEV), vfmt$(NUMEQP, NUMDEV), vcmt$(NUMEQP, NUMDEV), VPlot$(NUMEQP, NUMDEV)
Global VMax#(NUMEQP, NUMDEV), VMin#(NUMEQP, NUMDEV), VUnit$(NUMEQP, NUMDEV), vsize%(NUMEQP, NUMDEV)
Global fref%(NUMEQP), pref%(NUMEQP), VOffset#(NUMEQP, NUMDEV), Nexti%, Nextp%, Nextf%, NextSubi%
Global correlate%, lg%

Global MKIoffset%, DLabWidth%

Type FECSLCT: ' structure for selected properties:
              'PropIndex As Integer
'
              ArchiveSourceFlag As Boolean ' From Central archiver, or a history?
              ContextName As String
              ServerName As String
              PropName As String
              deviceName As String
              DeviceIndex As Integer
              DeviceSubIndex As Integer ' for TD properties,...
              PropUnits As String
              PropSize As Long
              PropFormat As Byte
              PropFormatStr As String
              PropDesc As String
              NPropDevices As Long ' if the number of DEVICES for the property is not its SIZE
              
              ' Which has been used to select this channel? Device NAME or INDEX?
              ValidDeviceName As Boolean
              ValidDeviceIndex As Boolean
              
              'ArchiveServer As String
              'FecName As String ' Archiver-Keyword....
              'fecNo As Integer are these really NOT needed? (pref and fref....)
              'pNo As Integer
              'helpText As String
              '
              ' Need for Local History Stuff
              ArchiveDataServer As String
              ArchiveHistoryServer As String
              ArchiveProperty As String
              ' Flag that data is from archiver....
              LHDataAlsoFromArchiver As Boolean
              WhereToGetLHData As Integer
              
              '
              NumPoints As Integer
              TotalPoints As Long
              ' Total History Points
              TotalLHPoints As Long
              ' Total Archive Points
              TotalArchPoints As Long
              '
              '
              DataServer As String
              LinkIndex As Long
              ACOPPlotIndex As Long
              DrawWidth As Integer
              DispColor As Long
              '
              Scale As Integer
              PListIndex As Integer
              VMax As Double ' Default Values
              VMin As Double ' for scaling
              VScale As Double
              VOffset As Double
              VPlot As String
              VUnit As String
              Active As Boolean
              Acquire As Boolean
              ReFilter As Boolean
              ReScale As Boolean
              RePlot As Boolean
              MaxValue As Double
              MinValue As Double
              ' For SPECTRA
              ArrayType As Integer
              XMaxValue As Double
              XMinValue As Double
              XUnits As String
              'Offset As Integer
              '
              SelectedMaxValue As Double ' When reading in TextBox stuff...
              SelectedMinValue As Double ' For scaling....
              SelectedOffset As Double ' For scaling....
              SelectedVMode As String ' Plotted as Log/Lin...
              SelectedVModeIndex As Integer ' Plotted as Log/Lin...
              PlotMaxValue As Double ' Actual Values (especially for AUTOSCALE, needed for ARRAY mode)
              PlotMinValue As Double ' for scaling
              PlotOffset As Double ' for scaling
              PlotZeroOffset As Double ' for calculating BACK
              PlotDelta As Double '
              PlotScale As Double '
              PlotAutoScale As Boolean
End Type
Global FSlct(MaxCurves * 2) As FECSLCT

Type SETSLCT: Name As String
              ContextName As String
              ServerName As String
              EqnIndex As Integer
              deviceName As String
              DeviceIndex As Integer
              DeviceSubIndex As Integer
              AxScale As Double
              AxOffset As Double
              min As Double
              max As Double
              plottype As String
              Units As String
              Help As String
End Type
Global CSet() As SETSLCT ' ReDim in getArchiveServerInfo()

Global NPlots%(1)
Global fecKeywords() As String, ttfKeywords() As String

Type KeywordInfo
  server As String
  keyword As String
  max As Single
  min As Single
  egu As String
  plot As String
  desc As String
  size As Integer
  fmt As String
  ArrayType As Integer
  XMax As Single
  XMin As Single
  XUnits As String
End Type

Global archivedKeywords() As KeywordInfo
Global filterKeywords(10) As KeywordInfo
Global nFilterKeywords As Integer
Global TmpConfigKeyword As KeywordInfo

Type HistoryConfigType
    Name As String
    Description As String
    LocationProps As String
    LocationConfigs As String
    NClientOcxProps As Integer
    NClientCSVProps As Integer
    OCXFlag As Boolean
    OCX_But_use_CentralFiles_Flag As Boolean
    WhichCentralDirectoryForConfigFiles As String
End Type
Global HistoryConfigs(20) As HistoryConfigType
Global NHistoryConfigs%, MaxNHistoryConfigs%, SelectedHistoryConfig%, SelectedHistoryConfigDescription$

Global gSubSystems() As String
Global gArchiveSubSystem$
Global gNumSubSystems As Integer
'Global cslct(2) As FECSLCT
'Global typ$(3)
Global extraArchiveServer(10) As String
Global nExtraArchiveServers As Integer
Global Const MaxnExtraArchiveServers = 5


' REDUCE for Kaul's slow PC....
Global Const MaxPlotPoints = 3000
Global Const MaxGetDataPointsARCH = 2000
Global Const MaxGetDataPointsHIST = 2000
Global Const MaxDataPointsAPPEND = MaxPlotPoints - MaxGetDataPointsHIST - 2
Global AppendTimeIncrement%, AppendTimeCounter%, AppendTotalCounter%


' Registry function declarations:
Public Const HKEY_CLASSES_ROOT = &H80000000
Public Const HKEY_CURRENT_USER = &H80000001
Public Const HKEY_LOCAL_MACHINE = &H80000002
Public Const HKEY_USERS = &H80000003

Declare Function RegOpenKey Lib "advapi32.dll" Alias "RegOpenKeyA" _
        (ByVal hKey As Long, ByVal lpctstr As String, phKey As Long) _
        As Long
        
Declare Function RegQueryValue Lib "advapi32.dll" Alias "RegQueryValueA" _
        (ByVal hKey As Long, ByVal lpSubKey As String, ByVal lpValue As String, _
         lpcbValue As Long) As Long

Declare Function RegQueryValueEx Lib "advapi32.dll" Alias "RegQueryValueExA" _
        (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpdwReserved As Long, _
         lpdwType As Long, lpbData As Byte, lpcbValue As Long) As Long

Declare Function RegCloseKey Lib "advapi32.dll" (ByVal hKey As Long) As Long
Public Sub PlotTheData(flag%)
Dim i%, ii%, n%, StartLabel%, StopLabel%, TmpPlots%, tmpIndex%, TmpMin#, tmpMax#
Dim errcnt As Integer

On Error GoTo PlotTheDataError
ArchiveForm.ACOPPlot(ActivePlot%).LockScreen 0
' Mode from OptPlot

ArchiveForm.ComSelect(2).BackColor = &HE0E0E0
For i% = 0 To 2
    ArchiveForm.TxtSelect(i%).BackColor = &HE0E0E0
Next i%

StartLabel% = ActivePlot * CopyOffset
StopLabel% = ActivePlot * CopyOffset + MaxCurves - 1

If flag = 0 Then
    ' refresh everything....
    For i% = StartLabel% To StopLabel%
        If FSlct(i%).Active = True Then
            FSlct(i%).RePlot = True
        Else
            FSlct(i%).RePlot = False
        End If
    Next i%
    
    
    ArchiveForm.ACOPPlot(ActivePlot%).ClearScreen
    
    ArchiveForm.ACOPPlot(ActivePlot%).Visible = True
    'ArchiveForm.ACOPPlot(ActivePlot%).GraphStyle = TIME_LIN
ElseIf flag = 1 Then
    ArchiveForm.ACOPPlot(ActivePlot%).ClearScreen
End If

If NZooms% > 0 Then
    'ArchiveForm.ACOPPlot(ActivePlot%).ymin = ZoomLimits&(NZooms%, 2)
    'ArchiveForm.ACOPPlot(ActivePlot%).ymax = ZoomLimits&(NZooms%, 3)
    'ArchiveForm.ACOPPlot(ActivePlot%).xmin = ZoomLimits&(NZooms%, 0)
    'ArchiveForm.ACOPPlot(ActivePlot%).xmax = ZoomLimits&(NZooms%, 1)
Else
    ZoomLimits#(0, 0) = CDbl(ArchiveStart&)
    ZoomLimits#(0, 1) = CDbl(ArchiveStop&)
    
    If ScalingMode% = RelativeScale Then
        ZoomLimits#(0, 2) = 0
        ZoomLimits#(0, 3) = 100
    Else
        ' Do the same check in ScaleData ?
        TmpMin# = 1000000#
        tmpMax# = -1000000#
        For i% = StartLabel% To StopLabel%
            With FSlct(i%)
                If FSlct(i%).RePlot = True Then
                    If .PlotMaxValue > tmpMax# Then tmpMax# = .PlotMaxValue
                    If .PlotMinValue < TmpMin# Then TmpMin# = .PlotMinValue
                End If
            End With
        Next i%
        ZoomLimits#(0, 2) = TmpMin#
        ZoomLimits#(0, 3) = tmpMax#
    End If
End If

ArchiveForm.ACOPPlot(ActivePlot%).ymin = ZoomLimits#(NZooms%, 2)
ArchiveForm.ACOPPlot(ActivePlot%).ymax = ZoomLimits#(NZooms%, 3)
ArchiveForm.ACOPPlot(ActivePlot%).XMin = CLng(ZoomLimits#(NZooms%, 0))
ArchiveForm.ACOPPlot(ActivePlot%).XMax = CLng(ZoomLimits#(NZooms%, 1))

' Get more points than one thinks one needs (x-min and max are set to ZOOM limits not to ArchiveStart and -Stop
'ArchiveStart& = ArchiveStart& - 3600 * 1
'ArchiveStop& = ArchiveStop& + 3600 * 1

' Get an overview of what is to be plotted?
Call DrawCaption

For i% = StartLabel% To StopLabel%
    ArchiveForm.dnam(i%).BorderStyle = 0
    'ArchiveForm.Text1(i%).text = ""
Next i%

'For i% = 0 To 3
'    ArchiveForm.ComSelect(i%).Enabled = False
'Next i%

ArchiveForm.ChkAuto(1).Enabled = False

For i% = StartLabel% To StopLabel%
    If FSlct(i%).Active And FSlct(i%).RePlot = True Then
        n% = FSlct(i%).NumPoints
        ArchiveForm.ACOPPlot(ActivePlot%).DisplayMode = ACOPDefaultMode&
        ArchiveForm.ACOPPlot(ActivePlot%).ForeColor = FSlct(i%).DispColor
        ArchiveForm.ACOPPlot(ActivePlot%).DrawWidth = 1 * ChubbyFactor! + ACOPDefaultWidth&
            
' for some inexplicible reason the Draw method can occasionally fail (hence the new error logic!)
        FSlct(i%).ACOPPlotIndex = ArchiveForm.ACOPPlot(ActivePlot%).Draw(PlotData(0, i%).d1val, PlotData(0, i%).d2Val, , , n%, "DBLDBL", MaxPoints)
    
        FSlct(i%).RePlot = False
    Else
        FSlct(i%).RePlot = False
    End If
Next i%

' Check if automatic AUTOSCALE (for ABSOLUTE scaling) is on?
If ArchiveForm.ChkScale.Value = vbUnchecked And ArchiveForm.ChkAuto(2).Value = vbChecked Then
    ArchiveForm.ACOPPlot(0).AutoScale False, False, True, True
    ArchiveForm.ACOPPlot(1).AutoScale False, False, True, True
    ArchiveForm.ACOPPlot(2).AutoScale False, False, True, True
End If

ArchiveForm.ACOPPlot(ActivePlot%).LockScreen 1

TmpPlots% = NPlots%(ActivePlot%)
If ActivePlot% = 1 Then TmpPlots% = TmpPlots% + CopyOffset
For i% = StartLabel% To TmpPlots% - 1
    ArchiveForm.OptX(i%).Visible = True
    ArchiveForm.OptY(i%).Visible = True
Next i%
For i% = TmpPlots% To StopLabel%
    ArchiveForm.OptX(i%).Visible = False
    ArchiveForm.OptY(i%).Visible = False
Next i%

'ArchiveForm.ACOPPlot(ActivePlot%).AutoScale True, True, False, False

If SelectedTrace%(ActivePlot%) <> -1 Then
    tmpIndex% = SelectedTrace%(ActivePlot%)
    Call SelectATrace(tmpIndex%)
End If
ArchiveForm.LabelMisc(3).Visible = False

' ALSO REFRESH CORRELATE PLOT?
If ArchiveForm.ChkDouble(2).Value = vbChecked Or ArchiveForm.ChkDouble(3).Value = vbChecked Then
    Call DrawCorr
End If

Exit Sub
PlotTheDataError:
errcnt = errcnt + 1
If errcnt < 3 Then Resume
Exit Sub
End Sub

Public Sub ScaleTheData(ChannelFlag%, DataFlag%)
Dim i%, ii%, j%, n%, StartLabel%, StopLabel%, tmpFaktor!, TmpOffset!, tmpMask&
Dim ScaleMax!, ScaleMin!, ScaleOffset!, tmpPlotRange!, tmpPlotOffset!
Dim Delta!, ZeroOffset!, InvDelta!, tmpCopyBytes&, tmpNPoints%

Dim tmpArchData(MaxPoints) As DBLDBL

StartLabel% = ActivePlot * CopyOffset
StopLabel% = ActivePlot * CopyOffset + MaxCurves - 1

On Error Resume Next

' How to do the scaling? 0-100, or absolute, or ACOP-YScale?
'If ScalingMode% = 0 Then

If ChannelFlag% = 0 Then
    ' refresh everything....
    For i% = StartLabel% To StopLabel%
        If FSlct(i%).Active = True Then
            FSlct(i%).ReScale = True
        Else
            FSlct(i%).ReScale = False
        End If
    Next i%
End If

'Need to do anything? Check if RELATIVE scale....
If ArchiveForm.ChkScale.Value Then
    'Need to do the re-scaling
Else
    For i% = StartLabel% To StopLabel%
        If FSlct(i%).ReScale = True Then
            'FSlct(i%).ReScale = False
            'FSlct(i%).RePlot = True
        Else
            ''FSlct(i%).ReScale = False
        End If
    Next i%
End If

For i% = StartLabel% To StopLabel%
    If FSlct(i%).Active And FSlct(i%).ReScale = True And FSlct(i%).NumPoints > 0 Then
        n% = FSlct(i%).NumPoints
        
        ' What is this for?
        For j% = 0 To NDisplayModes% - 1
            If UCase$(FSlct(i%).SelectedVMode) = DisplayModes$(j%) Then
                FSlct(i%).SelectedVModeIndex = DisplayModeIndexes%(j%)
                Exit For
            End If
        Next j%
                
        ' A bit of data-verarbeiting...
        ' Check if the DATA is meant to be scaled...
        tmpFaktor! = FSlct(i%).VScale
        If DataFlag% = 0 Then
            If Not (tmpFaktor! = 0 Or tmpFaktor! = 1) Then
                TmpOffset! = FSlct(i%).VOffset
                For ii% = 0 To n% - 1
                   'tmpArchData(ii%).fval = ArchData(ii%, i%).fval * tmpFaktor! + TmpOffset!
                   'tmpArchData(ii%).iVal = ArchData(ii%, i%).iVal
                   ArchData(ii%, i%).d1val = ArchData(ii%, i%).d1val * tmpFaktor! + TmpOffset!
                Next ii%
            ElseIf (FSlct(i%).VPlot = "BIT") Or (FSlct(i%).VPlot = "BITS") Then
                'FSlct(i%).VMax = 16.1
                'FSlct(i%).VMin = -0.05
                FSlct(i%).SelectedMaxValue = FSlct(i%).VMax
                FSlct(i%).SelectedMinValue = FSlct(i%).VMin
               
                ' ScaleForBits
                'tmpFaktor! = 1
                'tmpMask& = SelectBits&(FSlct(i%).DeviceSubIndex - 1)
                For ii% = 0 To n% - 1
                   'tmpArchData(ii%).fval = ScaleForBits(i%, CLng(ArchData(ii%, i%).fval)) '2 * i% + (CLng(ArchData(ii%, i%).fval) And TmpMask&) / TmpMask&
                   'tmpArchData(ii%).iVal = ArchData(ii%, i%).iVal
                   ArchData(ii%, i%).d1val = ScaleForBits(i%, CLng(ArchData(ii%, i%).d1val)) '2 * i% + (CLng(ArchData(ii%, i%).fval) And TmpMask&) / TmpMask&
                Next ii%
            ElseIf UCase$(FSlct(i%).SelectedVMode) = "LOG" Then
                ' Do this check HERE, and do it only ONCE....
                For ii% = 0 To n% - 1
                   'If ArchData(ii%, i%).fval <= 0 Then tmpArchData(ii%).fval = 0.0000001 Else tmpArchData(ii%).fval = ArchData(ii%, i%).fval
                   'tmpArchData(ii%).iVal = ArchData(ii%, i%).iVal
                   If ArchData(ii%, i%).d1val <= 0 Then ArchData(ii%, i%).d1val = 0.0000001
                Next ii%
                tmpFaktor! = 1
            'Else
            '    tmpCopyBytes& = CLng(n%) * 8
            '    Call MEMCPYL(tmpArchData(0).fval, ArchData(0, i%).fval, tmpCopyBytes&)
            End If
        'Else
        End If
        tmpCopyBytes& = CLng(n%) * 16
        Call MEMCPYL(tmpArchData(0).d1val, ArchData(0, i%).d1val, tmpCopyBytes&)

        
        FSlct(i%).PlotScale = tmpFaktor!
        
        FSlct(i%).MaxValue = -1
        FSlct(i%).MinValue = -1
                                                      
        If FSlct(i%).PlotAutoScale Then 'tmpAutoFlag Then
            ' Scale to the Max and Min values IN THE DATA....
            If FSlct(i%).MaxValue = -1 And FSlct(i%).MinValue = -1 Then
                ' Must find NEW max and min values
                ScaleMax! = CSng(ArchData(1, i%).d1val)
                ScaleMin! = ScaleMax!
                For ii% = 2 To n%
                    ' Only look at points being DISPLAYED!
                    If tmpArchData(ii%).d2Val > ZoomLimits#(NZooms%, 0) And tmpArchData(ii%).d2Val < ZoomLimits#(NZooms%, 1) Then
                        If tmpArchData(ii%).d1val > ScaleMax! Then
                            ScaleMax! = tmpArchData(ii%).d1val
                        ElseIf tmpArchData(ii%).d1val < ScaleMin! Then
                            ScaleMin! = tmpArchData(ii%).d1val
                        End If
                    End If
                Next ii%
                ' make sure an array of "all the same thing" goes down the middle:
                If ScaleMax! = ScaleMin! Then
                  ScaleMax! = ScaleMax! + ScaleMax! * 0.1 + 1
                  ScaleMin! = ScaleMin! - ScaleMin! * 0.1 - 1
                End If
                FSlct(i%).MaxValue = ScaleMax!
                FSlct(i%).MinValue = ScaleMin!
            End If
            ' Put them 5% away from the edge?
            ScaleMax! = FSlct(i%).MaxValue + (FSlct(i%).MaxValue - FSlct(i%).MinValue) * 0.01
            ScaleMin! = FSlct(i%).MinValue - (FSlct(i%).MaxValue - FSlct(i%).MinValue) * 0.01
        
            ScaleMax! = ScaleMax! * 1
            ScaleMin! = ScaleMin!
        
            ScaleOffset! = 0
        Else
            FSlct(i%).MaxValue = -1: FSlct(i%).MinValue = -1
            ScaleMax! = FSlct(i%).SelectedMaxValue
            ScaleMin! = FSlct(i%).SelectedMinValue
            ScaleOffset! = FSlct(i%).SelectedOffset
        End If
                
        FSlct(i%).PlotMaxValue = ScaleMax!
        FSlct(i%).PlotMinValue = ScaleMin!
        FSlct(i%).PlotOffset = ScaleOffset!
    
        If FSlct(i%).PlotAutoScale Then 'tmpAutoFlag Then
            tmpPlotRange! = ZoomLimits#(NZooms%, 3) - ZoomLimits#(NZooms%, 2)
            tmpPlotOffset! = ZoomLimits#(NZooms%, 2)
        Else
            tmpPlotRange! = 100
            tmpPlotOffset! = 0
        End If
        
        If n% <= 1 Then
            Delta! = ScaleMax! - ScaleMin!
            ZeroOffset! = ScaleMin! + FSlct(i%).PlotOffset
            FSlct(i%).PlotDelta = Delta! / 100
            FSlct(i%).PlotZeroOffset = ZeroOffset!
        Else
            ' To scale the data properly....
            If UCase$(FSlct(i%).SelectedVMode) = "LOG" Then
                If ScaleMin <= 0 Then ScaleMin = 0.01
                If ScaleMax! <= 0 Then ScaleMax! = ScaleMin! * 100000
                Delta! = (Log(ScaleMax!) - Log(ScaleMin!)) '/ Log(10#)
                If FSlct(i%).VMin = 0 Then FSlct(i%).VMin = 1E-20
                ZeroOffset! = Log(ScaleMin) 'Log(FSlct(i%).VMin) '/ Log(10#)
            Else
                Delta! = ScaleMax! - ScaleMin!
                ZeroOffset! = ScaleMin! + FSlct(i%).PlotOffset
            End If
        
            ' Use the scale-factor in the form for the GRAPHICS!
            If Delta! = 0 Then InvDelta! = 1 Else InvDelta! = tmpPlotRange! / Delta!
        
            ' For re-scaling
            If tmpPlotRange! = 0 Then tmpPlotRange! = 100
            FSlct(i%).PlotDelta = Delta! / tmpPlotRange!
            FSlct(i%).PlotZeroOffset = ZeroOffset!
        
            ' The number of points in the array...
            'PlotData(0, i%).iVal = ArchData(0, i%).iVal
            
            Select Case ScalingMode%
            Case AbsoluteScale:
                    tmpCopyBytes& = (n% + 1) * 16
                    Call MEMCPYL(PlotData(0, i%).d1val, tmpArchData(0).d1val, tmpCopyBytes&)
            
            Case RelativeScale:
                
                ' Plotting "mode"
                If UCase$(FSlct(i%).SelectedVMode) = "LOG" Then
                    'Call ARRLOG(ydat(0, i%), ydat(0, i%), n%)
                    For ii% = 0 To n% - 1
                        PlotData(ii%, i%).d2Val = tmpArchData(ii%).d2Val
                        If tmpArchData(ii%).d1val > 0 Then
                            PlotData(ii%, i%).d1val = (Log(tmpArchData(ii%).d1val) - ZeroOffset!) * InvDelta! + tmpPlotOffset!
                            'PlotData(ii%, i%).d1val = (Log(ArchData(ii%, i%).d1val) - ZeroOffset!) * InvDelta!
                        Else
                            PlotData(ii%, i%).d1val = 0
                        End If
                    Next ii%
                ElseIf UCase$(FSlct(i%).SelectedVMode) = "ABS" Then
                    For ii% = 0 To n% - 1
                        PlotData(ii%, i%).d2Val = tmpArchData(ii%).d2Val
                        PlotData(ii%, i%).d1val = (Abs(tmpArchData(ii%).d1val) - ZeroOffset!) * InvDelta! + tmpPlotOffset!
                    Next ii%
                ElseIf UCase$(FSlct(i%).SelectedVMode) = "SLOG" Then
                    'Call ARRMULT(CF_FLOAT, ydat(0, i%), 1 / fslct(i%).VMax, n%)
                    tmpFaktor! = 1 '/ FSlct(i%).VMax
                    For ii% = 0 To n% - 1
                        PlotData(ii%, i%).d2Val = tmpArchData(ii%).d2Val
                        If tmpArchData(ii%).d1val > 0 Then
                            ii% = ii%
                        End If
                        PlotData(ii%, i%).d1val = (tmpArchData(ii%).d1val * tmpFaktor! - ZeroOffset!) * InvDelta! + tmpPlotOffset!
                    Next ii%
                Else
                    For ii% = 0 To n% - 1
                        PlotData(ii%, i%).d2Val = tmpArchData(ii%).d2Val
                        PlotData(ii%, i%).d1val = (tmpArchData(ii%).d1val - ZeroOffset!) * InvDelta! + tmpPlotOffset!
                        'Debug.Print ii%, PlotData(ii%, i%).ival, PlotData(ii%, i%).d1val, ArchData(ii%, i%).d1val
                    Next ii%
                End If
            End Select
        End If
    
        FSlct(i%).ReScale = False
        FSlct(i%).ReFilter = True
        FSlct(i%).RePlot = True
    Else
        ' Nothing to do?
        FSlct(i%).ReScale = False
    End If
Next i%
End Sub


Public Sub DoTheData(flag%)

'   flag=0  alle daten neu
'   flag=1  nur plotten ohne daten holen

' NEW
Call ReadTheData(flag%)

'If ArchiveMode% = CArchivers Then
'    Call ReadTheArchiveData(Flag%)
'Else
'    Call ReadTheHistoryData(Flag%)
'End If

' Throw out points?

Call FilterTheData(flag%)

'
Call ScaleTheData(flag%, 0)

'
Call PlotTheData(0) '(Flag%)

End Sub

Function getArchiveServerInfo(fname As String) As Integer
Dim i%, j%, p%, a$, tok$, done As Boolean
Dim hst_col%, dat_col%, mac_col%, cfg_col%, state_col%
Dim fn$

'fn$ = App.Path + "\" + fname
fn$ = ConfPath$ + "\" + fname

NMachines = getDatabaseSize(fn$)
If NMachines = 0 Then
  getArchiveServerInfo = 0
  Exit Function
End If

' put USER files in NMACHINES +1
ReDim gArchiveServerInfo(NMachines + 1)
ReDim SetFile$(NMachines + 1, ConfFiles)
ReDim SetDir$(NMachines + 1, ConfFiles)
ReDim SetHelp$(NMachines + 1, ConfFiles)
ReDim NElem%(NMachines + 1, ConfFiles)
ReDim NSet%(NMachines + 1)
ReDim CSet(NMachines + 1, ConfFiles, 30)

Open fn$ For Input Access Read Shared As #1
Do
  Line Input #1, a$
  tok$ = Left$(a$, 1)
  If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" And a$ <> "" Then
    If Not done Then
      hst_col = colptr(a$, "ARCHIVE SERVER")
      dat_col = colptr(a$, "DATA SERVER")
      mac_col = colptr(a$, "MACHINE")
      state_col = colptr(a$, "STATE SERVER")
      cfg_col = colptr(a$, "CONFIG FILE")
      done = True
    Else
      gArchiveServerInfo(i%).ConfigFileName = getcol(a$, cfg_col)
      gArchiveServerInfo(i%).DataServerName = getcol(a$, dat_col)
      gArchiveServerInfo(i%).HistoryServerName = getcol(a$, hst_col)
      gArchiveServerInfo(i%).StateServerName = getcol(a$, state_col)
      gArchiveServerInfo(i%).MachineName = getcol(a$, mac_col)
      i% = i% + 1
      If i% >= NMachines Then Exit Do
    End If
  End If
Loop While Not EOF(1)
Close 1
getArchiveServerInfo = i%
End Function
Function getKeywordNames(server As String, keyword As String, keywordNames() As String) As Integer
Dim rc%, i%
Dim dbout As DBLK
Dim dbin As DBLK
Dim dbinbuf(1) As Long
Dim size As Integer
Dim kwd As String
Dim bKeywordNames() As NAME16
Dim bkwd(32) As Byte
Dim prp As PropertyQuery
Dim tmpstr$
Dim tmpNameSize%

kwd = keyword + ".NAM"

dbin.dArrayLength = 1: dbin.dFormat = CF_NAME32
BARR bkwd(), kwd
dbout.dArrayLength = Len(prp): dbout.dFormat = CF_STRUCT
rc = T_EXECLINK(server, "PROPS", dbout, prp, dbin, bkwd(0), CA_READ, 1000)
If prp.prpSize = 0 Then rc = illegal_property
If rc = 0 Then
  size = prp.prpSize
  ReDim bKeywordNames(size)
  dbout.dArrayLength = size: dbout.dFormat = CF_NAME16
  If ArchiveStart& > 0 And ArchiveStop& > 0 Then
    dbin.dArrayLength = 2: dbin.dFormat = CF_LONG
    dbinbuf(0) = ArchiveStart&: dbinbuf(1) = ArchiveStop&
    rc = T_EXECLINK(server, kwd, dbout, bKeywordNames(0), dbin, dbinbuf(0), CA_READ, 1000)
  Else
    dbin.dArrayLength = 0: dbin.dFormat = CF_NULL
    rc = T_EXECLINK(server, kwd, dbout, bKeywordNames(0), dbin, 0, CA_READ, 1000)
  End If
  
    ' if NAM prop BIGGER than PROP!
    tmpNameSize% = UBound(keywordNames) - LBound(keywordNames) + 1
    If size > tmpNameSize% Then
        MsgBox "Property/Name size Mismatch!  Keyword: " + kwd
        size = tmpNameSize%
    End If
Else
  size = UBound(keywordNames) - LBound(keywordNames) + 1
End If

If size = 8000 Then size = 1 ' force extra archive servers to register names
For i% = 0 To size - 1
  If rc Then
    keywordNames(i%) = "#" + Trim(STR(i%))
  Else
    tmpstr$ = BSTR(bKeywordNames(i%).nam)
    If tmpstr$ = "" Then
        Exit For
    Else
        keywordNames(i%) = tmpstr$ 'BSTR(bKeywordNames(i%).nam)
    End If
  End If
Next
getKeywordNames = size
End Function

Sub getKeywordInfo(server As String, keyword As String, minimum As Single, maximum As Single, _
                   egu As String, plot As String, desc As String, size As Integer, DataType As String)
Dim rc%, fmt%, ptype As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim prp As PropertyQuery
Dim denom As Single
Dim bkwd(32) As Byte

If DataType <> "" Then Exit Sub ' already done
rc% = GetEquipmentExtEGU(server, keyword, minimum, maximum, egu, ptype)
If rc% Then Exit Sub
denom = Abs(minimum)
If denom = 0 Then denom = 1
Select Case ptype
  Case 0: plot = "LIN"
  Case 1: plot = "LOG"
  Case 2: plot = "SLOG"
  Case 3: plot = "TD"
  Case 4: plot = "BITS"
  Case 5: plot = "TEXT"
  Case 6: plot = "ABS"
  Case Else: plot = "LIN"
End Select

dbin.dArrayLength = 1: dbin.dFormat = CF_NAME32
BARR bkwd(), keyword$
dbout.dArrayLength = Len(prp): dbout.dFormat = CF_STRUCT
rc = T_EXECLINK(server, "PROPS", dbout, prp, dbin, bkwd(0), CA_READ, 1000)
desc = BSTR(prp.prpDesc())
size = prp.prpSize
fmt% = prp.prpFormat + 512
Select Case fmt
 Case CF_TEXT: DataType = "NAME32": plot = "LUMI"
 Case CF_NAME32: DataType = "NAME32": plot = "LUMI"
 Case CF_NAME16: DataType = "NAME16": plot = "LUMI"
 Case CF_NAME48: DataType = "NAME48": plot = "LUMI"
 Case CF_FLOAT: DataType = "float"
 Case CF_LONG: DataType = "long"
 Case CF_SHORT: DataType = "short"
 Case CF_DOUBLE: DataType = "double"
 Case Else: DataType = "float"
End Select
End Sub

Sub getALLKeywordInfo(server As String, keyword As String, minimum As Single, maximum As Single, _
                   egu As String, plot As String, desc As String, size As Integer, DataType As String, _
                   ArrayType As Integer, XMax As Single, XMin As Single, XUnits As String)
Dim rc%, fmt%, ptype As Integer
Dim dbout As DBLK
Dim dbin As DBLK
Dim XPrp As XPropertyQuery
Dim denom As Single
Dim bkwd(32) As Byte
Dim tmpMax%
If DataType <> "" Then Exit Sub ' already done
rc% = GetEquipmentExtEGU(server, keyword, minimum, maximum, egu, ptype)
If rc% Then Exit Sub
denom = Abs(minimum)
If denom = 0 Then denom = 1
Select Case ptype
  Case 0: plot = "LIN"
  Case 1: plot = "LOG"
  Case 2: plot = "SLOG"
  Case 3: plot = "TD"
  Case 4: plot = "BITS"
  Case 5: plot = "TEXT"
  Case 6: plot = "ABS"
  Case Else: plot = "LIN"
End Select

' GetFullPropertyInformation(devName As String, property As String, prp As XPropertyQuery)
Call GetFullPropertyInformation(server, keyword, XPrp)

'dbin.dArrayLength = 1: dbin.dFormat = CF_NAME32
'BARR bkwd(), keyword$
'dbout.dArrayLength = Len(prp): dbout.dFormat = CF_STRUCT
'rc = T_EXECLINK(server, "PROPS", dbout, prp, dbin, bkwd(0), CA_READ, 1000)

With XPrp
    desc = BSTR(.prpDesc())
    tmpMax% = 30000
    If .prpSize < tmpMax% Then
        size = .prpSize
    Else
        size = tmpMax%
    End If
    ' IF an array, a SPECTRUM or a SCALAR...
    ArrayType = .prpArrayType
    XMax = .rangeMaxValue
    XMin = .rangeMinValue
    XUnits = .rangeUnits
    
    fmt% = .prpFormat + 512
End With

Select Case fmt
 Case CF_TEXT: DataType = "NAME32": plot = "LUMI"
 Case CF_NAME32: DataType = "NAME32": plot = "LUMI"
 Case CF_NAME16: DataType = "NAME16": plot = "LUMI"
 Case CF_NAME48: DataType = "NAME48": plot = "LUMI"
 Case CF_FLOAT: DataType = "float"
 Case CF_LONG: DataType = "long"
 Case CF_SHORT: DataType = "short"
 Case CF_DOUBLE: DataType = "double"
 Case Else: DataType = "float"
End Select
End Sub

Sub DrawCaption()
Dim i%, nm$, tmpIndex%, idx%, TmpText$, TmpDNameIndex%

'ArchiveForm.FrameMisc(0).Visible = True
'ArchiveForm.FrameMisc(1).Visible = False

' Clear everything first....
'For i% = ActivePlot% * CopyOffset To ActivePlot% * CopyOffset + MaxPlots - 1
'    ArchiveForm.dunit(i%).Caption = ""
'    ArchiveForm.dnam(i%).Caption = ""
'    ArchiveForm.dhelp(i%).Caption = ""
'    ArchiveForm.dlab(i%).Caption = ""
'    'ArchiveForm.dNow(i%).Caption = ""
'    ArchiveForm.dhelp(i%).ToolTipText = ""
'
'    'ArchiveForm.dhelp(i%).AutoSize = False
'    'ArchiveForm.dhelp(i%).WordWrap = False
'Next i%

'If SelectedTrace%(ActivePlot%) <> -1 Then
'    TmpDNameIndex% = IndexToDName%(SelectedTrace%(ActivePlot%))
'    'ArchiveForm.dhelp(TmpDNameIndex%).AutoSize = True
'ElseIf SelectedPlotArrayTrace% <> -1 Then
'    TmpDNameIndex% = SelectedPlotArrayTrace%
'End If
'SelectedPlotArrayTrace%

For i% = ActivePlot% * CopyOffset To ActivePlot% * CopyOffset + MaxPlots - 1
    With FSlct(i%)
        tmpIndex% = IndexToDName%(i%)
        If .Active = True Then
            ArchiveForm.dlab(tmpIndex%).ForeColor = .DispColor
            ArchiveForm.dunit(tmpIndex%).ForeColor = .DispColor
            'ArchiveForm.dNow(tmpIndex%).ForeColor = FSlct(i%).DispColor
          
            nm$ = .PropName
            If nm$ = "H1LUMI" Then
                If .DeviceIndex = 5 Then
                    ArchiveForm.dunit(tmpIndex%).Caption = "E+31"
                ElseIf .DeviceIndex = 6 Then
                    ArchiveForm.dunit(tmpIndex%).Caption = "E+30"
                ElseIf .DeviceIndex = 3 Then
                    ArchiveForm.dunit(tmpIndex%).Caption = "kHz"
                End If
            Else
                ArchiveForm.dunit(tmpIndex%).Caption = .VUnit
            End If
            idx% = .PListIndex
            If .PropSize > 1 Then
                nm$ = nm$ + "[" + Format$(.DeviceIndex, "###0") + "]"
            End If
            If (UCase$(.VPlot) = "TD") Or (UCase$(.VPlot) = "T.D.") Or (UCase$(.VPlot) = "BIT") Or (UCase$(.VPlot) = "BITS") Then
                nm$ = nm$ + "(" + Format$(.DeviceSubIndex - 1, "###0") + ")"
            End If
        
            ArchiveForm.dnam(tmpIndex%).ForeColor = .DispColor
            ArchiveForm.dnam(tmpIndex%).Caption = nm$
            
            ArchiveForm.dhelp(tmpIndex%).ForeColor = .DispColor
            If .NPropDevices > 1 Then
                If InStr(1, .deviceName, "#") <> 0 Then
                    TmpText$ = .PropDesc + " [" + Trim(STR$(.DeviceIndex)) + "]"
                Else
                    TmpText$ = .PropDesc + " [" + .deviceName + "]"
                End If
            Else
                TmpText$ = .PropDesc
            End If
            If .VPlot = "BIT" Then
                TmpText$ = TmpText$ + " (Bit" + STR$(.DeviceSubIndex - 1) + ")"
            End If
            
            If ArchiveForm.dhelp(tmpIndex%).Caption <> TmpText$ Then
                ArchiveForm.dhelp(tmpIndex%).Caption = TmpText$
            End If
            
            'ArchiveForm.dhelp(tmpIndex%).Caption = tmpText$
            ArchiveForm.dhelp(tmpIndex%).ToolTipText = TmpText$
        
        Else
'            ArchiveForm.dunit(tmpIndex%).Caption = ""
'            ArchiveForm.dnam(tmpIndex%).Caption = ""
'            ArchiveForm.dhelp(tmpIndex%).Caption = ""
'            ArchiveForm.dlab(tmpIndex%).Caption = ""
'            'ArchiveForm.dNow(tmpIndex%).Caption = ""
'            ArchiveForm.dhelp(tmpIndex%).ToolTipText = ""
        End If
     End With
Next i%

End Sub

Function filerArchiveData(d As Long) As Integer
Dim i%, j%
Dim iStart As Integer, iStop As Integer
Dim latched As Boolean
Dim foundCnt As Integer

If nFilterKeywords = 0 Then
  filerArchiveData = 0
  Exit Function
End If
For j% = 0 To nFilterKeywords - 1
  If foundCnt < j% Then Exit For
  If filterKeywords(j%).fmt = "NAME32" Then
  ' latch timestamp
    If filterDataBufferNPoints&(j%) = 0 Then
      filerArchiveData = 0
      Exit Function
    End If
    iStart = 0: iStop = filterDataBufferNPoints&(j%) - 1
    While Not ((latched) Or (iStop = iStart) Or (iStop = iStart + 1))
      i% = iStart + ((iStop - iStart) / 2)
      If filterTextBuffer(i%, j%).iVal < d Then
        iStart = i%
      ElseIf filterTextBuffer(i%, j%).iVal > d Then
        iStop = i%
      ElseIf filterTextBuffer(i%, j%).iVal = d Then
        latched = True
      End If
    Wend
    If UCase(filterKeywords(j%).plot) = UCase(BSTR(filterTextBuffer(i%, j%).nam)) Then
      foundCnt = foundCnt + 1
'      filerArchiveData = 1
'      Exit Function
    End If
  Else
  ' latch timestamp
    If filterDataBufferNPoints&(j%) = 0 Then
      filerArchiveData = 0
      Exit Function
    End If
    iStart = 0: iStop = filterDataBufferNPoints&(j%) - 1
    While Not ((latched) Or (iStop = iStart) Or (iStop = iStart + 1))
      i% = iStart + ((iStop - iStart) / 2)
      If filterDataBuffer(i%, j%).iVal < d Then
        iStart = i%
      ElseIf filterDataBuffer(i%, j%).iVal > d Then
        iStop = i%
      ElseIf filterDataBuffer(i%, j%).iVal = d Then
        latched = True
      End If
    Wend
    If filterDataBuffer(i%, j%).fval >= filterKeywords(j%).min And _
       filterDataBuffer(i%, j%).fval <= filterKeywords(j%).max Then
      foundCnt = foundCnt + 1
'      filerArchiveData = 1
'      Exit Function
    End If
  End If
Next
If foundCnt = nFilterKeywords Then filerArchiveData = 1 Else filerArchiveData = 0
End Function

Sub Main()
ArchiveForm.Show
End Sub
Sub DrawCorr()
Dim n%, ii%, n2%, rc%, rcc&
Dim TmpTextX$, TmpTextY$
Dim tmpIndex%

On Error Resume Next

tmpIndex% = ActivePlot%

'TmpTextX$ = ArchiveForm.LinLog(xIndex)
'TmpTextY$ = ArchiveForm.LinLog(yIndex)
If TmpTextX$ = "LOG" And TmpTextY$ = "LIN" Then
    ArchiveForm.ACOPCorrelate(tmpIndex%).GraphStyle = LOG_LIN
ElseIf TmpTextY$ = "LIN" And TmpTextY$ = "LOG" Then
    ArchiveForm.ACOPCorrelate(tmpIndex%).GraphStyle = LIN_LOG
Else 'If TmpTextY$ = "LIN" And TmpTextY$ = "LIN" Then
    ArchiveForm.ACOPCorrelate(tmpIndex%).GraphStyle = LIN_LIN
End If
 
OptXIndex% = DNameToIndex%(xIndex)
n% = FSlct(OptXIndex%).NumPoints
If n% > 1 Then
    For ii% = 0 To n% - 1
        ydat0!(ii%) = CSng(ArchData(ii% + 1, OptXIndex%).d1val)
        'Debug.Print ArchData(ii% + 1, OptXIndex%).d1val
        
        'ydat0!(ii%) = 0
        ' What about these 10^30? - CAN'T USE BECAUSE OF LUMI!!!
        'If ydat0!(ii%) > 10000000000# Then ydat0!(ii%) = 0
         
         'ydat1(ii%) = ArchData(ii% + 1, TmpXSelect%).d1val
         'xdat0(ii%) = xdat(ii%, TmpXSelect%)
         xdat0&(ii%) = CLng(ArchData(ii% + 1, OptXIndex%).d2Val)
    Next ii%
End If
       
OptYIndex% = DNameToIndex%(yIndex)
n2% = FSlct(OptYIndex%).NumPoints
If n2% > 1 Then
    For ii% = 0 To n2% - 1
        ydat1!(ii%) = CSng(ArchData(ii% + 1, OptYIndex%).d1val)
        
         ' What about these 10^30? - CAN'T USE BECAUSE OF LUMI!!!
         'If ydat1!(ii%) > 10000000000# Then ydat1!(ii%) = 0
        
        'ydat2(ii%) = ArchData(ii% + 1, TmpYSelect%).d1val
        'xdat0(ii%) = xdat(ii%, TmpYSelect%)
        xdat1&(ii%) = CLng(ArchData(ii% + 1, OptYIndex%).d2Val)
    Next ii%

    rc% = INTERP(ydat1!(0), xdat1&(0), n2%, xdat0&(0), n%)
End If

'For ii% = 0 To 1 'n2% - 1
'    Debug.Print ydat1!(ii%)
'Next ii%

' Declare Function INTERP Lib "apc32.dll" (Y!, ty&, ByVal nY%, tx&, ByVal nX%) As Integer
'rc% = INTERP(TmpYData!(1), TmpXData0&(1), PEne(0).ival, TmpXData1&(1), CMFLBunch(0, 2).ival)

If ArchiveForm.ChkChubby.Value = vbChecked Then
    ArchiveForm.ACOPCorrelate(tmpIndex%).DrawWidth = 5
    'ArchiveForm.ACOPCorrelate(tmpIndex%).XExtent = 4
    'ArchiveForm.ACOPCorrelate(tmpIndex%).DisplayMode = Dots
Else
    ArchiveForm.ACOPCorrelate(tmpIndex%).DrawWidth = 1
End If
ArchiveForm.ACOPCorrelate(tmpIndex%).ClearScreen
ArchiveForm.ACOPCorrelate(tmpIndex%).ForeColor = BLACK 'FSlct(TmpYSelect%).DispColor
rcc& = ArchiveForm.ACOPCorrelate(tmpIndex%).Draw(ydat1, ydat0, , , n%)

If ArchiveForm.ChkAuto(0).Value = vbChecked Or ArchiveForm.ChkAuto(2).Value = vbChecked Then
    ArchiveForm.ACOPCorrelate(tmpIndex%).AutoScale True, True, True, True
Else
    ArchiveForm.ACOPCorrelate(tmpIndex%).AutoScale False, False, False, False
    ArchiveForm.ACOPCorrelate(tmpIndex%).XMax = FSlct(OptXIndex%).PlotMaxValue
    ArchiveForm.ACOPCorrelate(tmpIndex%).XMin = FSlct(OptXIndex%).PlotMinValue
    ArchiveForm.ACOPCorrelate(tmpIndex%).ymax = FSlct(OptYIndex%).PlotMaxValue
    ArchiveForm.ACOPCorrelate(tmpIndex%).ymin = FSlct(OptYIndex%).PlotMinValue
End If

ArchiveForm.ACOPCorrelate(tmpIndex%).XAxisLabel = ArchiveForm.dnam(xIndex) + "  (" + FSlct(OptXIndex%).VUnit + ") "
ArchiveForm.ACOPCorrelate(tmpIndex%).YAxisLabel = ArchiveForm.dnam(yIndex) + "  (" + FSlct(OptYIndex%).VUnit + ") "
    
End Sub

Sub INTERP1(X() As Long, Y() As Single, n As Integer, _
    xr() As Long, yr() As Single, M As Integer)
    
    'calculates (interpolates) yr based on x,y at xr

Dim i1 As Integer
Dim i As Integer
Dim j As Integer
Dim a As Double
Dim B As Double
Dim denom As Single

'Debug.Print n, M
For j = 0 To M - 1
    i1 = n
    For i = 0 To n - 1
        If X(i) > xr(j) Then
            i1 = i
            Exit For
        End If
    Next i
    
    If i1 = 0 Then i1 = 1
    If i1 = n Then i1 = n - 1
    
    denom = (X(i1) - X(i1 - 1))
    If denom = 0 Then denom = 0.001
    B = (Y(i1) - Y(i1 - 1)) / denom
    a = Y(i1) - B * X(i1)
 '   Debug.Print a, b, i1
    yr(j) = a + B * xr(j)

Next j

End Sub

Public Sub RemoveTrace(tmpIndex As Integer)
Dim i%, TmpPosition%, TmpCount%, StartLabel%, StopLabel%

' -10: delete EVERYTHING

'Index is the fslct array index...
If tmpIndex = -1 Then Exit Sub
If NPlots%(ActivePlot%) <= 0 Then Exit Sub

SelectedPlotArrayTrace% = -1
If ArchiveForm.ChkDouble(4).Value = vbChecked Then
    ArchiveForm.ACOPPlot(2).ClearScreen
End If

StartLabel% = ActivePlot% * CopyOffset
StopLabel% = ActivePlot% * CopyOffset + MaxPlots - 1
For i% = StartLabel% To StopLabel%
    ArchiveForm.dnam(i%).BorderStyle = 0
Next i%

If tmpIndex% = -10 Then
    ArchiveForm.ACOPPlot(ActivePlot%).LockScreen 0
    ArchiveForm.ACOPPlot(ActivePlot%).ClearScreen

    For i% = StartLabel% To StopLabel%
        FSlct(i%).Active = False
    Next i%
    'For i% = 0 To MaxPlots - 1
    '    FSlct(i%).ACOPPlotIndex = -1
    'Next i%
Else
    ArchiveForm.ACOPPlot(ActivePlot%).LockScreen 0, FSlct(tmpIndex).ACOPPlotIndex
    If SelectedTrace%(ActivePlot%) > -1 Then ArchiveForm.ACOPPlot(ActivePlot%).LockScreen 0, SelectedTracePlotIndex&(ActivePlot%)
    ArchiveForm.ACOPPlot(ActivePlot%).ClearScreen FSlct(tmpIndex).ACOPPlotIndex, 0

    FSlct(tmpIndex).Active = False
    ArchiveForm.ACOPPlot(ActivePlot%).ClearScreen
    FSlct(tmpIndex).ACOPPlotIndex = -1

    For i% = 0 To MaxPlots - 1
        If FSlct(i%).Active Then ArchiveForm.ACOPPlot(ActivePlot%).RecallScreen FSlct(i%).ACOPPlotIndex
    Next i%
End If


' Can ONLY REMOVE SELECTED TRACE!!!
SelectedTrace%(ActivePlot%) = -1

'' Be sure array-plot is not elected?
'ArchiveForm.ChkDouble(4).Value = 0

StartUp% = 1
' Correlation-Plot Stuff
If tmpIndex% = -10 Then
    For i% = StartLabel% To StopLabel%
        'FSlct(i%).Active = False
        ArchiveForm.OptX(i%).Value = False
        ArchiveForm.OptY(i%).Value = False
    Next i%
    ArchiveForm.ACOPCorrelate(0).ClearScreen
    ArchiveForm.ACOPCorrelate(0).XAxisLabel = ""
    ArchiveForm.ACOPCorrelate(0).YAxisLabel = ""
Else
    ' Change the pointers for all captions AFTER the one removed...
    TmpPosition% = IndexToDName%(tmpIndex)
    If ArchiveForm.OptX(TmpPosition%).Value = True Then
        ArchiveForm.OptX(TmpPosition%).Value = False
        ArchiveForm.ACOPCorrelate(0).XAxisLabel = ""
        ArchiveForm.ACOPCorrelate(0).ClearScreen
    End If
    If ArchiveForm.OptY(TmpPosition%).Value = True Then
        ArchiveForm.OptY(TmpPosition%).Value = False
        ArchiveForm.ACOPCorrelate(0).YAxisLabel = ""
        ArchiveForm.ACOPCorrelate(0).ClearScreen
    End If
    
    For i% = StartLabel% To StopLabel%
        If (FSlct(i%).Active = True) Then
            If IndexToDName%(i%) > TmpPosition% Then
                ' For this index, the previous DName-Label
                IndexToDName%(i%) = IndexToDName%(i%) - 1
                ' For this DName-Label, this index...
                DNameToIndex%(IndexToDName%(i%)) = i%
            End If
        
            If IndexToDName%(i%) >= TmpPosition% Then
                tmpIndex% = IndexToDName%(i%)
                ArchiveForm.dlab(tmpIndex%).Caption = ArchiveForm.dlab(tmpIndex% + 1).Caption
            End If
        
        Else
'            ArchiveForm.dunit(i%).Caption = ""
'            ArchiveForm.dnam(i%).Caption = ""
'            ArchiveForm.dhelp(i%).Caption = ""
'            ArchiveForm.dlab(i%).Caption = ""
'            ArchiveForm.dNow(i%).Caption = ""
'            ArchiveForm.dhelp(i%).ToolTipText = ""
        End If
    Next i%
End If

If tmpIndex% = -10 Then
    NPlots%(ActivePlot%) = 0
Else
    NPlots%(ActivePlot%) = NPlots%(ActivePlot%) - 1
End If
TmpCount% = NPlots%(ActivePlot%)
If ActivePlot% = 1 Then TmpCount% = TmpCount% + CopyOffset

If tmpIndex% <> -10 Then
    ' Move the TEXT up....
    For i% = TmpPosition% To TmpCount% - 1
        'ArchiveForm.Text1(i%).text = ArchiveForm.Text1(i% + 1).text
        
        ArchiveForm.OptX(i%).Value = ArchiveForm.OptX(i% + 1).Value
        ArchiveForm.OptY(i%).Value = ArchiveForm.OptY(i% + 1).Value
        'ArchiveForm.dlab(i%).Width = ArchiveForm.dlab(i% + 1).Width ' WHY WIDTH?
        ArchiveForm.dlab(i%).Caption = ArchiveForm.dlab(i% + 1).Caption
    Next i%
    For i% = TmpCount% To StopLabel%
        'ArchiveForm.Text1(i%).text = ""
        ArchiveForm.OptX(i%).Visible = False
        ArchiveForm.OptY(i%).Visible = False
        DNameToIndex%(i%) = -1
    
    
        ArchiveForm.dunit(i%).Caption = ""
        ArchiveForm.dnam(i%).Caption = ""
        ArchiveForm.dhelp(i%).Caption = ""
        ArchiveForm.dlab(i%).Caption = ""
        ArchiveForm.dNow(i%).Caption = ""
        ArchiveForm.dhelp(i%).ToolTipText = ""
    Next i%
Else
    ' CLEAR the text
    For i% = TmpCount% To StopLabel%
        'ArchiveForm.Text1(i%).text = ""
        ArchiveForm.OptX(i%).Visible = False
        ArchiveForm.OptY(i%).Visible = False
        DNameToIndex%(i%) = -1
    
        ArchiveForm.dunit(i%).Caption = ""
        ArchiveForm.dnam(i%).Caption = ""
        ArchiveForm.dhelp(i%).Caption = ""
        ArchiveForm.dlab(i%).Caption = ""
        ArchiveForm.dNow(i%).Caption = ""
        ArchiveForm.dhelp(i%).ToolTipText = ""
    Next i%
End If



' And disable all the buttons and stuff...
For i% = 0 To 3
    ArchiveForm.ComSelect(i%).Enabled = False
Next i%

ArchiveForm.ChkAuto(1).Enabled = False
'ArchiveForm.ChkDouble(4).Visible = False

StartUp% = 0

' "Absolute" Scale: need to re-draw.
Call PlotTheData(0)
'Call DrawCaption

DoEvents

Exit Sub


'
'
'
'For i% = Index% To NPlots% - 2 Step 1
'  fslct(i%).PropName = fslct(i% + 1).PropName
'
'  fslct(i%).fecNo = fslct(i% + 1).fecNo
'  fslct(i%).pNo = fslct(i% + 1).pNo
'  fslct(i%).DeviceIndex = fslct(i% + 1).DeviceIndex
'  fslct(i%).PListIndex = fslct(i% + 1).PListIndex
'  fslct(i%).helpText = fslct(i% + 1).helpText
'
'  fslct(i%).VMax = fslct(i% + 1).VMax
'  fslct(i%).VMin = fslct(i% + 1).VMin
'  fslct(i%).VScale = fslct(i% + 1).VScale
'  fslct(i%).VUnit = fslct(i% + 1).VUnit
'  fslct(i%).VPlot = fslct(i% + 1).VPlot
'  fslct(i%).npoints = fslct(i% + 1).npoints
'  fslct(i%).DrawWidth = fslct(i% + 1).DrawWidth
'  ArchiveForm.Faktor(i%).text = ArchiveForm.Faktor(i% + 1).text
'
'  n% = fslct(i%).npoints%
'
'    If n% > 1 Then
'        For ii% = 0 To n% - 1
'           'ltim(ii%, i%) = ltim(ii%, i% + 1)
'           'fdat(ii%, i%) = fdat(ii%, i% + 1)
'            ArchData(ii%, i%).d1val = ArchData(ii%, i% + 1).d1val
'            ArchData(ii%, i%).ival = ArchData(ii%, i% + 1).ival
'        Next ii%
'    End If
'Next
'
'NPlots% = NPlots% - 1

End Sub

Public Sub SelectATrace(dataIndex%)
Dim i%, TmpDNameIndex%, tmpIndex%, TmpTxtMin$, TmpTxtMax$, TmpTxtOffset$, TmpText$
Dim tmpNPoints%

On Error Resume Next

If dataIndex% = -1 Then
    Exit Sub
End If

' need to do this here?
ArrayPlotIndex& = -1

' May need to replotted (with dots...)
If (SelectedTrace%(ActivePlot%) <> -1) Then
    ArchiveForm.dnam(IndexToDName%(SelectedTrace%(ActivePlot%))).BorderStyle = 0
    
    If FSlct(SelectedTrace%(ActivePlot%)).NumPoints > 1 Then
'LOCK        ArchiveForm.ACOPPlot(ActivePlot%).LockScreen 0, SelectedTracePlotIndex&(ActivePlot%)
        ArchiveForm.ACOPPlot(ActivePlot%).ClearScreen SelectedTracePlotIndex&(ActivePlot%)
    End If

'    If (ArchiveForm.ChkDouble(4).Value = 1) And (FSlct(SelectedTrace%(ActivePlot%)).PropSize = 1) Then
'        ' Array mode has been selected... MUST DE-SELECT....
'        ArchiveForm.ChkDouble(4).Value = 0
'    End If
End If

SelectedTrace%(ActivePlot%) = dataIndex%
SelectedPlotArrayTrace% = dataIndex%

TmpDNameIndex% = IndexToDName%(dataIndex)
ArchiveForm.dnam(TmpDNameIndex%).BorderStyle = 1
'ArchiveForm.dhelp(TmpDNameIndex%).AutoSize = False
'ArchiveForm.dhelp(TmpDNameIndex%).WordWrap = False

'ArchiveForm.dhelp(TmpDNameIndex%).ZOrder 0

'For i% = 0 To 6
'    ArchiveForm.dhelp(i%).ZOrder 1
'Next i%
'ArchiveForm.dhelp(TmpDNameIndex%).ZOrder 0

For i% = 0 To 2
    ArchiveForm.TxtSelect(i%).Enabled = True
    ArchiveForm.TxtSelect(i%).BackColor = &HE0E0E0
Next i%

tmpIndex% = SelectedTrace%(ActivePlot%)

ArchiveForm.FrameSelect.Caption = "Selected Trace: #" + Format$(tmpIndex%, "0")

With FSlct(tmpIndex%)
    StartUp% = 1
    If .PlotAutoScale Then ArchiveForm.ChkAuto(1).Value = vbChecked Else ArchiveForm.ChkAuto(1).Value = vbUnchecked
    
    ArchiveForm.ComboSelect(0).Enabled = True
    
    ' Log or Linear?
    'ArchiveForm.ComboSelect.text = FSlct(tmpIndex%).SelectedVMode
    ArchiveForm.ComboSelect(0).ListIndex = .SelectedVModeIndex
    StartUp% = 0
    
    If .PlotMinValue = 0 Then
        TmpTxtMin$ = Format(.PlotMinValue, "0.0") '"0.0"
    ElseIf Abs(.PlotMinValue) < 0.01 Or Abs(.PlotMinValue) > 1000 Then
        TmpTxtMin$ = Format(.PlotMinValue, "scientific")
    Else
        TmpTxtMin$ = Format(.PlotMinValue, "###0.00##") '"standard")
    End If
    
    If .PlotMaxValue = 0 Then
        TmpTxtMax$ = Format(.PlotMaxValue, "0.0") '"0.0"
    ElseIf Abs(.PlotMaxValue) < 0.01 Or Abs(.PlotMaxValue) > 1000 Then
        TmpTxtMax$ = Format(.PlotMaxValue, "scientific")
    Else
        TmpTxtMax$ = Format(.PlotMaxValue, "###0.00##") '"standard")
    End If
    
    If .PlotOffset = 0 Then
        TmpTxtOffset$ = Format(.PlotOffset, "0.0") '"0.0"
    ElseIf Abs(.PlotOffset) < 0.01 Or Abs(.PlotOffset) > 1000 Then
        TmpTxtOffset$ = Format(.PlotOffset, "scientific")
    Else
        TmpTxtOffset$ = Format(.PlotOffset, "###0.00##") '"standard")
    End If
    
    
    If .TotalPoints > 1000000# Then
        TmpText$ = Format$(.NumPoints, "0") + "/" + Format$(.TotalPoints, "0")
    Else
        TmpText$ = Format$(.NumPoints, "0") + " / " + Format$(.TotalPoints, "0")
    End If
    ArchiveForm.LabelPoints(0) = TmpText$
    ArchiveForm.LabelPoints(1) = Format$(.NumPoints, "0")
    ArchiveForm.LabelMisc(2).Visible = True
    
    ' If local history, and there is an archive server, then...
    'If Not (.ArchiveSourceFlag) And .ArchiveDataServer <> "" Then
    If Not (.ArchiveSourceFlag) And .TotalArchPoints > -1 Then
        ArchiveForm.LabelPoints(2).Visible = True
        ArchiveForm.LabelPoints(3).Visible = True
    
        'If .TotalLHPoints > 1000000# Then
            TmpText$ = "L.Hist: " + Format$(.TotalLHPoints, "0")
        'Else
        '    TmpText$ = Format$(.NumPoints, "0") + " / " + Format$(.TotalPoints, "0")
        'End If
        ArchiveForm.LabelPoints(2) = TmpText$
        TmpText$ = "C.Arch: " + Format$(.TotalArchPoints, "0")
        ArchiveForm.LabelPoints(3) = TmpText$
    Else
        ArchiveForm.LabelPoints(2).Visible = False
        ArchiveForm.LabelPoints(3).Visible = False
    End If
    
    StartUp% = 1
    ArchiveForm.TxtSelect(0).text = TmpTxtMin$ ' Min
    ArchiveForm.TxtSelect(1).text = TmpTxtMax$ ' Max
    ArchiveForm.TxtSelect(2).text = TmpTxtOffset$ ' Offset
    StartUp% = 0
    
    If FSlct(SelectedTrace%(ActivePlot%)).NumPoints > 1 Then
        ArchiveForm.ACOPPlot(ActivePlot%).ForeColor = FSlct(dataIndex%).DispColor
        ArchiveForm.ACOPPlot(ActivePlot%).DrawWidth = 3 * ChubbyFactor! / 2 + 2
        ' Use the selected type:
        If ACOPDefaultMode& = Dots Then
            ArchiveForm.ACOPPlot(ActivePlot%).DisplayMode = PolyLine
        Else
            ArchiveForm.ACOPPlot(ActivePlot%).DisplayMode = Dots
        End If
        
        If ACOPDefaultMode& = Dots Then
            ArchiveForm.ACOPPlot(ActivePlot%).DrawWidth = 1 * ChubbyFactor! + 1 + ACOPDefaultWidth&
        ElseIf ACOPDefaultMode& = PolyLineDots Or ACOPDefaultMode& = BarLineDots Then
            ArchiveForm.ACOPPlot(ActivePlot%).DrawWidth = 1 * ChubbyFactor! + 5 + ACOPDefaultWidth&
        Else
            ArchiveForm.ACOPPlot(ActivePlot%).DrawWidth = 1 * ChubbyFactor! + 3 + ACOPDefaultWidth&
        End If
        tmpNPoints% = FSlct(SelectedTrace%(ActivePlot%)).NumPoints
        SelectedTracePlotIndex&(ActivePlot%) = ArchiveForm.ACOPPlot(ActivePlot%).Draw(PlotData(0, dataIndex%).d1val, PlotData(0, dataIndex%).d2Val, , , tmpNPoints%, "DBLDBL")
    'LOCK    ArchiveForm.ACOPPlot(ActivePlot%).LockScreen 1, SelectedTracePlotIndex&(ActivePlot%)
    End If
    
    'For i% = 0 To 3
    '    ArchiveForm.ComSelect(i%).Enabled = False
    'Next i%
    If ScalingMode% = RelativeScale Then
        ArchiveForm.ChkAuto(1).Visible = True
    Else
        ArchiveForm.ChkAuto(1).Visible = False
    End If
    
    ArchiveForm.ChkAuto(1).Enabled = True
    
    ' Need to allow array plotting?
    
    If FSlct(SelectedTrace%(ActivePlot%)).PropSize > 1 Then
        ' should this check-box be displayed?
        If ArchiveForm.MExtraDisplay.Checked = True Then
        'If ArchiveForm.ChkDouble(1).Visible = True Then
            ArchiveForm.TxtSelect(2).Visible = False
            ArchiveForm.LabelSelect(2).Visible = False
        Else
        End If
                
        'ArchiveForm.ChkDouble(4).Visible = True
        
        ' is there already a TS selected?
        KinoFrames% = FSlct(SelectedTrace%(ActivePlot%)).NumPoints
        KinoIndex% = 0
        If ArchiveTS& > 0 Then
            For i% = 2 To KinoFrames%
                If ArchiveTS& < CLng(ArchData(i%, SelectedTrace%(ActivePlot%)).d2Val) Then
                    KinoIndex% = i%
                    Exit For
                End If
            Next i%
        End If
        If KinoIndex% = 0 Then KinoIndex% = KinoFrames% / 2
        
        ArchiveTS& = CLng(ArchData(KinoIndex%, SelectedTrace%(ActivePlot%)).d2Val)
        'KinoIndex% = 1
        ArchiveForm.TextTS.text = STR$(KinoIndex%)
        
        StartingUp = True
        ArchiveForm.HScrollTS.max = KinoFrames%
        StartingUp = False
    
        If ArchiveForm.ChkDouble(4).Value = 1 Then Call DoTheArrayData
    Else
        'ArchiveForm.ChkDouble(4).Visible = False
    End If
End With

End Sub


Public Sub GetHTCStuff(CurrIndex%)
                    
Dim TmpStartStop&(3), TmpBunches%(220), TmpI%, BunchData(MaxPoints, 9) As FLTINT, NBunchPoints%(9)
Dim i%, n%, ii%, rcc&, TmpNBunches%, BIndex%(10), BtoDataIndex%(220), HTC_Index%
Dim BTS&, BTSIndex%, Bunch%, BDataIndex%
Dim TmpHTCIndex%(MaxPoints - 1), tmpNPoints%
TmpStartStop&(0) = ArchiveStart&
TmpStartStop&(1) = ArchiveStop&
                    
' Find out which data has the HTC-Bunch number....
' (Don't bother to AUTOMATICALLY load it....)
HTC_Index% = -1
For i% = 0 To MaxCurves - 1
    If FSlct(i%).PropName = "HE_HTC_BUNCH" Then
        HTC_Index% = i%
        Exit For
    End If
Next i%
If HTC_Index% = -1 Then
    MsgBox "HTC-Bunch Not Found!"
    FSlct(CurrIndex%).NumPoints = 0
    Exit Sub
End If
'Debug.Print " HE_HTC_BUNCH Index: ", HTC_Index%

' Loop through the data from the "HE_HTC_BUNCH" property, and find
' out WHICH BUNCHES WERE USED....
tmpNPoints% = FSlct(CurrIndex%).NumPoints
If tmpNPoints% = 0 Then
    TmpNBunches% = 0
Else
    Erase TmpBunches%
    For i% = 0 To tmpNPoints% - 1
        ' Because the -1 gets read-back as 65535....
        If (ArchData(i%, HTC_Index%).d1val < 0) Or (ArchData(i%, HTC_Index%).d1val > 219) Then
            ' A bug? have gotten 65535 as bunch number....
            Debug.Print " Hit-Bunch: ", ArchData(i%, HTC_Index%).d1val
            'ArchData(i%, HTC_Index%).d1val = 0
            TmpHTCIndex%(i%) = 0
        Else
            TmpI% = CInt(ArchData(i%, HTC_Index%).d1val) - 1
            TmpBunches%(TmpI%) = TmpBunches%(TmpI%) + 1
            TmpHTCIndex%(i%) = TmpI%
        End If
        'If Not (TmpI% < 0 Or TmpI% > 219) Then TmpBunches%(TmpI%) = TmpBunches%(TmpI%) + 1
        'Debug.Print " HE_HTC_BUNCH Search ", TmpI%
    Next i%

    TmpI% = 0
    ' Get the data for ALL BUNCHES which have been "selected"....
    ArchiveForm.ACOPData.deviceProperty = FSlct(CurrIndex%).PropName
    For i% = 0 To 219
        If TmpBunches%(i%) > 0 Then
            BIndex%(TmpI%) = i%
            TmpStartStop&(2) = i%
            rcc& = ArchiveForm.ACOPData.Execute(BunchData(0, TmpI%).fval, MaxPoints, "FLTINT", TmpStartStop)
            ArchiveForm.ACOPData.GetDataSize NBunchPoints%(TmpI%)
            
            BtoDataIndex%(i%) = TmpI%
            ' Check if enough data....
            TmpI% = TmpI% + 1
            If TmpI% > 9 Then
                MsgBox " Only 10 Bunch-Currents collected!"
                Exit For
            End If
        Else
            BtoDataIndex%(i%) = -1
        End If
    Next i%
    If TmpI% = 0 Then
        ' No useful data in the array?
        TmpNBunches% = 0
    Else
        TmpNBunches% = TmpI%
    End If
End If

' How many bunches were used for the HTC?
If TmpNBunches% = 0 Then
    ' No Bunches found? Just get the data for Bunch-0 and return....
    ArchiveForm.ACOPData.deviceProperty = FSlct(CurrIndex%).PropName
    TmpStartStop&(2) = 0
    rcc& = ArchiveForm.ACOPData.Execute(ArchData(0, CurrIndex%).d1val, MaxPoints, "DBLDBL", TmpStartStop)
    ArchiveForm.ACOPData.GetDataSize tmpNPoints%
    FSlct(CurrIndex%).NumPoints = tmpNPoints%
    Exit Sub
End If

' Transfer all the Bunch Data into ONE array....

FSlct(CurrIndex%).NumPoints = NBunchPoints%(TmpI%) 'BunchData(0, 0).iVal

' Get the right starting conditions....
BTSIndex% = 1
'Bunch% = CInt(ArchData(BTSIndex%, HTC_Index%).fval) - 1
'If (Bunch% < 0 Or Bunch% > 219) Then Bunch% = 0
Bunch% = TmpHTCIndex%(BTSIndex%)
BDataIndex% = BtoDataIndex%(Bunch%)
' Set time-stamp to NEXT
BTS& = ArchData(BTSIndex% + 1, HTC_Index%).d2Val

For i% = 0 To NBunchPoints%(TmpI%) - 1 'BunchData(0, 0).iVal - 1
    ' Check each time stamp, to get the current of the right bunch....
    If BunchData(i%, 0).iVal > BTS& Then
        ' Move to the bunch at the NEXT TS....
        BTSIndex% = BTSIndex% + 1
'        If (ArchData(BTSIndex%, HTC_Index%).d1val < 0) Or (ArchData(BTSIndex%, HTC_Index%).d1val > 219) Then
'            ' Kludge: just try to SKIP one?
'            BTSIndex% = BTSIndex% + 1
'            'Bunch% = 0
'            Bunch% = CInt(ArchData(BTSIndex%, HTC_Index%).d1val) - 1
'        Else
'            Bunch% = CInt(ArchData(BTSIndex%, HTC_Index%).d1val) - 1
'        End If
        Bunch% = TmpHTCIndex%(BTSIndex%)
        BDataIndex% = BtoDataIndex%(Bunch%)
        If (BTSIndex% + 1) > ArchData(0, HTC_Index%).d2Val Then
            ' No More Timestamps.... so keep this bunch....
            BTS& = ArchiveStop& + 100
        Else
            BTS& = ArchData(BTSIndex% + 1, HTC_Index%).d2Val
        End If
    End If
    ArchData(i%, CurrIndex%).d1val = CDbl(BunchData(i%, BDataIndex%).fval)
    ArchData(i%, CurrIndex%).d2Val = CDbl(BunchData(i%, 0).iVal)
Next i%

End Sub

Public Sub DrawArray()
Dim rcc&, i%, ii%, TmpStartStop&(3), TempIndex%, TempSize%
Dim Delta!, InvDelta!, ZeroOffset!, tmpFaktor!
Dim ScaleMax!, ScaleMin!, TempDNameIndex%
Dim tmpstr$


ArchiveForm.ACOPPlot(2).ClearScreen


' Draw an ARRAY in the second window...
' Get the data from the SelectedTrace, at the selected Time-Stamp
TempDNameIndex% = IndexToDName%(SelectedTrace%(0))
TempIndex% = SelectedTrace%(0)

TmpStartStop&(0) = ArchiveTS&
TmpStartStop&(1) = 0

' For TD, need also the SubIndex (the BUNCH)
If UCase$(FSlct(TempIndex%).VPlot) = "TD" Then
'    TmpStartStop&(2) = NextSubi% ' the START INDEX of the "property"
'    TmpStartStop&(3) = NTDBunches ' SAMPLE Interval
    
    TmpStartStop&(2) = 0 ' the START INDEX of the "property"
    TmpStartStop&(3) = 1 ' SAMPLE Interval
Else
    TmpStartStop&(2) = 0 ' the START INDEX of the "property"
    TmpStartStop&(3) = 1 ' SAMPLE Interval
End If

TempSize% = FSlct(TempIndex%).PropSize
ArchiveForm.ACOPData.deviceName = FSlct(TempIndex%).ServerName
ArchiveForm.ACOPData.deviceProperty = FSlct(TempIndex%).PropName
rcc& = ArchiveForm.ACOPData.Execute(ArrayData!(0), TempSize%, "SINGLE", TmpStartStop&, 4)

If rcc& = 0 Then ArrayDataSize = TempSize% Else ArrayDataSize = 0
ArrayDataTimeStamp = ArchiveTS&: ArrayDataKeyword = FSlct(TempIndex%).PropName





' Need to scale the data consistent with MainPlot....
ScaleMax! = FSlct(TempIndex%).PlotMaxValue
ScaleMin! = FSlct(TempIndex%).PlotMinValue

' To scale the data properly....
If FSlct(TempIndex%).VPlot = "LOG" Then
    If ScaleMin! <= 0 Then ScaleMin! = 0.01
    If ScaleMax! <= 0 Then ScaleMax! = ScaleMin! * 100000
    Delta! = (Log(ScaleMax!) - Log(ScaleMin!))
    If FSlct(TempIndex%).VMin = 0 Then FSlct(TempIndex%).VMin = 1E-20
    ZeroOffset! = Log(ScaleMin!)
Else
    Delta! = ScaleMax! - ScaleMin!
    ZeroOffset! = ScaleMin!
End If

If Delta! = 0 Then InvDelta! = 1 Else InvDelta! = 100 / Delta!
' Use the scale-factor in the form for the GRAPHICS!
InvDelta! = InvDelta! * 1 'Val(ArchiveForm.Faktor(TempDNameIndex%).text)
            
' Plotting "mode"
If FSlct(TempIndex%).VPlot = "LOG" Then
    For ii% = 0 To TempSize% - 1
        If ArrayData!(ii%) > 0 Then
            PlotArrayData!(ii%) = (Log(ArrayData!(ii%)) - ZeroOffset!) * InvDelta!
        Else
            PlotArrayData!(ii%) = 0
        End If
    Next ii%
ElseIf FSlct(TempIndex%).VPlot = "ABS" Then
    For ii% = 0 To TempSize% - 1
        PlotArrayData!(ii%) = (Abs(ArrayData!(ii%)) - ZeroOffset!) * InvDelta!
    Next ii%
ElseIf FSlct(TempIndex%).VPlot = "SLOG" Then
    tmpFaktor! = 1
    For ii% = 0 To TempSize% - 1
        If PlotArrayData!(ii%) > 0 Then
            ii% = ii%
        End If
        PlotArrayData!(ii%) = (ArrayData!(ii%) * tmpFaktor! - ZeroOffset!) * InvDelta!
    Next ii%
Else
    For ii% = 0 To TempSize% - 1
       PlotArrayData!(ii%) = (ArrayData!(ii%) - ZeroOffset!) * InvDelta!
    Next ii%
End If
                    
If ArchiveForm.OptDisplayArray(0).Value = True Then
    If TempSize% > 100 Then ArchiveForm.ACOPPlot(2).DrawWidth = 1 Else ArchiveForm.ACOPPlot(2).DrawWidth = 3
Else
    ArchiveForm.ACOPPlot(2).DrawWidth = 2
End If

ArchiveForm.ACOPPlot(2).ForeColor = FSlct(TempIndex%).DispColor
ArchiveForm.ACOPPlot(2).Draw PlotArrayData!, , , , TempSize%
ArchiveForm.ACOPPlot(2).XMin = 0
ArchiveForm.ACOPPlot(2).XMax = FSlct(TempIndex%).PropSize

If (ArchiveForm.ChkAuto(0).Value + ArchiveForm.ChkAuto(1).Value + ArchiveForm.ChkAuto(2).Value) > 0 Then
    ArchiveForm.ACOPPlot(2).AutoScale False, False, True, True
Else
    ArchiveForm.ACOPPlot(2).AutoScale False, False, False, False
    ArchiveForm.ACOPPlot(2).ymin = 0
    ArchiveForm.ACOPPlot(2).ymax = 100
End If

Call CTIME(datstr, ArchiveTS&)
tmpstr$ = ArchiveForm.ACOPPlot(0).CTIME(ArchiveTS&)
tmpstr$ = Mid(tmpstr$, 1, Len(tmpstr$) - 2)

ArchiveForm.ACOPPlot(2).ForeColor = BLACK
ArchiveForm.ACOPPlot(2).YAxisLabel = FSlct(TempIndex%).VUnit
ArchiveForm.ACOPPlot(2).XAxisLabel = "Array Index"
ArchiveForm.ACOPPlot(2).Caption = FSlct(TempIndex%).PropName + "  at  " + tmpstr$

'ArchiveForm.tlab(1).Caption = Left(datstr, Len(datstr) - 2) + "   UTC: " + STR$(ArchiveTS&)
ArchiveForm.tlab(1).Caption = datstr + "   UTC: " + STR$(ArchiveTS&)

ArchiveForm.ACOPPlot(ActivePlot%).ClearScreen
'For i% = 0 To MaxPlots% - 1
'    If FSlct(i%).Active Then ArchiveForm.ACOPPlot(0).RecallScreen FSlct(i%).ACOPPlotIndex
'Next i%

ArchiveForm.ACOPPlot(ActivePlot%).DisplayMode = PolyLine
ArchiveForm.ACOPPlot(ActivePlot%).DrawWidth = -3
XCursorArray&(0) = ArchiveTS&
XCursorArray&(1) = ArchiveTS&
ArchiveForm.ACOPPlot(ActivePlot%).ForeColor = BLUE
ArchiveForm.ACOPPlot(ActivePlot%).Draw YCursorArray!(0), XCursorArray&(0), , , 2, "SINGLE"

' Set markers on array plot?
ArchiveForm.ACOPPlot(2).Tagging = True
ArchiveForm.ACOPPlot(2).ClearTags
For i% = ActivePlot% * CopyOffset To ActivePlot% * CopyOffset + MaxPlots - 1
    If FSlct(i%).Active = True Then
        If FSlct(TempIndex%).PropName = FSlct(i%).PropName Then
            'Set a marker
            If FSlct(i%).DispColor = 0 Then
                ArchiveForm.ACOPPlot(2).TagColor = LGREY
            Else
                ArchiveForm.ACOPPlot(2).TagColor = FSlct(i%).DispColor
            End If
            ArchiveForm.ACOPPlot(2).IsTagged FSlct(i%).DeviceIndex, True
        End If
    End If
Next i%

End Sub

Public Sub DrawMarker()
Dim TempX&(1), TempY!(1)

If ArchiveTS& > 0 Then
    ' Draw a marker
    ArchiveForm.ACOPPlot(0).ClearScreen
    ArchiveForm.ACOPPlot(0).DisplayMode = PolyLine
    ArchiveForm.ACOPPlot(0).DrawWidth = 2
    ArchiveForm.ACOPPlot(0).ForeColor = DGREEN
    TempX&(0) = ArrayDataTimeStamp&
    TempX&(1) = TempX&(0)
    
    TempY!(0) = ArchiveForm.ACOPPlot(0).ymin - 100
    TempY!(1) = ArchiveForm.ACOPPlot(0).ymax + 100
    
    MarkerPlotIndex& = ArchiveForm.ACOPPlot(0).Draw(TempY!(0), TempX&(0), , , 2)
    
    ' Draw a REFERENCE marker
    If (ReferenceTS& > 0) And ((ArchiveForm.CheckRef(0).Value + ArchiveForm.CheckRef(1).Value) > 0) Then
        'ACOPPlot(0).ClearScreen
        ArchiveForm.ACOPPlot(0).DisplayMode = PolyLine
        ArchiveForm.ACOPPlot(0).DrawWidth = 2
        ArchiveForm.ACOPPlot(0).ForeColor = BLUE
        TempX&(0) = ReferenceTS&
        TempX&(1) = TempX&(0)
        
        TempY!(0) = ArchiveForm.ACOPPlot(0).ymin - 100
        TempY!(1) = ArchiveForm.ACOPPlot(0).ymax + 100
        
        RefMarkerPlotIndex& = ArchiveForm.ACOPPlot(0).Draw(TempY!(0), TempX&(0), , , 2)
    End If
End If
End Sub

Function getSelectedName(n As Integer) As String
Dim i As Integer
Dim nm$
If n > 15 Then
  getSelectedName = ""
  Exit Function
End If
i = FSlct(n).PListIndex
nm$ = FSlct(n).PropName 'archivedKeywords(i).keyword
If FSlct(n).PropSize > 1 Then
  nm$ = nm$ + "[" + Trim$(STR$(FSlct(n).DeviceIndex)) + "]"
  If FSlct(n).DeviceSubIndex > 0 Then nm$ = nm$ + "[" + Trim$(STR$(FSlct(n).DeviceSubIndex)) + "]"
End If
getSelectedName = nm$
End Function


Public Sub FilterTheData(flag%)
Dim i%, ii%, n%, OKCount%, StartLabel%, StopLabel%

On Error Resume Next

StartLabel% = ActivePlot * CopyOffset
StopLabel% = ActivePlot * CopyOffset + MaxCurves - 1
                                
If flag = 0 Then
    ' refresh everything....
    For i% = StartLabel% To StopLabel%
        If FSlct(i%).Active = True Then
            FSlct(i%).ReFilter = True
        Else
            FSlct(i%).ReFilter = False
        End If
    Next i%
End If
                                
For i% = StartLabel% To StopLabel%
    If FSlct(i%).Active And FSlct(i%).ReFilter = True Then
        n% = FSlct(i%).NumPoints
        
        If FSlct(i%).PropName = "HPFWHM" Then
            ' Bad data from the CMFL FEC....
            For ii% = 1 To n%
                If ArchData(ii%, i%).d1val > 10000# Then ArchData(ii%, i%).d1val = 0
            Next ii%
        ElseIf FSlct(i%).PropName = "H1SLumi" Then
            ' Bad data from H1-Lumi....
            For ii% = 1 To n%
                'If Not (IsNumeric(ArchData(ii%, i%).d1val)) Then ArchData(ii%, i%).d1val = 0
                ArchData(ii%, i%).d1val = Val(ArchData(ii%, i%).d1val)
            Next ii%
        ElseIf FSlct(i%).PropName = "HE_H_HTC_PSC" Or FSlct(i%).PropName = "HE_V_HTC_PSC" Then
            ' Signed Integers read as UNSIGNED...
            For ii% = 1 To n%
                If ArchData(ii%, i%).d1val > 32767 Then ArchData(ii%, i%).d1val = ArchData(ii%, i%).d1val - 65536
            Next ii%
        ElseIf (FSlct(i%).PropName = "TTFAcc2TCoup4KB" And FSlct(i%).DeviceIndex = 4) Or (FSlct(i%).PropName = "TTFAcc1THOM2" And FSlct(i%).DeviceIndex = 2) Then
            ' IS there bad data here?
            ' Not a problem anymore? - just for TTFAcc1THOM(2) on 30.July and TTFAcc2Coup4KB(4) on 31.July
            'For ii% = 1 To n%
            '    If ArchData(ii%, i%).d1val > 10000 Then ArchData(ii%, i%).d1val = 0
            'Next ii%
        ElseIf InStr(1, FSlct(i%).PropName, "L3") <> 0 Then '"L3Que"
            ' IS there bad data here?
            ' Not a problem anymore? - just for TTFAcc1THOM(2) on 30.July and TTFAcc2Coup4KB(4) on 31.July
            OKCount% = 1
            For ii% = 0 To n% - 1
                If ArchData(ii%, i%).d1val < ErrorValue! Then
                    ArchData(OKCount%, i%).d1val = ArchData(ii%, i%).d1val
                    ArchData(OKCount%, i%).d2Val = ArchData(ii%, i%).d2Val
                    OKCount% = OKCount% + 1
                End If
            Next ii%
            n% = OKCount% - 1
            FSlct(i%).NumPoints = n%
        End If
    
        If ArchiveForm.MenuBADData.Checked Then
            OKCount% = 1
            For ii% = 0 To n% - 1
                If ArchData(ii%, i%).d1val < ErrorValue! Then
                    ArchData(OKCount%, i%).d1val = ArchData(ii%, i%).d1val
                    ArchData(OKCount%, i%).d2Val = ArchData(ii%, i%).d2Val
                    OKCount% = OKCount% + 1
                End If
            Next ii%
            n% = OKCount% - 1
            FSlct(i%).NumPoints = n%
        End If
        FSlct(i%).ReFilter = False
        FSlct(i%).RePlot = True
    Else
        ' Nothing to do?
        FSlct(i%).ReFilter = False
    End If
Next i%

End Sub

Public Sub OperateOnTheData(Index%)
Dim i%, ii%, rc%
Dim TmpYData!(MaxPoints), TmpXData0&(MaxPoints), TmpXData1&(MaxPoints), NTmp0%, NTmp1%

' try to do an operation on two of the arrays which are already loaded.....
If Index% < 2 Then
    MsgBox " error in operation! not enough arrays!"
    Exit Sub
End If

' use the time stamps of the last to get the data points for the SECOND-to-LAST....
NTmp0% = FSlct(Index% - 2).NumPoints
For ii% = 0 To NTmp0% - 1
    TmpXData0&(ii%) = CLng(ArchData(ii%, Index% - 2).d2Val)
    TmpYData!(ii%) = CSng(ArchData(ii%, Index% - 2).d1val)
Next ii%

NTmp1% = FSlct(Index% - 1).NumPoints
For ii% = 0 To NTmp1% - 1
    TmpXData1&(ii%) = ArchData(ii%, Index% - 1).d2Val
Next ii%

' Declare Function INTERP Lib "apc32.dll" (Y!, ty&, ByVal nY%, tx&, ByVal nX%) As Integer
rc% = INTERP(TmpYData!(0), TmpXData0&(0), NTmp0%, TmpXData1&(0), NTmp1%)
' assume it is MINUS...
If FSlct(Index%).PropName = OpMinus Then
    If FSlct(Index% - 1).PropName = "HPBunCur" Then
        ' Just so the plot looks good for the proton-current plot....
        For ii% = 0 To FSlct(Index% - 1).NumPoints - 1
            ArchData(ii%, Index%).d2Val = ArchData(ii%, Index% - 1).d2Val
            If TmpYData(ii%) > 5 Then  ' Check how much proton current.....
                ArchData(ii%, Index%).d1val = TmpYData(ii%) - ArchData(ii%, Index% - 1).d1val
            Else
                ArchData(ii%, Index%).d1val = 0
            End If
        Next ii%
    Else
        For ii% = 0 To FSlct(Index% - 1).NumPoints - 1
            ArchData(ii%, Index%).d2Val = ArchData(ii%, Index% - 1).d2Val
            ArchData(ii%, Index%).d1val = TmpYData(ii%) - ArchData(ii%, Index% - 1).d1val
            'Debug.Print ii%, ArchData(ii%, index%).d1val, ArchData(ii%, index% - 1).d1val, TmpYData(ii%)
        Next ii%
    End If
ElseIf FSlct(Index%).PropName = OpPlus Then
    For ii% = 0 To FSlct(Index% - 1).NumPoints - 1
        ArchData(ii%, Index%).d2Val = ArchData(ii%, Index% - 1).d2Val
        ArchData(ii%, Index%).d1val = TmpYData(ii%) + ArchData(ii%, Index% - 1).d1val
    Next ii%
ElseIf FSlct(Index%).PropName = OpMult Then
    For ii% = 0 To FSlct(Index% - 1).NumPoints - 1
        ArchData(ii%, Index%).d2Val = ArchData(ii%, Index% - 1).d2Val
        ArchData(ii%, Index%).d1val = TmpYData(ii%) * ArchData(ii%, Index% - 1).d1val
    Next ii%
ElseIf FSlct(Index%).PropName = OpDiv Then
    If FSlct(Index% - 1).PropName = "D3IBottom" Then
        ' Just so the plot looks good for the proton-current plot....
        For ii% = 0 To FSlct(Index% - 1).NumPoints - 1
            ArchData(ii%, Index%).d2Val = ArchData(ii%, Index% - 1).d2Val
            If (TmpYData(ii%) > 1) And (ArchData(ii%, Index% - 1).d1val <> 0) Then
                ArchData(ii%, Index%).d1val = TmpYData(ii%) / ArchData(ii%, Index% - 1).d1val
            Else
                ArchData(ii%, Index%).d1val = 0
            End If
        Next ii%
    Else
        For ii% = 0 To FSlct(Index% - 1).NumPoints - 1
            ArchData(ii%, Index%).d2Val = ArchData(ii%, Index% - 1).d2Val
            If ArchData(ii%, Index% - 1).d1val <> 0 Then
                ArchData(ii%, Index%).d1val = TmpYData(ii%) / ArchData(ii%, Index% - 1).d1val
            Else
                ArchData(ii%, Index%).d1val = 0
            End If
        Next ii%
    End If
End If
FSlct(Index%).NumPoints = FSlct(Index% - 1).NumPoints
FSlct(Index%).TotalPoints = FSlct(Index% - 1).TotalPoints

' Need the time-bins, too...
For ii% = 0 To FSlct(Index%).NumPoints - 1
    ArchTimeBins#(ii%, Index%) = ArchData(ii%, Index%).d2Val
Next ii%
ArchTimeBins#(0, Index%) = ArchData(1, Index%).d2Val - 100
ArchTimeBins#(FSlct(Index%).NumPoints + 1, Index%) = ArchData(FSlct(Index%).NumPoints, Index%).d2Val + 100

End Sub


Public Sub ReadTheData(flag%)
Dim i%, ii%, j%, k%, kk%, StartLabel%, StopLabel%, MsgRC%, rc%, rcc&
Dim tmpIndex%, tmpSide&, TmpStartStop&(3), tStr$, tmpTotalPoints&, TmpText$
Dim useStringBuffer As Boolean, scratchTotalPoints As FLTINT

On Error GoTo ReadError

StartLabel% = ActivePlot * CopyOffset
StopLabel% = ActivePlot * CopyOffset + MaxCurves - 1


If flag = 0 Then
    ' refresh everything....
    For i% = StartLabel% To StopLabel%
        If FSlct(i%).Active = True Then
            FSlct(i%).Acquire = True
            FSlct(i%).ReFilter = True
            FSlct(i%).ReScale = True
            FSlct(i%).RePlot = True
        Else
            FSlct(i%).Acquire = False
            FSlct(i%).ReFilter = False
            FSlct(i%).ReScale = False
            FSlct(i%).RePlot = False
        End If
        'ArchiveForm.acopplot(0).LockScreen 0, fslct(i%).ACOPPlotIndex
        FSlct(i%).ACOPPlotIndex = -1
    Next
'ElseIf Flag = 1 Then
'    For i% = StartLabel% To StopLabel%
'    '   THIS NEEDS TO BE FIXED !!!! The ArchData() buffer gets reassigned inside the drawing logic to
'    '   accomplish some sort of scaling, etc.  That's why it needs to be reacquired for the autoscale to
'    '   work properly.  The solution is to use a second drawing buffer
'        'If FSlct(i%).Active = True Then FSlct(i%).Acquire = True ' Testing! shouldn't be here - but AUTOSCALE plots wrong without it....
'
'        If FSlct(i%).Active = True Then
'            FSlct(i%).RePlot = True
'        Else
'        End If
'    Next
End If



For i% = StartLabel% To StopLabel%
    With FSlct(i%)
        If .Active And .Acquire = True Then
            If ArchiveForm.MXWindow(1).Checked = True Then
                tmpSide& = 0
            Else
                If NZooms% = 0 Then
                    ' get an extra hour each side.....
                    tmpSide& = 3600
                Else
                    ' What if the data are in ONE SECOND raster - then don't add too much....
                    If .NumPoints > 800 And (ArchiveStop& - ArchiveStart&) < 7200 Then tmpSide& = 100 Else tmpSide& = 1800
                End If
            End If
            
            TmpStartStop&(0) = ArchiveStart& - tmpSide&
            TmpStartStop&(1) = ArchiveStop& + tmpSide&
            
            If ActivePlot% = 1 Then
                ' Don't do anything.... don't need to read data for "copy-buffer"
            ElseIf (.PropName = OpMinus) Or (.PropName = OpPlus) Or (.PropName = OpMult) Or (.PropName = OpDiv) Then
                ' Doing mathematical operations (subtracting coasting beam....)
                Call OperateOnTheData(i%)
            Else
                If .ArchiveSourceFlag = True Then
                    rc% = ReadArchiveData(i%)
                Else
                    rc% = ReadHistoryData(i%)
                End If
                
                If rc% = -10001 Then
                    ' ABORT from the read routine
                    TmpText$ = "ERROR"
                    tmpIndex% = IndexToDName%(i%)
                    .NumPoints = 0
                    'ArchiveForm.Text1(tmpIndex%) = tmpText$
                    Exit Sub
                Else
                End If
                                
                If .NumPoints > 0 Then
                    For ii% = 1 To .NumPoints - 2
                        ArchTimeBins#(ii%, i%) = ArchData(ii%, i%).d2Val + ((ArchData(ii% + 1, i%).d2Val - ArchData(ii%, i%).d2Val)) / 2
                    Next ii%
                    ArchTimeBins#(0, i%) = ArchData(1, i%).d2Val - 100
                    ArchTimeBins#(.NumPoints, i%) = ArchData(.NumPoints - 1, i%).d2Val + 100
                    'ArchTimeBins#(.NumPoints, i%) = ArchData(.NumPoints - 1, i%).d2Val + 100
                Else
                End If
            End If
            
            ' Which row is the data in?
            tmpIndex% = IndexToDName%(i%)
            'ArchiveForm.LinLog(TmpIndex%) = FSlct(i%).VPlot
'            If .TotalPoints > 1000000# Then
'                tmpText$ = Format$(.NumPoints, "0") + "/" + Format$(.TotalPoints, "0")
'            Else
'                tmpText$ = Format$(.NumPoints, "0") + " / " + Format$(.TotalPoints, "0")
'            End If
'            ArchiveForm.Text1(tmpIndex%) = tmpText$
            
            .Acquire = False
            
            .ReFilter = True
            .ReScale = True
            .RePlot = True
        End If
    End With
Next i%

Exit Sub
ReadError:
MsgBox "Error in ReadTheData: " + Err.Description
End Sub

Public Function ReadHistoryData(Index%) As Integer
Dim devProperty$, TmpText$
Dim tmpSide&, TmpStartStop&(3)
Dim tmpTimeOut&, scratchTotalPoints As DBLDBL 'FLTINT
Dim npts As Long, n As Long
Dim rcc&, i%, ii%, j%, nread As Integer
Dim dout As DBLK, din As DBLK
Dim iAnswer%, tmpEnabled As Boolean
Dim tmpShortDevName$, tmpFloat!
Dim tmpLHDeviceName$, tmpLHProperty$, tmpARCDeviceName$, tmpSelectIndex%
Dim tmpServerDeviceName$, tmpProperty$

Dim tmpDeviceName$, tmpDeviceNUMBER$

Dim scratchTotalPointsFLOAT As FLTINT
Dim DataTypeString$

' Changing from FLTINT to DBLDBL
DataTypeString$ = "DBLDBL"

With FSlct(Index%)
    .ReFilter = False
    .ReScale = False
    .RePlot = False
    
    If .Active And .Acquire = True Then
        If ArchiveForm.MXWindow(1).Checked = True Then
            tmpSide& = 0
        Else
            If NZooms% = 0 Then
                ' get an extra hour each side.....
                tmpSide& = 3600
            Else
                ' What if the data are in ONE SECOND raster - then don't add too much....
                If .NumPoints > 800 And (ArchiveStop& - ArchiveStart&) < 7200 Then tmpSide& = 100 Else tmpSide& = 1800
            End If
        End If
        
        TmpStartStop&(0) = ArchiveStart& - tmpSide&
        TmpStartStop&(1) = ArchiveStop& + tmpSide&
        
        TmpStartStop&(2) = 0

        ' Check if there is a device name...
        If .deviceName = "" Or .deviceName = "?" Then
            ' Only an index...
            tmpShortDevName$ = "#" + Format$(.DeviceIndex, "###0")
        ElseIf InStr(1, .deviceName, "/") <> 0 Then
            ' Vakuum Servers: some devices have a SLASH!
            tmpShortDevName$ = "#" + Format$(.DeviceIndex, "###0")
        Else
            tmpShortDevName$ = .deviceName
        End If
        
        ' First Try: using NAME
        If .ContextName = "" Then
            tmpDeviceName$ = .ServerName + "/" + tmpShortDevName$
        Else
            tmpDeviceName$ = "/" + .ContextName + "/" + .ServerName + "/" + tmpShortDevName$
        End If

        ' Invalid device name - not registered (only a .NAM property?) then try a NUMBER....
        If .ContextName = "" Then
            tmpDeviceNUMBER$ = .ServerName + "/#" + Format$(.DeviceIndex, "###0")
        Else
            tmpDeviceNUMBER$ = "/" + .ContextName + "/" + .ServerName + "/#" + Format$(.DeviceIndex, "###0")
        End If

        devProperty$ = .PropName

        ' First find out how many points
        tmpTimeOut& = 1000
LaunchPointsLink:
        
        ArchiveForm.ACOPData.AccessRate = tmpTimeOut&
        ArchiveForm.ACOPData.AccessMode = "READ"
        tmpLHDeviceName$ = tmpDeviceName$
        tmpLHProperty$ = devProperty$ + ".HIST"
        ArchiveForm.ACOPData.deviceName = tmpLHDeviceName$
        ArchiveForm.ACOPData.deviceProperty = tmpLHProperty$
        rcc& = ArchiveForm.ACOPData.Execute(scratchTotalPoints.d1val, 1, DataTypeString$, TmpStartStop, 2)
        'tmpTimeOut& = 1000 ' This should go fast....
        If rcc& = out_of_range% Or rcc& = device_not_connected% Then
            tmpLHDeviceName$ = tmpDeviceNUMBER$
            ArchiveForm.ACOPData.deviceName = tmpLHDeviceName$
            rcc& = ArchiveForm.ACOPData.Execute(scratchTotalPoints.d1val, 1, DataTypeString$, TmpStartStop, 2)
        End If
        
        ReadHistoryData = rcc&
        If rcc& Then
            iAnswer% = MsgBox(" Error Reading Total-History-POINTS for " + tmpLHProperty$ + " from " + tmpLHDeviceName$ + ":  " + ArchiveForm.ACOPData.Status, vbAbortRetryIgnore, "Reading Histories")
            scratchTotalPoints.d2Val = 0
            If iAnswer% = vbRetry Then
                tmpTimeOut& = tmpTimeOut& + 1000
                GoTo LaunchPointsLink
            ElseIf iAnswer% = vbAbort Then
                ReadHistoryData = -10001
                Exit Function
            Else
                ' Ignore...
            End If
        End If
        .TotalLHPoints = CLng(scratchTotalPoints.d2Val)
        
        If .ArchiveDataServer <> "" Then
            tmpTimeOut& = 1000
            ArchiveForm.ACOPData.AccessRate = tmpTimeOut&
            ArchiveForm.ACOPData.AccessMode = "READ"
            ArchiveForm.ACOPData.deviceName = .ArchiveHistoryServer + "/" + tmpShortDevName$
            ArchiveForm.ACOPData.deviceProperty = .ArchiveProperty
            rcc& = ArchiveForm.ACOPData.Execute(scratchTotalPoints.d1val, 1, DataTypeString$, TmpStartStop, 2)
            Debug.Print scratchTotalPoints.d2Val
            
            'rcc& = ArchiveForm.ACOPData.Execute(scratchTotalPointsFLOAT.fval, 1, "FLTINT", TmpStartStop, 2)
            If rcc& = 35 Then
                ArchiveForm.ACOPData.deviceName = .ArchiveHistoryServer + "/#0" ' + tmpShortDevName$
                TmpStartStop&(2) = 1
                rcc& = ArchiveForm.ACOPData.Execute(scratchTotalPoints.d1val, 1, DataTypeString$, TmpStartStop, 3)
                TmpStartStop&(2) = 0
            End If
            
            Debug.Print scratchTotalPointsFLOAT.iVal
            If rcc& Then
                MsgBox "Error reading from central archiver! " + ArchiveForm.ACOPData.Status
                scratchTotalPoints.d2Val = 0
            Else
            End If
            .TotalArchPoints = CLng(scratchTotalPoints.d2Val)
        ElseIf .LHDataAlsoFromArchiver = True Then
            ' Try to get arch data with redirection...
            tmpTimeOut& = 1000
LaunchPointsLinkB:
            ArchiveForm.ACOPData.AccessRate = tmpTimeOut&
            ArchiveForm.ACOPData.AccessMode = "READ"
            tmpARCDeviceName$ = tmpDeviceName$
            'tmpARCDeviceName$ = "/" + .ContextName + "/" + .ServerName + "/#4"
            ArchiveForm.ACOPData.deviceName = tmpARCDeviceName$
            ArchiveForm.ACOPData.deviceProperty = devProperty$ + ".ARCH"
            ' First, just check if there IS a redirection...
            rcc& = ArchiveForm.ACOPData.Execute(tmpFloat!)
            If rcc& = 101 Or rcc& <> 0 Or .LHDataAlsoFromArchiver = False Then
                .LHDataAlsoFromArchiver = False
                .TotalArchPoints = -1
            Else
                tmpARCDeviceName$ = tmpDeviceName$
                'tmpARCDeviceName$ = "/" + .ContextName + "/" + .ServerName + "/#4"
                ArchiveForm.ACOPData.deviceName = tmpARCDeviceName$
                ArchiveForm.ACOPData.deviceProperty = devProperty$ + ".ARCH"
                rcc& = ArchiveForm.ACOPData.Execute(scratchTotalPoints.d1val, 1, DataTypeString$, TmpStartStop, 2)
                'tmpTimeOut& = 1000 ' This should go fast....
                If rcc& = out_of_range% Or rcc& = device_not_connected% Then
                    tmpARCDeviceName$ = tmpDeviceNUMBER$
                    ArchiveForm.ACOPData.deviceName = tmpARCDeviceName$
                    rcc& = ArchiveForm.ACOPData.Execute(scratchTotalPoints.d1val, 1, DataTypeString$, TmpStartStop, 2)
                End If
        
                ReadHistoryData = rcc&
                If rcc& Then
                    iAnswer% = MsgBox(" Error Reading Total-History-POINTS for " + tmpLHProperty$ + " from " + tmpLHDeviceName$ + ":  " + ArchiveForm.ACOPData.Status, vbAbortRetryIgnore, "Reading Histories")
                    scratchTotalPoints.d2Val = 0
                    If iAnswer% = vbRetry Then
                        tmpTimeOut& = tmpTimeOut& + 1000
                        GoTo LaunchPointsLinkB
                    ElseIf iAnswer% = vbAbort Then
                        ReadHistoryData = -10001
                        Exit Function
                    Else
                        ' Ignore...
                    End If
                End If
                .TotalArchPoints = CLng(scratchTotalPoints.d2Val)
            End If
        Else
            .TotalArchPoints = -1
        End If
    
        ' Where to get the data?
        If ArchiveMode% = LHistoryChooser And .WhereToGetLHData < 2 Then
            ' use OPTION BUTTON!
            If .WhereToGetLHData = 0 Then tmpSelectIndex% = 1 Else tmpSelectIndex% = 2
        ElseIf .ArchiveDataServer <> "" Then
            If .TotalArchPoints > 500 Or .TotalArchPoints > .TotalLHPoints Then
                ' use Central Archiver
                tmpSelectIndex% = 0
            Else
                tmpSelectIndex% = 1
            End If
        Else
            If .TotalArchPoints > 500 Or .TotalArchPoints > .TotalLHPoints Then
                ' use ARCH Property
                tmpSelectIndex% = 2
            Else
                tmpSelectIndex% = 1
            End If
        End If
        
        'tmpSelectIndex% = 1
        Select Case tmpSelectIndex%
        Case 0: ' Central Archiver
            ' Get the data out of the CENTRAL ARCHIVER
            tmpServerDeviceName$ = .ArchiveHistoryServer + "/" + tmpShortDevName$
            tmpProperty$ = .ArchiveProperty

            .TotalPoints = .TotalArchPoints
            tmpTimeOut& = 1000
        Case 1: ' NORMAL Local History
            ' Get the Local History Data
            tmpServerDeviceName$ = tmpLHDeviceName$
            tmpProperty$ = devProperty$ + ".HIST"
            .TotalPoints = .TotalLHPoints
            If .TotalPoints > 10000 Then
                tmpTimeOut& = 5000
            Else
                tmpTimeOut& = 2000
            End If
        Case 2: ' LocalHistory redirect to central archiver
            tmpServerDeviceName$ = tmpLHDeviceName$
            tmpProperty$ = devProperty$ + ".ARCH"
            .TotalPoints = .TotalArchPoints
            tmpTimeOut& = 1000
        End Select
    
        TmpText$ = "Total: " + Format$(.TotalPoints, "0")
        ArchiveForm.LabelPoints(0) = TmpText$

LaunchHistoryLink:
        TmpStartStop&(2) = 0.01
        TmpStartStop&(3) = -1
        
        ArchiveForm.ACOPData.AccessRate = tmpTimeOut&
        ArchiveForm.ACOPData.deviceName = tmpServerDeviceName$
        ArchiveForm.ACOPData.deviceProperty = tmpProperty$
        rcc& = ArchiveForm.ACOPData.Execute(ArchData(0, Index%).d1val, MaxGetDataPointsHIST, "DBLDBL", TmpStartStop, 3)
        
        ReadHistoryData = rcc&
        
        If rcc& Then
            iAnswer% = MsgBox(" Error Reading History Data for " + tmpProperty$ + " from " + tmpServerDeviceName$ + ":  " + ArchiveForm.ACOPData.Status, vbAbortRetryIgnore, "Reading Histories")
            If iAnswer% = vbRetry Then
                tmpTimeOut& = tmpTimeOut& + 2000
                GoTo LaunchHistoryLink
            ElseIf iAnswer% = vbAbort Then
                .NumPoints = 0
                .TotalPoints = 0
                ReadHistoryData = -10001
                Exit Function
            Else
                ' Ignore....
            End If
            nread = 0
        Else
            ArchiveForm.ACOPData.GetDataSize nread
            .ReFilter = True
            .ReScale = True
            .RePlot = True
        End If
        
        .NumPoints = nread
    End If
    
End With

' Set back to "nothing"
ArchiveForm.LabelPoints(0).Caption = "-"
ArchiveForm.LabelPoints(2).Visible = False
ArchiveForm.LabelPoints(3).Visible = False

End Function

Public Function ReadArchiveData(Index%) As Integer
Dim i%, ii%, j%, k%, kk%, StartLabel%, StopLabel%, MsgRC%, rc%, rcc&
Dim tmpIndex%, tmpSide&, TmpStartStop&(3), tStr$, tmpTotalPoints&, TmpText$, TmpStartStopDble#(3)
Dim useStringBuffer As Boolean, scratchTotalPoints As FLTINT, TmpDevName$
Dim iAnswer%
Dim nPointsRead%

On Error GoTo ErrorRoutine

With FSlct(Index%)
    .ReFilter = False
    .ReScale = False
    .RePlot = False
    
    If .Active And .Acquire = True Then
        If ArchiveForm.MXWindow(1).Checked = True Then
            tmpSide& = 0
        Else
            If NZooms% = 0 Then
                ' get an extra hour each side.....
                tmpSide& = 3600
            Else
                ' What if the data are in ONE SECOND raster - then don't add too much....
                If .NumPoints > 800 And (ArchiveStop& - ArchiveStart&) < 7200 Then tmpSide& = 100 Else tmpSide& = 1800
            End If
        End If
        
        TmpStartStop&(0) = ArchiveStart& - tmpSide&
        TmpStartStop&(1) = ArchiveStop& + tmpSide&
        
        If Not filterAcquired Then
retrieveFilterData:
            If nFilterKeywords > 0 Then
                ArchiveForm.ACOPData.Caption = filterString
                For j% = 0 To nFilterKeywords - 1
                    If filterKeywords(j%).fmt = "NAME32" Then
                        ArchiveForm.ACOPData.deviceName = filterKeywords(j%).server
                        ArchiveForm.ACOPData.deviceProperty = filterKeywords(j%).keyword
                        rcc& = ArchiveForm.ACOPData.Execute(filterTextBuffer(0, j%).nam, MaxPoints / 10, "NAME32I", TmpStartStop)
                    Else
                        ArchiveForm.ACOPData.deviceName = filterKeywords(j%).server
                        ArchiveForm.ACOPData.deviceProperty = filterKeywords(j%).keyword
                        rcc& = ArchiveForm.ACOPData.Execute(filterDataBuffer(0, j%).fval, MaxPoints, "FLTINT", TmpStartStop)
                    End If
                    If rcc& Then
                        MsgRC = MsgBox(" Error acquiring filter! " + ArchiveForm.ACOPData.Status, vbAbortRetryIgnore, "Archive Retrieval")
                        filterDataBufferNPoints&(j%) = 0
                        If MsgRC = vbRetry Then GoTo retrieveFilterData
                    End If
                    ArchiveForm.ACOPData.GetDataSize nPointsRead%
                    filterDataBufferNPoints&(j%) = nPointsRead%
                Next j%
            Else
                ArchiveForm.ACOPData.Caption = ""
            End If
            filterAcquired = True
        End If
        
        ' get the data out of the archive
retrieveArchiveData:
        ArchiveForm.LabelMisc(3).Caption = "Data loading...."
        ArchiveForm.LabelMisc(3).Visible = True
        ArchiveForm.Refresh
        
        ' give it a longer timeout in case there's a bunch of data :
        If ArchiveForm.timeoutText.Visible Then
            ArchiveForm.ACOPData.AccessRate = ArchiveForm.timeoutText.text '3000
        Else
            ArchiveForm.ACOPData.AccessRate = 3000
        End If
        
        If .DeviceIndex < 0 And .deviceName = "#0" And Mid(.PropName, 1, 3) <> "TTF" Then
            ' For the HTC: get the BUNCH CURRENTS for the INDEX of the HE_HTC_BUNCH!
            ArchiveForm.ACOPData.deviceName = .ServerName
            Call GetHTCStuff(Index%)
        Else
            If Mid(.PropName, 1, 3) = "TTF" Then
                ArchiveForm.ACOPData.deviceName = "TTFHISTORY"
            
                ' Kludge for the HTC Bunch-Selection....
                If .DeviceIndex < 0 Then .DeviceIndex = 0
                
                ' Is this a TD Property?
                If .VPlot = "TD" Then
                    TmpStartStop&(2) = .DeviceIndex * NTDBunches + .DeviceSubIndex
                Else
                    TmpStartStop&(2) = .DeviceIndex
                End If
            Else
                If .DeviceIndex >= 0 Then TmpStartStop&(2) = .DeviceIndex
            End If
        
            
LaunchPointsLink:
            ' Check if there is a device name...
            If .deviceName = "" Or .deviceName = "?" Then
                ' Only an index...
                If .ContextName = "" Then
                    TmpDevName$ = .ServerName + "/#" + Format$(.DeviceIndex, "###0")
                Else
                    TmpDevName$ = "/" + .ContextName + "/" + .ServerName + "/#" + Format$(.DeviceIndex, "###0")
                End If
            ElseIf InStr(1, .deviceName, "/") <> 0 Then
                ' Vakuum Servers: some devices have a SLASH!
                If .ContextName = "" Then
                    TmpDevName$ = .ServerName + "/#" + Format$(.DeviceIndex, "###0")
                Else
                    TmpDevName$ = "/" + .ContextName + "/" + .ServerName + "/#" + Format$(.DeviceIndex, "###0")
                End If
            Else
                If .ContextName = "" Then
                    TmpDevName$ = .ServerName + "/" + .deviceName
                Else
                    TmpDevName$ = "/" + .ContextName + "/" + .ServerName + "/" + .deviceName
                End If
            End If
            ArchiveForm.ACOPData.deviceName = TmpDevName$
            ArchiveForm.ACOPData.deviceProperty = .PropName
            
            
            '' Get the total number of points in the interval
            'ArchiveForm.ACOPData.deviceName = .ServerName + "/" + .deviceName
            'If .ContextName <> "" Then
            '  ArchiveForm.ACOPData.deviceName = "/" + .ContextName + "/" + ArchiveForm.ACOPData.deviceName
            'End If
            
            rcc& = ArchiveForm.ACOPData.Execute(scratchTotalPoints.fval, 1, "FLTINT", TmpStartStop, 2)
            If rcc& Then '= out_of_range% Then
'                ' Invalid device name - not registered (only a .NAM property?)
'                'MsgBox " error reading device name history for " + devProperty + ": " + RPCERROR(rcc&)
'                If .ContextName = "" Then
'                    TmpDevName$ = .ServerName + "/#" + Format$(.DeviceIndex, "###0")
'                Else
'                    TmpDevName$ = "/" + .ContextName + "/" + .ServerName + "/#" + Format$(.DeviceIndex, "###0")
'                End If
'                ArchiveForm.ACOPData.deviceName = TmpDevName$
'                rcc& = ArchiveForm.ACOPData.Execute(scratchTotalPoints.fval, 1, "FLTINT", TmpStartStop, 2)
            End If
                             
            If rcc& Then
                scratchTotalPoints.iVal = 0
                iAnswer% = MsgBox(" Error Reading Total Points for " + .PropName + " from " + TmpDevName$ + ":  " + ArchiveForm.ACOPData.Status, vbAbortRetryIgnore, "Reading Histories")
                If iAnswer% = vbRetry Then
                    GoTo LaunchPointsLink
                ElseIf iAnswer% = vbAbort Then
                    ReadArchiveData = -10001
                    Exit Function
                Else
                    ' Ignore....
                End If
            End If
            tmpTotalPoints& = scratchTotalPoints.iVal
            .TotalPoints = tmpTotalPoints&
            
LaunchDataLink:
            ArchiveForm.ACOPData.deviceProperty = .PropName
            ArchiveForm.ACOPData.deviceName = TmpDevName$ '.ServerName + "/" + .deviceName
            'If .ContextName <> "" Then
            '  ArchiveForm.ACOPData.deviceName = "/" + .ContextName + "/" + ArchiveForm.ACOPData.deviceName
            'End If
            If .Acquire = True Then
                tStr = Left(UCase(.PropFormatStr), 4)
                If tStr = "CHAR" Or tStr = "NAME" Or tStr = "TEXT" Then
                    rcc& = ArchiveForm.ACOPData.Execute(ArchStringDataBuffer(0, Index%).nam, MaxStrings, "NAME32I", TmpStartStop, 2)
                    useStringBuffer = True
                Else
                    rcc& = ArchiveForm.ACOPData.Execute(ArchDataBuffer(0, Index%).d1val, MaxGetDataPointsARCH, "DBLDBL", TmpStartStop, 2)
                End If
                If rcc& Then
                  iAnswer% = MsgBox(" Error Reading Archived Data for " + .PropName + " from " + TmpDevName$ + ":  " + " " + ArchiveForm.ACOPData.Status, vbAbortRetryIgnore, "Reading Histories")
                  'ArchData(0, index%).iVal = 0
                  If iAnswer% = vbRetry Then
                      GoTo LaunchDataLink
                  ElseIf iAnswer% = vbAbort Then
                      ReadArchiveData = -10001
                      Exit Function
                  Else
                      ' Ignore....
                  End If
                  nPointsRead% = 0                                 'P.D  allow for the new way !
                Else
                  ArchiveForm.ACOPData.GetDataSize nPointsRead%    'P.D  allow for the new way !
                End If
            End If

            .NumPoints = nPointsRead%
            kk% = 0
            For k% = 0 To nPointsRead% - 1 'ArchDataBuffer(0, index%).d2val
                If (nFilterKeywords = 0) Or (filerArchiveData(CLng(ArchDataBuffer(k%, Index%).d2Val)) > 0) Then
                    If useStringBuffer Then
                        ArchData(kk%, Index%).d2Val = ArchStringDataBuffer(k%, Index%).iVal
                    Else
                        ArchData(kk%, Index%) = ArchDataBuffer(k%, Index%)
                        
                        ' TimeStamp of ZERO????
                        'If kk% > 0 And ArchData(kk%, index%).iVal = 0 Then
                        '    ArchData(kk%, index%).iVal = ArchData(kk% - 1, index%).iVal + 1
                        'End If
                        'Debug.Print k%, ArchData(kk%, index%).fval, ArchData(kk%, index%).iVal - ArchData(0, index%).iVal
                    End If
                    kk% = kk% + 1
                End If
            Next k%
            If kk% > 1 Then
                .NumPoints = kk% ' - 1
            Else
                .NumPoints = 0
            End If
        End If
        
        '.NumPoints = 1
        ReadArchiveData = rcc&
        ' .NumPoints = ArchDataBuffer(0, index%).iVal  ' < why is (was) this necessary ?
                
        If rcc& Then
        
        Else
            .ReFilter = True
            .ReScale = True
            .RePlot = True
        End If
    End If
End With

Exit Function

ErrorRoutine:
iAnswer% = MsgBox("Error in Read for Property: " + ArchiveForm.ACOPData.deviceProperty + "  " + Err.Description, vbRetryCancel)
If iAnswer% = vbCancel Then
    Exit Function
Else
    Resume Next
End If
End Function

Public Sub ReadArrayData()
Dim i%, TmpDName$, tmpDefaultDName$, TmpPName$, rcc&, TmpStartStop&(3)
Dim tmpTS&, TmpSize&, tmpTSArray&(1), TempIndex%, TempDNameIndex%, tmpTimeOut&
Dim iAnswer%, TmpDataServer$

If SelectedTrace%(0) < 0 Then SelectedTrace%(0) = 0

If ArchiveTS& <= 0 Then
    ArchiveTS& = ArchiveStart& + (ArchiveStop& - ArchiveStart&) / 2
End If

'LabelTime(0).Caption = ACOPPlot(0).CTIME(ArchiveTS&)

' Get the data from the SelectedTrace, at the selected Time-Stamp
TempDNameIndex% = IndexToDName%(SelectedTrace%(0))
TempIndex% = SelectedTrace%(0)

If FSlct(TempIndex%).PropSize = 1 Then
    MsgBox " Selected Property is NOT an array!"
    Exit Sub
End If

If ArchiveMode% = CArchivers Then
    TmpStartStop&(0) = ArchiveTS&
    TmpStartStop&(1) = ArchiveTS&
    
    With FSlct(TempIndex%)
        ' For TD, need also the SubIndex (the BUNCH)
        If UCase$(.VPlot) = "TD" Then
        '    TmpStartStop&(2) = NextSubi% ' the START INDEX of the "property"
        '    TmpStartStop&(3) = NTDBunches ' SAMPLE Interval
            
            TmpStartStop&(2) = 0 ' the START INDEX of the "property"
            TmpStartStop&(3) = 1 ' SAMPLE Interval
        Else
            TmpStartStop&(2) = 0 ' the START INDEX of the "property"
            TmpStartStop&(3) = 1 ' SAMPLE Interval
        End If
        
        TmpSize& = .PropSize
        
        TmpDataServer$ = gArchiveServerInfo(SelectedMachine%).DataServerName
        TmpDName$ = TmpDataServer$ '.ServerName
        TmpPName$ = .PropName
    End With
    
    ReDim ArrayData!(TmpSize& - 1)
    ReDim PlotArrayData!(TmpSize& - 1)
    
    ArchiveForm.ACOPData.deviceName = TmpDName$
    ArchiveForm.ACOPData.deviceProperty = TmpPName$
    
    rcc& = ArchiveForm.ACOPData.Execute(ArrayData!(0), TmpSize&, "SINGLE", TmpStartStop&, 4)
    
Else
    ' What to read?
    ' Pump-ish data: data is stored with DeviceNumber #0 = only ONE Array
    ' Vibration Data - one array is stored for each DEVICE....
    
    With FSlct(TempIndex%)
        TmpPName$ = .PropName
        TmpSize& = .PropSize
        
        If .ArrayType And AT_TRACE = AT_TRACE Then
            'ArchiveForm.ACOPPlot(2).DisplayMode = PolyLineDots
            TmpDName$ = "/" + .ContextName + "/" + .ServerName + "/" + .deviceName
        Else
            'ArchiveForm.ACOPPlot(2).DisplayMode = SimpleHistogram
            tmpDefaultDName$ = "/" + .ContextName + "/" + .ServerName + "/" + "#0"
        End If
        
        
            ' Better use the given device name if you can ......
            TmpDName$ = "/" + .ContextName + "/" + .ServerName + "/" + .deviceName
            'TmpDName$ = "/" + .ContextName + "/" + .ServerName + "/" + "#" + Format$(.DeviceIndex, "0")
            tmpDefaultDName$ = "/" + .ContextName + "/" + .ServerName + "/" + "#0"
        'End If
    End With
    
    ReDim ArrayData!(TmpSize& - 1)
    ReDim PlotArrayData!(TmpSize& - 1)
    
    TmpStartStop&(0) = ArchiveTS&
    TmpStartStop&(1) = TmpStartStop&(0)
    TmpStartStop&(2) = 0
    TmpStartStop&(3) = -1
    
    ' First try with "device index"?
    tmpTimeOut& = 1000
    ArchiveForm.ACOPData.deviceProperty = TmpPName$ + ".HIST"
    
    ArchiveForm.ACOPData.AccessMode = "READ"
    'rcc& = ArchiveForm.ACOPData.Execute(ArrayData!, TmpSize&, "SINGLE", ArchiveTS&, 1, "LONG")
    
ReadArrayAgain:
    ArchiveForm.ACOPData.deviceName = TmpDName$
    ArchiveForm.ACOPData.AccessRate = tmpTimeOut&
    rcc& = ArchiveForm.ACOPData.Execute(ArrayData!, TmpSize&, "SINGLE", TmpStartStop&, 4, "LONG")

    If rcc& = 12 Or rcc& = 32 Then
        ' NOT ALLOCATED! Try with device zero....
        ArchiveForm.ACOPData.deviceName = tmpDefaultDName$
        rcc& = ArchiveForm.ACOPData.Execute(ArrayData!, TmpSize&, "SINGLE", TmpStartStop&, 4, "LONG")
    End If
    
    If rcc& Then
        iAnswer% = MsgBox(" Error Reading History Data for " + ArchiveForm.ACOPData.deviceProperty + " from " + ArchiveForm.ACOPData.deviceName + _
                        ":  " + ArchiveForm.ACOPData.Status, vbAbortRetryIgnore, "Reading Histories")
        If iAnswer% = vbRetry Then
            tmpTimeOut& = tmpTimeOut& + 2000
            GoTo ReadArrayAgain
        ElseIf iAnswer% = vbAbort Then
            Exit Sub
        Else
        End If
    End If


'    With FSlct(TempIndex%)
'        TmpDName$ = "/" + .ContextName + "/" + .ServerName + "/" + "#1"
'        ArchiveForm.ACOPData.deviceName = TmpDName$
'        ArchiveForm.ACOPData.deviceProperty = TmpPName$ + ".HIST"
'        ReDim ArrayINTData%(TmpSize& - 1)
'        rcc& = ArchiveForm.ACOPData.Execute(ArrayData!, TmpSize&, "SINGLE", TmpStartStop&, 4, "LONG")
'        'rcc& = ArchiveForm.ACOPData.Execute(ArrayINTData%, TmpSize&, "INTEGER", TmpStartStop&, 4, "LONG")
'    End With
End If

ArrayProp$ = TmpPName$
ArrayServerDevName$ = TmpDName$

If rcc& = 0 Then
    ArrayDataSize& = TmpSize&
Else
    ArrayDataSize = 0
    MsgBox "error! " + ArchiveForm.ACOPData.Status
End If
ArrayDataTimeStamp& = ArchiveForm.ACOPData.timestamp
ArrayDataKeyword$ = FSlct(TempIndex%).PropName

' compare the REQUESTED and the RETURNED time stamps...
Debug.Print ArchiveTS& - ArrayDataTimeStamp&, ArchiveForm.ACOPPlot(0).CTIME(ArchiveTS&), _
                    ArchiveForm.ACOPPlot(0).CTIME(ArrayDataTimeStamp&)

' Show difference in the stamps....
ArchiveForm.LabelTime(2).Caption = STR$(ArrayDataTimeStamp& - ArchiveTS&)

' prepare axis for reference display.....
ReDim RefAxisData!(TmpSize&)
RefAxisData!(0) = -0.5
For i% = 1 To TmpSize&
    RefAxisData!(i%) = RefAxisData!(i% - 1) + 1
Next i%

End Sub

Public Sub PlotTheArrayData()
Dim rcc&
Dim i%, TmpSelectedIndex%, TempIndex%

TmpSelectedIndex% = SelectedTrace%(0)
If TmpSelectedIndex% = -1 Then Exit Sub

TempIndex% = IndexToDName%(TmpSelectedIndex%)

ArchiveForm.ACOPPlot(2).ClearScreen

If ArrayPlotIndex& < 0 Then
    If (FSlct(TempIndex%).ArrayType And AT_TRACE) = AT_TRACE Then
        ArchiveForm.ACOPPlot(2).DisplayMode = PolyLineDots
    Else
        ArchiveForm.ACOPPlot(2).DisplayMode = SimpleHistogram
    End If
    
    ArchiveForm.ACOPPlot(2).DrawWidth = 2
    ArchiveForm.ACOPPlot(2).ClearScreen
    ArchiveForm.ACOPPlot(2).XMin = -0.5
    ArchiveForm.ACOPPlot(2).XMax = ArrayDataSize&
    If ArchiveForm.SyncZoom.Value = vbChecked Then
        ArchiveForm.ACOPPlot(2).ymin = ArchiveForm.ACOPPlot(0).ymin
        ArchiveForm.ACOPPlot(2).ymax = ArchiveForm.ACOPPlot(0).ymax
    Else
        ArchiveForm.ACOPPlot(2).ymin = ArchiveForm.ACOPPlot(0).ymin
        ArchiveForm.ACOPPlot(2).ymax = ArchiveForm.ACOPPlot(0).ymax
    End If
    ArrayPlotIndex& = ArchiveForm.ACOPPlot(2).Draw(PlotArrayData!, , , , ArrayDataSize&)
    'ArrayPlotIndex& = ArchiveForm.ACOPPlot(2).Draw(PlotArrayData!, ArrayXAxis!, , , ArrayDataSize&)
Else
    rcc& = ArchiveForm.ACOPPlot(2).RefreshScreen(PlotArrayData!, ArrayPlotIndex&, ArrayDataSize&)
End If

' Set markers on array plot?
ArchiveForm.ACOPPlot(2).Tagging = True
ArchiveForm.ACOPPlot(2).ClearTags
For i% = ActivePlot% * CopyOffset To ActivePlot% * CopyOffset + MaxPlots - 1
    If FSlct(i%).Active = True Then
        If (FSlct(TempIndex%).PropName = FSlct(i%).PropName) And (FSlct(TempIndex%).ServerName = FSlct(i%).ServerName) Then
            'Set a marker
            If FSlct(i%).DispColor = 0 Then
                ArchiveForm.ACOPPlot(2).TagColor = Gray
            Else
                ArchiveForm.ACOPPlot(2).TagColor = FSlct(i%).DispColor
            End If
            ArchiveForm.ACOPPlot(2).IsTagged FSlct(i%).DeviceIndex, True
        End If
    End If
Next i%

'ArrayDataTimeStamp& , ArrayDataKeyword$

ACOPCaptionText$(2) = FSlct(SelectedTrace%(0)).PropDesc ' ArrayDataKeyword$
ArchiveForm.ACOPPlot(2).ForeColor = vbBlack
ArchiveForm.ACOPPlot(2).Caption = ACOPCaptionText$(2) + " at " + ArchiveForm.ACOPPlot(2).CTIME(ArrayDataTimeStamp&)

ArchiveForm.ACOPPlot(2).YAxisLabel = FSlct(SelectedTrace%(0)).PropUnits

'ArchiveForm.ACOPPlot(2).ClearTags
'ArchiveForm.ACOPPlot(2).TagColor = vbGreen

If ArchiveForm.ChkAuto(0).Value = vbChecked Or ArchiveForm.ChkAuto(2).Value = vbChecked Then
    ArchiveForm.ACOPPlot(2).AutoScale False, False, True, True
Else
    'ArchiveForm.ACOPPlot(2).ymin = ArchiveForm.ACOPPlot(0).ymin
    'ArchiveForm.ACOPPlot(2).ymax = ArchiveForm.ACOPPlot(0).ymax
End If

If ReferenceTS& = 0 Then
    ArchiveForm.LabelTime(1).Caption = "No Reference"
End If

Call DrawMarker

End Sub

Public Sub ScaleArrayData()
Dim ii%, Delta!, InvDelta!, ZeroOffset!, tmpFaktor!
Dim ScaleMax!, ScaleMin!, TempSize%
Dim TempIndex%, tmpCopyBytes&

TempIndex% = SelectedTrace%(0)
If TempIndex% = -1 Then Exit Sub

TempSize% = FSlct(TempIndex%).PropSize

Select Case ScalingMode%
Case AbsoluteScale:
        tmpCopyBytes& = TempSize% * 4
        Call MEMCPYL(PlotArrayData(0), ArrayData(0), tmpCopyBytes&)

Case RelativeScale:
        ' Need to scale the data consistent with MainPlot....
        ScaleMax! = FSlct(TempIndex%).PlotMaxValue
        ScaleMin! = FSlct(TempIndex%).PlotMinValue
                
        ' To scale the data properly....
        If FSlct(TempIndex%).VPlot = "LOG" Then
            If ScaleMin! <= 0 Then ScaleMin! = 0.01
            If ScaleMax! <= 0 Then ScaleMax! = ScaleMin! * 100000
            Delta! = (Log(ScaleMax!) - Log(ScaleMin!))
            If FSlct(TempIndex%).VMin = 0 Then FSlct(TempIndex%).VMin = 1E-20
            ZeroOffset! = Log(ScaleMin!)
        Else
            Delta! = ScaleMax! - ScaleMin!
            ZeroOffset! = ScaleMin!
        End If
        
        
        If Delta! = 0 Then InvDelta! = 1 Else InvDelta! = 100 / Delta!
        ' Use the scale-factor in the form for the GRAPHICS!
        InvDelta! = InvDelta! * 1 'Val(ArchiveForm.Faktor(TempDNameIndex%).text)
                    
        ' Plotting "mode"
        If FSlct(TempIndex%).VPlot = "LOG" Then
            For ii% = 0 To TempSize% - 1
                If ArrayData!(ii%) > 0 Then
                    PlotArrayData!(ii%) = (Log(ArrayData!(ii%)) - ZeroOffset!) * InvDelta!
                Else
                    PlotArrayData!(ii%) = 0
                End If
            Next ii%
        ElseIf FSlct(TempIndex%).VPlot = "ABS" Then
            For ii% = 0 To TempSize% - 1
                PlotArrayData!(ii%) = (Abs(ArrayData!(ii%)) - ZeroOffset!) * InvDelta!
            Next ii%
        ElseIf FSlct(TempIndex%).VPlot = "SLOG" Then
            tmpFaktor! = 1
            For ii% = 0 To TempSize% - 1
                If PlotArrayData!(ii%) > 0 Then
                    ii% = ii%
                End If
                PlotArrayData!(ii%) = (ArrayData!(ii%) * tmpFaktor! - ZeroOffset!) * InvDelta!
            Next ii%
        Else
            For ii% = 0 To TempSize% - 1
               PlotArrayData!(ii%) = (ArrayData!(ii%) - ZeroOffset!) * InvDelta!
            Next ii%
        End If
End Select

End Sub

Public Sub DoTheArrayData()

' Is it necessary to do anything?
If SelectedTrace%(ActivePlot%) = -1 Then Exit Sub
If FSlct(SelectedTrace%(ActivePlot%)).PropSize < 2 Then Exit Sub

Call ReadArrayData
Call ScaleArrayData
Call PlotTheArrayData

End Sub

Function HistoryConfigLoad(filename$) As Integer
Dim col_Context%, col_Server%, col_Property%, col_DeviceName%, col_Desc%
Dim col_Units%, col_PlotMin%, col_PlotMax%, tmpDeviceName$
'Dim filename$
Dim i%, a$, p%, tok$, nparam%, type_done, rc%
Dim tmpXPrpQuery As XPropertyQuery, TmpDName$, TmpValStr$, iAnswer%

Dim col_ArchData%, col_ArchHistory%, col_ArchProperty%

type_done = False
'filename$ = App.Path + "\HistoryConfig.csv" 'fname$
If Dir(filename$) = "" Then
  HistoryConfigLoad = 0
  Exit Function
End If
'Name, Context, Server, Property, DeviceName, Description, Units, PlotMin, PlotMax

Open filename$ For Input Access Read Shared As #1
nparam% = 8
i% = 0: p% = nparam%
Do
    Line Input #1, a$
    tok$ = Left$(a$, 1)
    If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" Then
        If Not type_done Then
            col_Context% = colptr(a$, "Context")
            col_Server% = colptr(a$, "Server")
            col_Property% = colptr(a$, "Property")
            col_DeviceName% = colptr(a$, "DeviceName")
            col_Desc% = colptr(a$, "Description")
            col_Units% = colptr(a$, "Units")
            col_PlotMin% = colptr(a$, "PlotMin")
            col_PlotMax% = colptr(a$, "PlotMax")
            
'col_ArchData%, col_ArchHistory%, col_ArchProperty%
            
            col_ArchData% = colptr(a$, "ArchiveDataServer")
            col_ArchHistory% = colptr(a$, "ArchiveHistoryServer")
            col_ArchProperty% = colptr(a$, "ArchiveProperty")
            type_done = True
        Else
            With CSVPropInfo(i%)
                .ContextName = Trim(getcol(a$, col_Context%))
                .ServerName = Trim(getcol(a$, col_Server%))
                .prpName = Trim(getcol(a$, col_Property%))
                tmpDeviceName$ = Trim((getcol(a$, col_DeviceName%)))
                
                tmpDeviceName$ = Trim((getcol(a$, col_DeviceName%)))
                'If .deviceName <> "" Then .devIndex = Val(Right$(.deviceName, Len(.deviceName) - 1))
                If tmpDeviceName$ = "" Then
                    .deviceName = "#0"
                ElseIf STR$(Val(tmpDeviceName$)) = .deviceName Then
                    ' Check if just a number....
                    .deviceName = "#" + Format$(tmpDeviceName$, "0")
                Else
                    .deviceName = tmpDeviceName$
                End If
                
                ' WHY DO THIS HERE???? _ takes so long....
                
                ' Get the "default data" for this property....
TryAgain:
                TmpDName$ = "/" + .ContextName + "/" + .ServerName
                rc% = GetFullPropertyInformation(TmpDName$, .prpName, tmpXPrpQuery)
                If rc% <> 0 Then
                    iAnswer% = MsgBox("Error Getting Full-Property Info from Server: " + TmpDName + "  Property: " + .prpName + " : " + RPCERROR(rc%), vbAbortRetryIgnore)
                    If iAnswer% = vbRetry Then
                        GoTo TryAgain
                    ElseIf iAnswer% = vbAbort Then
                        Close #1
                        Exit Function
                    Else
                    End If
                End If
                
                .PropDesc = Trim(getcol(a$, col_Desc%))
                If .PropDesc = "" Then .PropDesc = BSTR$(tmpXPrpQuery.prpDesc)
                
                .PropUnits = Trim(getcol(a$, col_Units%))
                If .PropUnits = "" Then .PropUnits = BSTR$(tmpXPrpQuery.prpUnits)
                
                TmpValStr$ = Trim(getcol(a$, col_PlotMin%))
                If TmpValStr$ = "" Then .PropMin = tmpXPrpQuery.prpMinValue Else _
                                        .PropMin = Val(TmpValStr$)
                
                TmpValStr$ = Trim(getcol(a$, col_PlotMax%))
                If TmpValStr$ = "" Then .PropMax = tmpXPrpQuery.prpMaxValue Else _
                                        .PropMax = Val(TmpValStr$)
            
                .PropSize = tmpXPrpQuery.prpSize
            
                .ArrayType = tmpXPrpQuery.prpArrayType
                .XMax = tmpXPrpQuery.rangeMaxValue
                .XMin = tmpXPrpQuery.rangeMinValue
                .XUnits = tmpXPrpQuery.rangeUnits
                
                ' Is there an archive server?
                If col_ArchData% > -1 Then
                    .ArchiveDataServer = Trim(getcol(a$, col_ArchData%))
                    .ArchiveHistoryServer = Trim(getcol(a$, col_ArchHistory%))
                    .ArchiveProperty = Trim(getcol(a$, col_ArchProperty%))
                Else
                    .ArchiveDataServer = ""
                    .ArchiveHistoryServer = ""
                    .ArchiveProperty = ""
                End If
            End With
            i% = i% + 1
      End If
    End If
Loop While Not EOF(1)
Close 1

HistoryConfigLoad = i%

End Function



Public Function ScaleForBits(Index%, StatusValue&) As Single
Dim tmpMask&, tmpFaktor!, tmpValue!

' Convert statusvalue to LONG and THEN do bit-mask/scaling?
tmpFaktor! = 1
tmpMask& = SelectBits&(FSlct(Index%).DeviceSubIndex - 1)

tmpValue! = 2 * Index% + (StatusValue& And tmpMask&) / tmpMask&

ScaleForBits! = tmpValue!
End Function
