Attribute VB_Name = "Module1"
Global Const MAXNUMEVENTS = 512
Global Const MAXNUMSTEPS = 512
Global Const cfgfile$ = "pmarchmgr.csv"

Type ARB ' Archive Request Block
  context As String
  srcTag As String
  srcPrp As String
  dev As String
  arcTag As String
  arcPrp As String
  siz As Integer
  fmt As String
  dataValue As Integer
  devAccess As String
  waitSecs As Integer
  notreadyTimeout As Integer
  valueScale As Single
  valueShift As Single
  pmHdr As DHS
  useHdr As Boolean
  devList() As String
  devAliasList() As String
  useDevList As Boolean
End Type

Type PMEVENT_TYPE
  longExt As String
  trigger As String
  shortExt As String
  headerFile As String
  recordLevel As Integer ' basically a boolean
  fwdSrv As String
  fwdPrp As String
  fwdData As Integer ' 1 short value
  pmSteps() As ARB
  nPmSteps As Integer
End Type
Global pmEvent(MAXNUMEVENTS) As PMEVENT_TYPE

Function AppendDatabase(fname$, nsvrs%, nparam%) As Integer
' add a record
' is record name already there ? -> deactivate

End Function
Function readDeviceFile(devFileName As String, devList() As String, aliasList() As String) As Integer
Dim i As Integer, k As Integer, n As Integer
Dim a As String, hdr As String, tok As String
Dim nam_col As Integer, num_col As Integer, ali_col As Integer
Dim hdr_done As Boolean

If Dir(devFileName) = "" Then
  readDeviceFile = 0
  Exit Function
End If

i = getDatabaseSize(devFileName)
If i <= 0 Then
  readDeviceFile = 0
  Exit Function
End If

ReDim devList(i - 1)
ReDim aliasList(i - 1)

Open devFileName For Input Access Read Shared As #3
Do
  Line Input #3, a
  tok = Left$(a, 1)
  If tok <> "%" And tok <> ";" And tok <> "#" Then
    If Not hdr_done Then
      num_col = colptr(a, "DEVICE_NUMBER")
      nam_col = colptr(a, "DEVICE_NAME")
      ali_col = colptr(a, "DEVICE_ALIAS")
      hdr_done = True
    Else
      i = Val(getcol(a, num_col))
      If i <= UBound(devList) Then
        devList(i) = getcol(a, nam_col)
        aliasList(i) = getcol(a, ali_col)
        n = n + 1
      End If
    End If
  End If
Loop While Not EOF(3)
Close 3

readDeviceFile = n

End Function

Function readHeaderFile(hdrFileName As String, steps() As ARB) As Integer
Dim i As Integer, k As Integer, n As Integer
Dim a As String, hdr As String, tok As String
Dim tgtPrp As String, tgtSrv As String
Dim hdr_done As Boolean
Dim devHdr As DHS
Dim prp_col As Integer, dev_col As Integer, siz_col As Integer, fmt_col As Integer
Dim rat_col As Integer, locnt_col As Integer, hicnt_col As Integer, egu_col As Integer
Dim loegu_col As Integer, hiegu_col As Integer
Dim dval As Double
Dim hdrHasEntries As Boolean

If Dir(hdrFileName) = "" Then
  readHeaderFile = 0
  Exit Function
End If

Open hdrFileName For Input Access Read Shared As #2
Do
  Line Input #2, a
  tok = Left$(a, 1)
  If Len(a) > 0 And tok <> "%" And tok <> ";" And tok <> "#" Then
    If Not hdr_done Then
      prp_col = colptr(a, "Property")
      dev_col = colptr(a, "Device")
      siz_col = colptr(a, "ArraySize")
      fmt_col = colptr(a, "DataType")
      rat_col = colptr(a, "SamplingRate")
      locnt_col = colptr(a, "LowCount")
      hicnt_col = colptr(a, "HighCount")
      egu_col = colptr(a, "Egu")
      loegu_col = colptr(a, "LowEgu")
      hiegu_col = colptr(a, "HighEgu")
      hdr_done = True
    Else
      devHdr.arraySize = Val(getcol(a, siz_col))
      devHdr.datatype = getFormatFromString(getcol(a, fmt_col))
      BARR devHdr.egu, getcol(a, egu_col)
      devHdr.eguHigh = Val(getcol(a, hiegu_col))
      devHdr.eguLow = Val(getcol(a, loegu_col))
      dval = Val(getcol(a, hicnt_col))
      devHdr.highCount = IIf(dval < 1000000000, dval, 1000000000)
      dval = Val(getcol(a, locnt_col))
      devHdr.lowCount = IIf(dval < 1000000000, dval, 1000000000)
      devHdr.samplingRate = Val(getcol(a, rat_col))
      tgtPrp = getcol(a, prp_col)
      tgtSrv = getcol(a, dev_col)
      ' now match this devHdr to the appropriate steps()s ...
      For k = 0 To UBound(steps)
        If (tgtSrv = steps(k).arcTag) And (tgtPrp = steps(k).arcPrp) Then
          steps(k).pmHdr = devHdr
          steps(k).useHdr = True
          hdrHasEntries = True
        End If
      Next
      n = n + 1
    End If
  End If
Loop While Not EOF(2)
Close 2

If Not hdrHasEntries Then n = 0
readHeaderFile = n

End Function

Function writeDataBase(pname As String, ntriggers As Integer) As Integer
Dim i As Integer, k As Integer, n As Integer
Dim a As String, hdr As String
Dim pmFileName As String
Dim evnFileName As String
Dim hdrFileName As String
Dim devFileName As String

' write pmArchiveList.csv
ArchiveDbForm.WriteProgress.Visible = True
ArchiveDbForm.WriteProgress.Max = ntriggers
pmFileName = pname + "\pmArchiveList.csv"
hdr = "Server,Name,Extension,Source,Destination,Header,Record,AutoClear,fwd_Server,fwd_Property,fwd_Data"
Open pmFileName For Output As #1
Print #1, hdr
For i = 0 To ntriggers - 1
  ArchiveDbForm.WriteProgress.Value = i
  DoEvents
  a = pmEvent(i).longExt + "," + pmEvent(i).trigger + "," + pmEvent(i).shortExt + ",../CACHE,../CACHE"
  a = a + "," + pmEvent(i).headerFile + "," + Trim$(str$(pmEvent(i).recordLevel)) + ",0"
  a = a + "," + pmEvent(i).fwdSrv + "," + pmEvent(i).fwdPrp + ","
  If Len(pmEvent(i).fwdSrv) > 0 Then a = a + Trim$(str$(pmEvent(i).fwdData))
  Print #1, a
  ' write trigger file
  evnFileName = pname + "\..\CACHE\triggerFiles\" + pmEvent(i).trigger + ".csv"
  Open evnFileName For Output As #2
  hdr = "Context,Tag,Property,Device,ArchiveTag,ArchiveProperty,Size,Format,Value,Access,Wait,Timeout,Scale,Shift"
  Print #2, hdr
  For k = 0 To pmEvent(i).nPmSteps - 1
    a = pmEvent(i).pmSteps(k).context + "," + pmEvent(i).pmSteps(k).srcTag + "," + pmEvent(i).pmSteps(k).srcPrp + "," + pmEvent(i).pmSteps(k).dev
    a = a + "," + pmEvent(i).pmSteps(k).arcTag + "," + pmEvent(i).pmSteps(k).arcPrp + "," + Trim$(str$(pmEvent(i).pmSteps(k).siz))
    a = a + "," + pmEvent(i).pmSteps(k).fmt + "," + Trim$(str$(pmEvent(i).pmSteps(k).dataValue))
    a = a + "," + pmEvent(i).pmSteps(k).devAccess + "," + Trim$(str$(pmEvent(i).pmSteps(k).waitSecs))
    a = a + "," + Trim$(str$(pmEvent(i).pmSteps(k).notreadyTimeout)) + "," + Trim$(Format$(pmEvent(i).pmSteps(k).valueScale, "0.0"))
    a = a + "," + Trim$(Format$(pmEvent(i).pmSteps(k).valueShift, "0.0"))
    Print #2, a
  Next
  Close 2
  ' write header files
  If Len(pmEvent(i).headerFile) > 0 And pmEvent(i).nPmSteps > 0 Then
    hdrFileName = pname + "\..\CACHE\headerFiles\" + pmEvent(i).headerFile ' already has the .csv extension
    Open hdrFileName For Output As #2
    hdr = "Property,Device,ArraySize,DataType,SamplingRate,LowCount,HighCount,Egu,LowEgu,HighEgu"
    Print #2, hdr
    For k = 0 To pmEvent(i).nPmSteps - 1
      If pmEvent(i).pmSteps(k).useHdr Then
        a = pmEvent(i).pmSteps(k).arcPrp + "," + pmEvent(i).pmSteps(k).arcTag
        a = a + "," + Trim$(str$(pmEvent(i).pmSteps(k).pmHdr.arraySize))
        a = a + "," + GetFormatAsString(pmEvent(i).pmSteps(k).pmHdr.datatype)
        a = a + "," + Trim$(str$(pmEvent(i).pmSteps(k).pmHdr.samplingRate))
        a = a + "," + Trim$(str$(pmEvent(i).pmSteps(k).pmHdr.lowCount))
        a = a + "," + Trim$(str$(pmEvent(i).pmSteps(k).pmHdr.highCount))
        a = a + "," + BSTR(pmEvent(i).pmSteps(k).pmHdr.egu)
        a = a + "," + Trim$(str$(pmEvent(i).pmSteps(k).pmHdr.eguLow))
        a = a + "," + Trim$(str$(pmEvent(i).pmSteps(k).pmHdr.eguHigh))
        Print #2, a
        For n = k + 1 To pmEvent(i).nPmSteps - 1 Step 1
          If (pmEvent(i).pmSteps(k).arcPrp = pmEvent(i).pmSteps(n).arcPrp) And _
             (pmEvent(i).pmSteps(k).arcTag = pmEvent(i).pmSteps(n).arcTag) Then
            pmEvent(i).pmSteps(n).useHdr = False ' now we've done this one
          End If
        Next
      End If
    Next
    Close 2
  End If
  ' write device files(s)
  For k = 0 To pmEvent(i).nPmSteps - 1
    If pmEvent(i).pmSteps(k).useDevList And Len(pmEvent(i).pmSteps(k).arcTag) > 0 Then
      devFileName = pname + "\..\CACHE\deviceFiles\" + pmEvent(i).pmSteps(k).arcTag + "-devices.csv"
      Open devFileName For Output As #2
      hdr = "DEVICE_NUMBER,DEVICE_NAME,DEVICE_ALIAS"
      Print #2, hdr
      For n = 0 To UBound(pmEvent(i).pmSteps(k).devList)
        a = str$(n) + "," + pmEvent(i).pmSteps(k).devList(n)
        a = a + "," + pmEvent(i).pmSteps(k).devAliasList(n)
        Print #2, a
      Next
      For n = k + 1 To pmEvent(i).nPmSteps - 1 Step 1
        If (pmEvent(i).pmSteps(k).arcTag = pmEvent(i).pmSteps(n).arcTag) Then
          pmEvent(i).pmSteps(n).useDevList = False ' now we've done this one
        End If
      Next
      Close 2
    End If
  Next
Next
Close 1
writeDataBase = i
ArchiveDbForm.WriteProgress.Visible = False
End Function
Function readDataBase(pname As String) As Integer
Dim i As Integer, k As Integer, n As Integer
Dim a As String, hdr As String, tok As String
Dim pmFileName As String
Dim evnFileName As String
Dim hdrFileName As String
Dim devFileName As String
Dim hdr_done As Boolean

Dim srv_col As Integer, nam_col As Integer, ext_col As Integer, hdr_col As Integer, rec_col As Integer
Dim fwdsrv_col As Integer, fwdprp_col As Integer, fwddat_col As Integer

pmFileName = pname + "\pmArchiveList.csv"
'If Dir(pmFileName) = "" Then
'  readDataBase = 0
'  Exit Function
'End If
n = getDatabaseSize(pmFileName)
If n = 0 Then
  readDataBase = 0
  Exit Function
End If
ArchiveDbForm.WriteProgress.Visible = True
ArchiveDbForm.WriteProgress.Max = n

Open pmFileName For Input Access Read Shared As #5
i = 0
Do
  ArchiveDbForm.WriteProgress.Value = i
  DoEvents
  Line Input #5, a
  tok = Left$(a, 1)
  If tok <> "%" And tok <> ";" And tok <> "#" Then
    If Not hdr_done Then
      srv_col = colptr(a, "Server")
      nam_col = colptr(a, "Name")
      ext_col = colptr(a, "Extension")
      hdr_col = colptr(a, "Header")
      rec_col = colptr(a, "Record")
      fwdsrv_col = colptr(a, "fwd_Server")
      fwdprp_col = colptr(a, "fwd_Property")
      fwddat_col = colptr(a, "fwd_Data")
      hdr_done = True
    Else
      pmEvent(i).longExt = getcol(a, srv_col)
      pmEvent(i).trigger = getcol(a, nam_col)
      pmEvent(i).shortExt = getcol(a, ext_col)
      pmEvent(i).headerFile = getcol(a, hdr_col)
      pmEvent(i).recordLevel = Val(getcol(a, rec_col))
      pmEvent(i).fwdSrv = getcol(a, fwdsrv_col)
      pmEvent(i).fwdPrp = getcol(a, fwdprp_col)
      pmEvent(i).fwdData = Val(getcol(a, fwddat_col))
      
      ' read in the trigger file
      If Len(pmEvent(i).trigger) > 0 Then ' this had better be true !
        ' this will read the device files
        evnFileName = pname + "\..\CACHE\triggerFiles\" + pmEvent(i).trigger + ".csv"
        pmEvent(i).nPmSteps = readTriggerFile(evnFileName, pmEvent(i).pmSteps)
      End If
      
      If Len(pmEvent(i).headerFile) > 0 Then
        ' might have a header file
        hdrFileName = pname + "\..\CACHE\headerFiles\" + pmEvent(i).headerFile ' already has the .csv extension
        n = readHeaderFile(hdrFileName, pmEvent(i).pmSteps)
        If n = 0 Then pmEvent(i).headerFile = "" ' non-extent header file => remove the name
      End If
      i = i + 1
    End If
  End If
Loop While Not EOF(5)
Close 5

ArchiveDbForm.WriteProgress.Visible = False
readDataBase = i
End Function
Function readTriggerFile(evnFileName As String, steps() As ARB) As Integer
Dim i As Integer, k As Integer, n As Integer, nempty As Integer
Dim a As String, hdr As String, tok As String, tmpstr As String
Dim tag_col As Integer, prp_col As Integer, dev_col As Integer, arcprp_col As Integer, arctag_col As Integer
Dim siz_col As Integer, fmt_col As Integer, val_col As Integer, acc_col As Integer, wai_col As Integer
Dim to_col As Integer, sca_col As Integer, shf_col As Integer, con_col As Integer
Dim hdr_done As Boolean
Dim devFileName As String

i = getDatabaseSize(evnFileName)
If i <= 0 Then
  readTriggerFile = 0
  Exit Function
End If

ReDim steps(i - 1)
Open evnFileName For Input Access Read Shared As #2
i = 0
Do
  Line Input #2, a
  tok = Left$(a, 1)
  If Len(a) <> 0 And tok <> "%" And tok <> ";" And tok <> "#" Then
    If Not hdr_done Then
      con_col = colptr(a, "Context")
      tag_col = colptr(a, "Tag")
      prp_col = colptr(a, "Property")
      dev_col = colptr(a, "Device")
      arctag_col = colptr(a, "ArchiveTag")
      arcprp_col = colptr(a, "ArchiveProperty")
      siz_col = colptr(a, "Size")
      fmt_col = colptr(a, "Format")
      val_col = colptr(a, "Value")
      acc_col = colptr(a, "Access")
      wai_col = colptr(a, "Wait")
      to_col = colptr(a, "Timeout")
      sca_col = colptr(a, "Scale")
      shf_col = colptr(a, "Shift")
      hdr_done = True
    Else
      If con_col >= 0 Then
        steps(i).context = getcol(a, con_col)
      Else
        steps(i).context = ArchiveDbForm.dbContextText.text
      End If
      steps(i).srcTag = getcol(a, tag_col)
      steps(i).srcPrp = getcol(a, prp_col)
      steps(i).dev = getcol(a, dev_col)
      steps(i).arcPrp = getcol(a, arcprp_col)
      steps(i).arcTag = getcol(a, arctag_col)
      steps(i).siz = Val(getcol(a, siz_col))
      steps(i).fmt = getcol(a, fmt_col)
      steps(i).dataValue = Val(getcol(a, val_col))
      steps(i).devAccess = getcol(a, acc_col)
      tmpstr = UCase(steps(i).devAccess)
      If (tmpstr = "POLL") Or (tmpstr = "WAIT") Then
        steps(i).waitSecs = Val(getcol(a, wai_col))
      Else
        steps(i).waitSecs = 0
      End If
      If steps(i).srcTag = "" And steps(i).waitSecs = 0 Then
        ' This is a nonsensical empty step! Remove it!
        nempty = nempty + 1
      Else
        steps(i).notreadyTimeout = Val(getcol(a, to_col))
        steps(i).valueScale = Val(getcol(a, sca_col))
        steps(i).valueShift = Val(getcol(a, shf_col))
        ' read in the device files
        devFileName = ArchiveDbForm.dbPathCombo.text + "\..\CACHE\deviceFiles\" + steps(i).arcTag + "-devices.csv"
        If readDeviceFile(devFileName, steps(i).devList, steps(i).devAliasList) > 0 Then steps(i).useDevList = True
        i = i + 1
      End If
    End If
  End If
Loop While Not EOF(2)
Close 2

readTriggerFile = i

End Function
