Attribute VB_Name = "Alarm"
Option Explicit

Global Const almNEWALARM = &H1
Global Const almHEARTBEAT = &H2
Global Const almOSCILLATION = &H4
Global Const almDATACHANGE = &H8
Global Const almINSTANT = &H10
Global Const almTERMINATE = &H40
Global Const almTEST = &H80

Global NMachines As Integer
Global CAServerNames$(), CAServerContextNames$()
Global NDeviceRows%(2, 20)

Type AMS            ' Alarm Message Structure
tag(15) As Byte
device(15) As Byte
almTag(15) As Byte
alarmCode As Long
timestamp As Long
alarmMask As Long
alarmData(5) As Byte
alarmDataFormat As Byte  ' format as Byte => CF_<format> - CF_DOUBLE !!!!
alarmDataArraySize As Byte
severity As Byte
descriptor As Byte
alarmSystem As Integer
End Type

Type XAMS            ' Extended Alarm Message Structure (use with CAS only)
server(15) As Byte
device(15) As Byte
almText(39) As Byte
alarmCode As Long
timestamp As Long
alarmMask As Long
alarmSystem As Long
alarmData(7) As Byte
alarmDataFormat As Byte  ' format as Byte => CF_<format> - CF_DOUBLE !!!!
alarmDataArraySize As Byte
severity As Byte
descriptor As Byte
End Type

Type AMRB         ' Alarm Message Request Block
starttime As Long
stoptime As Long
severity As Long
reservered As Long
End Type

Type ASB        ' Alarm Status Block
nalarms As Long
mostRecentAlarmTime As Long
highestSeverity As Long
nalarmsAtMostRecentAlarmTime As Long
nalarmsAtHighestSeverity As Long
End Type

Type ADS
tag(15) As Byte
code As Long
mask As Long
severity As Integer
DataFormat As Byte ' format as Byte => CF_<format> - CF_DOUBLE !!!!
dataDim As Byte
timeRes As Long
hitsChannel As Integer
hitsModule As Integer
AlarmText(39) As Byte
deviceText(37) As Byte
alarmSystem As Integer
dataText(39) As Byte
url(39) As Byte
Reserved As Long
End Type

Type CASQS
devcontext(15) As Byte
devServer(15) As Byte
subsystem(15) As Byte
arcExt(15) As Byte
SeverityLevel As Long
ArchiveLevel As Long
Retention As Long
AlarmLevel As Long
alarmSystem As Long
End Type

Declare Function appendAlarmInfoTable Lib "tinesrv32.dll" (ByVal LocalName As String, localADS As ADS) As Integer
Declare Function SetMaximumAlarms Lib "tinesrv32.dll" (ByVal maxnum As Integer) As Integer
Declare Sub setAlarmWindow Lib "tinesrv32.dll" (ByVal AlarmRetentionWindow As Long)
Declare Function getAlarmWindow Lib "tinesrv32.dll" () As Long
Declare Sub setTerminationWindow Lib "tinesrv32.dll" (ByVal AlarmTerminationWindow As Long)
Declare Function getTerminationWindow Lib "tinesrv32.dll" () As Long
Declare Sub setAlarmHeartbeat Lib "tinesrv32.dll" (ByVal AlarmHeartbeat As Long)
Declare Function getAlarmHeartbeat Lib "tinesrv32.dll" () As Long

Type ALARM_WATCH_THRESHOLDS
  cnt As Long
  hi As Single
  hiwarn As Single
  lo As Single
  lowarn As Single
End Type

Declare Function appendAlarmWatchTable Lib "tinesrv32.dll" (ByVal LocalName As String, ByVal property As String, ByVal device As String, ByVal arraySize As Long, ByVal Format As Long, ByVal arrayType As Long, ByVal severity As Long, ByVal alarmSystem As Long, alarmThresh As ALARM_WATCH_THRESHOLDS)
Function getAlarmServerInfo(fname As String) As Integer
Dim i%, j%, p%, a$, tok$, done As Boolean
Dim con_col%, cas_col%
Dim fn$

fn$ = App.Path + "\" + fname

NMachines = getDatabaseSize(fn$)
If NMachines = 0 Then
  getAlarmServerInfo = 0
  Exit Function
End If

ReDim CAServerNames$(NMachines)
ReDim CAServerContextNames$(NMachines)

Open fn$ For Input Access Read Shared As #1
Do
  Line Input #1, a$
  tok$ = Left$(a$, 1)
  If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" And a$ <> "" Then
    If Not done Then
      con_col = colptr(a$, "CONTEXT")
      cas_col = colptr(a$, "ALARM SERVER")
      done = True
    Else
      CAServerNames$(i%) = getcol(a$, cas_col)
      CAServerContextNames$(i%) = getcol(a$, con_col)
      i% = i% + 1
      If i% >= NMachines Then Exit Do
    End If
  End If
Loop While Not EOF(1)
Close 1
getAlarmServerInfo = i%
End Function
Function getAlarmServerDisplayInfo(fname As String) As Integer
Dim i%, j%, p%, a$, tok$, done As Boolean
Dim con_col%, cas_col%, R1_col%, R2_col%, R3_col%
Dim fn$

fn$ = App.Path + "\" + fname

NMachines = getDatabaseSize(fn$)
If NMachines = 0 Then
  getAlarmServerDisplayInfo = 0
  Exit Function
End If

ReDim CAServerNames$(NMachines)
ReDim CAServerContextNames$(NMachines)

Open fn$ For Input Access Read Shared As #1
Do
  Line Input #1, a$
  tok$ = Left$(a$, 1)
  If tok$ <> "%" And tok$ <> ";" And tok$ <> "#" And a$ <> "" Then
    If Not done Then
      con_col = colptr(a$, "CONTEXT")
      cas_col = colptr(a$, "ALARM SERVER")
      
      ' For ALARM VIEWER!
      R1_col% = colptr(a$, "NDevR1")
      R2_col% = colptr(a$, "NDevR2")
      R3_col% = colptr(a$, "NDevR3")
      done = True
    Else
      CAServerNames$(i%) = getcol(a$, cas_col)
      CAServerContextNames$(i%) = getcol(a$, con_col)
      
      NDeviceRows%(0, i%) = Val(getcol(a$, R1_col%))
      NDeviceRows%(1, i%) = Val(getcol(a$, R2_col%))
      NDeviceRows%(2, i%) = Val(getcol(a$, R3_col%))
      
      i% = i% + 1
      If i% >= NMachines Then Exit Do
    End If
  End If
Loop While Not EOF(1)
Close 1
getAlarmServerDisplayInfo = i%
End Function


Function GetPMArchivedStruct(ByVal pmArchiveGroup$, ByVal evnTag$, ByVal devName$, ByVal devProperty$, ByVal npoints As Long, DataBuffer As AMS)
Dim dout As DBLK, din As DBLK
Dim apc As APCBLK
Dim rc&, p%, i%, dServerName$, dName$, evn As NAME8

Static SessionID As Integer
Static eventTag As String
Static pmArcGrp As String
Static done As Boolean

If pmArchiveServer$ = "" Then
 pmArchiveServer$ = "APC"
End If

If Not done Then
  FILLSTRUCT "APCBLK", Len(apc), 1, CF_NULL
  done = True
End If

rc& = 0
evnTag$ = LCase(evnTag$)
If eventTag <> evnTag Or pmArchiveGroup$ <> pmArcGrp Then ' new session
  eventTag = evnTag
  pmArcGrp = pmArchiveGroup$
  If SessionID% > 0 Then ' close it
    dout.dArrayLength = 0: dout.dFormat = CF_NULL
    din.dArrayLength = 1: din.dFormat = CF_SHORT
    rc& = T_EXECLINK(pmArchiveServer$ & "/" & pmArchiveGroup$, "CLOSE", dout, 0, din, SessionID%, 1, 1000)
    If rc& Then GoTo GetPMArchivedStructError
  End If
  If evnTag$ = "" Then GoTo GetPMArchivedStructError ' just close the current session
  dout.dArrayLength = 1: dout.dFormat = CF_SHORT
  din.dArrayLength = 1: din.dFormat = CF_NAME8
  BARR evn.nam(), evnTag$
  rc& = T_EXECLINK(pmArchiveServer$ & "/" & pmArchiveGroup$, "OPEN", dout, SessionID%, din, evn, 1, 1000)
  If rc& Then GoTo GetPMArchivedStructError
End If
If eventTag = "" Then GoTo GetPMArchivedStructError

p% = InStr(devName$, "/")
If p% = 0 Then
  dServerName$ = devName$
  dName$ = "#0"
Else
  dServerName$ = Left$(devName$, p% - 1)
  dName$ = Right$(devName$, Len(devName$) - p%)
End If

apc.SessionID = SessionID%
BARR apc.EqpName(), dServerName$
BARR apc.devName(), dName$
BARR apc.devProperty(), devProperty$
din.dArrayLength = 1
din.dFormat = CF_STRUCT
BARR din.dTag(), "APCBLK"

dout.dArrayLength = npoints
dout.dFormat = CF_STRUCT
rc& = T_EXECLINK(pmArchiveServer$, "READDATA", dout, DataBuffer, din, apc, 1, 1000)
If rc& Then GoTo GetPMArchivedStructError

GetPMArchivedStructError:
GetPMArchivedStruct = rc&
End Function


Function GetAlarmDefinitions(devServer As String, adefs() As ADS, nadefs As Integer) As Integer
Dim devName$, MYrc%, i%, n%
Dim dout As DBLK, din As DBLK
' ADD OPTIONAL TIMEOUT BECAUSE SO MANY LINK-NOT-OPEN!
dout.dArrayLength = 1: dout.dFormat = CF_SHORT
din.dArrayLength = 0: din.dFormat = CF_NULL
MYrc% = T_EXECLINK(devServer, "NALMDEFS", dout, n%, din, 0, CA_READ, 200)
If MYrc% = 45 Then
    dout.dArrayLength = 1: dout.dFormat = CF_SHORT
    din.dArrayLength = 0: din.dFormat = CF_NULL
    MYrc% = T_EXECLINK(devServer, "NALMDEFS", dout, n%, din, 0, CA_READ, 600)
End If
'If n% > 163 Then n% = 163 ' Phil's limit... because of DOS FECs, memory/data transfer limits...

If n% > 500 Then
    MsgBox " Too many alarm definitions! The Server (" + devServer$ + ") has " + STR$(n%) + " alarms!" + _
            " Truncating list to 500."
    n% = 500
End If
If MYrc% Or n% = 0 Then
    'Debug.Print
    GoTo GetAlarmDefinitionsError
End If
ReDim adefs(n%)

'Debug.Print devServer + ": Reading ALM definitions: rc, n: " + str$(MYrc%), str$(n%)
'dout.dArrayLength = n * Len(adefs(0)): dout.dFormat = CF_STRUCT
dout.dArrayLength = CLng(n%) * Len(adefs(0)): dout.dFormat = CF_STRUCT
MYrc% = T_EXECLINK(devServer, "ALMDEFS", dout, adefs(0), din, 0, CA_READ, 200)
If MYrc% = 45 Then
    DoEvents
    dout.dArrayLength = CLng(n%) * Len(adefs(0)): dout.dFormat = CF_STRUCT
    MYrc% = T_EXECLINK(devServer, "ALMDEFS", dout, adefs(0), din, 0, CA_READ, 800)
End If
If MYrc% Then
    GoTo GetAlarmDefinitionsError
End If
nadefs = n%
GetAlarmDefinitions = MYrc%
Exit Function

GetAlarmDefinitionsError:
nadefs = n%
GetAlarmDefinitions = MYrc%
Debug.Print "GetAlarmDefinitions = " + STR$(MYrc%)
End Function

Public Sub CopyAMSintoXAMS(TableAMS() As AMS, IndexAMS%, TableXAMS() As XAMS, IndexXAMS%, NElements%)
Dim i%
' For ARCHIVE DATA:
For i% = 0 To NElements% - 1
    With TableAMS(i% + IndexAMS%)
        Call MEMCPY(TableXAMS(i% + IndexXAMS%).server(0), .tag(0), 16)
        Call MEMCPY(TableXAMS(i% + IndexXAMS%).device(0), .device(0), 16)
        
        ' Just copy it in - or get it in a call?
        Call MEMCPY(TableXAMS(i% + IndexXAMS%).almText(0), .almTag(0), 16)
        Call MEMCPY(TableXAMS(i% + IndexXAMS%).alarmData(0), .alarmData(0), 6)
        
        TableXAMS(i% + IndexXAMS%).alarmCode = .alarmCode
        TableXAMS(i% + IndexXAMS%).timestamp = .timestamp
        TableXAMS(i% + IndexXAMS%).alarmMask = .alarmMask
        TableXAMS(i% + IndexXAMS%).alarmDataFormat = .alarmDataFormat
        TableXAMS(i% + IndexXAMS%).alarmDataArraySize = .alarmDataArraySize
        TableXAMS(i% + IndexXAMS%).severity = .severity
        TableXAMS(i% + IndexXAMS%).descriptor = .descriptor
        TableXAMS(i% + IndexXAMS%).alarmSystem = .alarmSystem
    
        Debug.Print ASCTIME(.timestamp)
    End With
Next i%

Debug.Print

'Type AMS            ' Alarm Message Structure
'tag(15) As Byte - is SERVER
'device(15) As Byte
'almTag(15) As Byte - is SHORT TEXT!
'alarmCode As Long
'timestamp As Long
'alarmMask As Long
'alarmData(5) As Byte
'alarmDataFormat As Byte  ' format as Byte => CF_<format> - CF_DOUBLE !!!!
'alarmDataArraySize As Byte
'severity As Byte
'descriptor As Byte
'alarmSystem As Integer
'End Type
'
'Type XAMS            ' Extended Alarm Message Structure (use with CAS only)
'server(15) As Byte
'device(15) As Byte
'almText(39) As Byte

'alarmCode As Long
'timestamp As Long
'alarmMask As Long
'alarmData(7) As Byte
'alarmDataFormat As Byte  ' format as Byte => CF_<format> - CF_DOUBLE !!!!
'alarmDataArraySize As Byte
'severity As Byte
'descriptor As Byte
'alarmSystem As Long
'End Type

End Sub

