#ifndef _ACOPDLL_H_
#define _ACOPDLL_H_

#ifndef STD_TIMEZONE_STR
# define STD_TIMEZONE_STR "CET"
#endif
#ifndef DST_TIMEZONE_STR
# define DST_TIMEZONE_STR "CDT"
#endif

#define ACOPQUERYMEMPOOLSIZE 0x4000

#define EXECUTE_METHOD	1
#define ATTACH_METHOD	2
#define DETACH_METHOD	3
#define GETDATA_METHOD	4

typedef struct 
{
	HGLOBAL hMem;
	long type; // is VT_EMPTY ptr is now byte array for cust formats
	long arraySize;
	long blockSize;
	LPSTR custFormat;
}DTYPE;

typedef struct 
{
	short MethodType;
  short TimeStampMSec;
	LPSTR DeviceContext;
	LPSTR DeviceGroup;
	LPSTR DeviceName;
	LPSTR DeviceProperty;
	LPSTR AccessMode;
	LPSTR AccessRate;
	LPSTR AccessProtocol;
	DTYPE Data;
	DTYPE DataEx;
	LPSTR Status;
	long StatusCode;
	long TimeStamp;
	long hLink;
  long hId;
	short Pending;
	short Grouped;
  short DataChanged;
  short DataCheck;
  float toleranceAbs;
  float tolerancePct;
	void (*callBack)(long hLink);
}DevStruct;

#ifdef __cplusplus
#define F_PREFIX extern "C"
#else
#define F_PREFIX extern
#endif

F_PREFIX void WINAPI InitAcopDll(void);
F_PREFIX long WINAPI DevRequest(DevStruct *ds);
F_PREFIX long WINAPI QueryStockAccessModes(LPSTR *modeArray);
F_PREFIX long WINAPI QueryDataBlockSize(long dimension,char *fmtstr);
F_PREFIX long WINAPI QueryDefaultAccessProtocol(LPSTR *protocol);
F_PREFIX long WINAPI QueryDeviceContextInformation(LPSTR aProtocol,LPSTR *dContexts,LPSTR *dGroups,LPSTR *dNames,LPSTR *dProps);
F_PREFIX long WINAPI QueryDevicePropertyInformation(LPSTR aProtocol,LPSTR *dContexts,LPSTR *dGroups,LPSTR *dNames,LPSTR *dProps);
F_PREFIX long WINAPI QueryDeviceNameInformation(LPSTR aProtocol,LPSTR *dContexts,LPSTR *dGroups,LPSTR *dNames,LPSTR *dProps);
F_PREFIX long WINAPI QueryDeviceGroupInformation(LPSTR aProtocol,LPSTR *dContexts,LPSTR *dGroups,LPSTR *dNames,LPSTR *dProps);
F_PREFIX long WINAPI QueryDeviceEGUInformation(LPSTR aProtocol,LPSTR dContext,LPSTR dGroup,LPSTR dName,LPSTR dProp,
									  float *yMin,float *yMax,LPSTR egu,int *graphStyle);

#endif
