#ifndef _TINE_H_
#define _TINE_H_

typedef struct
{
  UINT32 dArrayLength;
  short  dFormat;
  short  reserved;
  char   dTag[8];
} DBLK;

typedef struct
{
  void *data;
  void *dataStatic;
  char name[16];
  long timestamp;
  float tolerance;
  UINT16 dArrayLength;
  short dFormat;
  short id;
  short compCode;
  UINT32 dByteLength;
  short acquire;
} GBLK;

typedef struct
{
  char name[16];
} NAME16;

typedef struct
{
  char name[32];
} NAME32;

#define MAXGLB 25
#define GLBHEARTBEAT 60
extern GBLK gblk[MAXGLB];
extern int nglobals;
__declspec(dllimport) short LINKDATA(HWND hVBWnd, char *name, short EqNo,
                                     char *prop, long timer, short size, short format,short mode);
__declspec(dllimport) short CLOSELINK(HWND hVBWnd, short i);
__declspec(dllimport) short PASCAL CLOSERPC(HWND hVBWnd, short i);
__declspec(dllimport) short CHANGEMODE(short id, short mode);
__declspec(dllimport) short PASCAL GETRPCDATA(short i, void *buf,time_t *timestamp);
__declspec(dllimport) short PASCAL GETRPCDATAEx(short i, void *buf,time_t *timestamp,long *datasize);
__declspec(dllimport) short PASCAL GetRPCDataAndTime(short i, void *buf,double *dtimestamp,long *datasize);
__declspec(dllimport) short PASCAL PUTRPC(short i, void *buf);
__declspec(dllimport) short CHANGEMODE(short i, short mode);
__declspec(dllimport) short PASCAL RPC(char *name,short EqNo,char *prop,short size,
                                       void *data,short datasize,short format);
__declspec(dllimport) time_t RPCtimestamp;
__declspec(dllimport) double PASCAL T_GETDATATIMESTAMP(void);
__declspec(dllimport) short PASCAL RPCERR(short err, char  *errstr);
__declspec(dllimport) short OPENLINK (HWND hWnd,char *devname,char *devprop,
                                      DBLK *dout,DBLK *din,void *datain,
                                      short access,long timer,short mode);
__declspec(dllimport) int AttachLink(char *devName,char *devprop,
                                      DTYPE *dout,DTYPE *din,short access,int pollrate,
                                      void (*callback)(int,int),int mode);
__declspec(dllimport) short PASCAL EXECLINK (char *devname,char *devprop,
                                      DBLK *dout,void *dataout,DBLK *din,void *datain,short access);
__declspec(dllimport) short PASCAL EXECLINKEx (char *devname,char *devprop,
                                        DBLK *dout,void *dataout,DBLK *din,void *datain,
                                        short access,long timeout);
__declspec(dllimport) short ExecLinkEx(char *devName,char *devProperty,DTYPE *dout,DTYPE *din,short access,long pollrate);
__declspec(dllimport) short PASCAL RPCGETLASTERR(char *errstr);
__declspec(dllimport) short PASCAL RPCGETLASTERROR(char *errstr);
__declspec(dllimport) long PASCAL GETSTRUCTSIZE (char *tag);
__declspec(dllimport) short PASCAL GETGLOBAL(char *keyword, void *VBbuf, short size, short format);
__declspec(dllimport) short GETGLOBALID(char *keyword);
__declspec(dllimport) short GetContexts(NAME16 *contexts,int *bufsiz);
__declspec(dllimport) short GetDeviceServers(NAME16 *context,NAME16 *servers,int *bufsiz);
__declspec(dllimport) short GetDeviceNames(NAME16 *context,NAME16 *server,NAME16 *names,NAME32 *property,int *bufsiz);
__declspec(dllimport) short GetDeviceProperties(NAME16 *context,NAME16 *server,NAME16 *name,NAME32 *properties,int *bufsiz);
__declspec(dllimport) short GetDeviceEGU(NAME16 *context,NAME16 *server,NAME16 *name,NAME32 *property,float *min,float *max,char *egu);
__declspec(dllimport) short PutRPCErrorValue (short i, void *errValue);
__declspec(dllimport) short PASCAL SetNotificationTolerance(int i, float toleranceAbsolute, float tolerancePercent);
__declspec(dllimport) short PASCAL GetDataAndTime(short i, void *buf,double *dtimestamp,long *datasize,int *status);

#endif // _TINE_H_