#ifndef _RPCDEFS_H_
#define _RPCDEFS_H_

#ifndef DELIMITER
#define DELIMITER "/\\"
#endif

#ifndef MAX
#define MAX(a,b)  ((a) > (b) ? a : b)
#endif
#ifndef MIN
#define MIN(a,b)  ((a) < (b) ? a : b)
#endif
#ifndef BYTE
#define BYTE unsigned char
#endif
#ifndef WORD
#define WORD unsigned short
#endif
#ifndef DWORD
#define DWORD unsigned long
#endif
#ifndef UINT8
#define UINT8 unsigned char
#endif
#ifndef UINT16
#define UINT16 unsigned short
#endif
#ifndef UINT32
#define UINT32 unsigned long
#endif

#ifndef TRUE
#define TRUE -1
#endif
#ifndef FALSE
#define FALSE 0
#endif

#undef CF_TEXT
#define CF_DOUBLE   512
#define CF_SHORT    513
#define CF_INTEGER  513
#define CF_BYTE     514
#define CF_LONG     515
#define CF_TEXT     516
#define CF_FLOAT    517

#undef CF_NULL
#define CF_NULL     767

#define getFormatSize(fmt)\
 ( fmt == CF_DOUBLE  ? 8 :\
   fmt == CF_SHORT   ? 2 :\
   fmt == CF_BYTE    ? 1 :\
   fmt == CF_LONG    ? 4 :\
   fmt == CF_FLOAT   ? 4 :\
   fmt == CF_TEXT    ? 1 : 0 )

#define getFormatType(txt) (\
	!strcmp(txt,"BYTE")     ? CF_BYTE :\
	!strcmp(txt,"SHORT")    ? CF_SHORT :\
	!strcmp(txt,"INTEGER")  ? CF_SHORT :\
	!strcmp(txt,"LONG")     ? CF_LONG :\
	!strcmp(txt,"FLOAT")    ? CF_FLOAT :\
	!strcmp(txt,"SINGLE")   ? CF_FLOAT :\
	!strcmp(txt,"DOUBLE")   ? CF_DOUBLE :\
    CF_NULL )

#define CM_NULL         0x00
#define CM_CANCEL       0x00
#define CM_SINGLE       0x01
#define CM_REFRESH      0x02
#define CM_POLL         0x03
#define CM_REGISTER     0x04
#define CM_RECEIVE      0x05
#define CM_NODUPLICATES 0x10
#define CM_BCAST        0x100
#define CM_NETWORK      0x200
#define CM_MCAST        0x200
#define CM_USE_ON_ERROR 0x400
#define CM_RETRY        0x800
#define CM_GROUPED      0x1000
#define CM_CONNECT      0x2000
#define CM_WAIT         0x4000
#define CM_SYNCNOTIFY   0x8000

#define BASEMODE(m) ((m) & 0xff)

#define getAccessMode(txt) (\
 	strstr(txt,"READ")    ? CM_SINGLE :\
	strstr(txt,"WRITE")   ? CM_SINGLE :\
	strstr(txt,"SINGLE")  ? CM_SINGLE :\
	strstr(txt,"REFRESH") ? CM_REFRESH :\
	strstr(txt,"POLL")    ? CM_POLL :\
	strstr(txt,"REGISTER")? CM_REGISTER :\
	strstr(txt,"RECEIVE")? CM_RECEIVE :\
	CM_CANCEL )

#define getAccessScope(txt) (\
	strstr(txt,"NETWORK")  ? CM_MCAST :\
	strstr(txt,"CONNECT")  ? CM_CONNECT :\
	CM_NULL )

#define CA_NULL         0x00
#define CA_READ         0x01
#define CA_WRITE        0x02
#define CA_ASYNC        0x04
#define CA_SYNC         0x08
#define CA_FIRST        0x40
#define CA_LAST         0x80

#define getAccessType(txt) ( strstr(txt,"WRITE") != NULL ? CA_WRITE : CA_READ )

#endif // _RPCDEFS_H_
