#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include "extcode.h"

__declspec(dllexport) short PASCAL RegisterServerNotifierEx(char *prpName, void (*nf)(int), int nid);
__declspec(dllexport) short PASCAL RegisterServerNotifier(char *prpName, void (*nf)(int));
__declspec(dllimport) short PASCAL RegisterServerCallback(char *prpName, void (*cb)(void));
__declspec(dllimport) short tAttachNotifier(char *fullDeviceNameAndProperty, void (*nf)(int), int nid);
__declspec(dllimport) void tDetachNotifier(void (*nf)(int));

DWORD __cdecl GetLVAppWindHandle(HWND *handle);

#define MAXNOTIFIERS 256
typedef struct NotifierTableStruct
{
  int index;
  LVRefNum lvOccurrence;
} NotifierTable;
NotifierTable notifiers[MAXNOTIFIERS];

int initNotifierTable(void)
{
  int i;
  for (i=0; i<MAXNOTIFIERS; i++) notifiers[i].index = -1;
  return 0;
}
int getNotifierIndex(void)
{
  int i;
  for (i=0; i<MAXNOTIFIERS; i++) 
  {
    if (notifiers[i].index == -1) 
    {
      notifiers[i].index = i;
      return i;
    }
  }
  return -1;
}
int freeNotifierIndex(int index)
{
  if (index <0 || index >= MAXNOTIFIERS) return -1;
  notifiers[index].index = -1;
  return 0;
}

LVRefNum gLvOccurrence;
DWORD WM_SET_OCCURRENCE;
HWND hLVWnd;
int initialized = 0;

void lvTineNotifyCallback(int nid)
{
  if (initialized) 
  {
    //PostMessage(hLVWnd, WM_SET_OCCURRENCE, 0, (long)gLvOccurrence);
    PostMessage(hLVWnd, WM_SET_OCCURRENCE, 0, (long)notifiers[nid].lvOccurrence);
  }
}
__declspec(dllexport) short PASCAL RegisterServerOccurrence(char *prpName,LVRefNum *refNum)
{
  int nid = getNotifierIndex();
  if (nid < 0) return -1;
  initialized = -1;
  notifiers[nid].lvOccurrence = *refNum;
  gLvOccurrence = *refNum;
  return RegisterServerNotifierEx(prpName,lvTineNotifyCallback,nid);
}
__declspec(dllexport) short PASCAL RegisterClientOccurrence(char *fullDeviceNameAndProperty,LVRefNum *refNum)
{
  int nid = getNotifierIndex();
  if (nid < 0) return -1;
  initialized = -1;
  notifiers[nid].lvOccurrence = *refNum;
  return tAttachNotifier(fullDeviceNameAndProperty,lvTineNotifyCallback,nid);
}

BOOL WINAPI DllMain(HINSTANCE hInstDll,DWORD fdwReason,LPVOID lpvReserved)
{
	switch (fdwReason)
	{
	 case DLL_PROCESS_ATTACH:  // DLL being loaded
      initNotifierTable();
      WM_SET_OCCURRENCE = GetLVAppWindHandle(&hLVWnd);
			break;
	 case DLL_THREAD_ATTACH:
			break;
	 case DLL_THREAD_DETACH:
			break;
	 case DLL_PROCESS_DETACH:  // DLL being unloaded
      tDetachNotifier(lvTineNotifyCallback);
			break;
  }
  return (TRUE);
}
