#include "project.def"
#include <stdio.h>
#include <windows.h>
#include <string.h>
#include <stdlib.h>
#include <malloc.h>
#include <ctype.h>
#include <sys/timeb.h>
#include <time.h>
#include <winsock.h>
#include <wsipx.h>
#include <wsnwlink.h>
#include "MeteredSection.h"
#include "errors.h"
#include "database.h"
#include "rpcsrv.h"
#ifdef USE_SHARED_MEMORY
# include "mmfshare.h"
#else
# include "rpcalloc.h"
#endif

static int nStdContracts = 0;
ElemDataStruct *stdContractAlloc(char *tag,int sizeIn,int sizeOut)
{
  ElemDataStruct *e = NULL;
  unsigned int contractSize;
  char msg[80];
  static int i = 1;

  if (link[i].active > 0 && !strncmp(tag,link[i].linkTag,128)) return link[i].Elem;
	for (i=1; i<MAXHOTLINKS; i++)
  {
    if (link[i].active > 0 && !strncmp(tag,link[i].linkTag,128)) return link[i].Elem;
  }
  if (nStdContracts > MAXHOTLINKS) return NULL;
  contractSize = sizeof(ElemDataStruct) + sizeIn + sizeOut;
  if (sizeIn % 2) contractSize++;
  if (sizeOut % 2) contractSize++;
  if ((e=calloc(1,contractSize)) == NULL)
  {
    sprintf(msg,"alloc error: %s",tag);
    MessageBox(NULL,msg,"",IDOK);
  }
  nStdContracts++;
  return e;
}
BYTE *stdDataBlockAlloc(char *tag,int size)
{
  BYTE *d = NULL;
  char msg[80];

  if ((d=calloc(1,size)) == NULL)
  {
	 sprintf(msg,"alloc error: %s",tag);
	 MessageBox(NULL,msg,"",IDOK);
  }
  return d;
}
LCLCONTRACT *lclStdContractAlloc(char *tag)
{
  static LCLCONTRACT lc;
  return &lc;
}
void stdContractFree(ElemDataStruct *e)
{
  if (e == NULL) return;
  free(e);
  nStdContracts--;
}
void stdDataBlockFree(BYTE *d)
{
  if (d == NULL) return;
  free(d);
}
void lclStdContractFree(LCLCONTRACT *lc)
{
  return;
}
