#define AssignStructDataPtr(dptr,sptr,dir) { dptr = sptr;\
  switch (dir) {\
    case RTOL: i = con->contract.EqpSizeIn;\
               if ((s=getStructFromTag(con->contract.strTagIn)) == NULL) break;\
               if ((i=i/s->rawlen) > s->num) ccerr(out_of_range);\
               if (con->contract.EqpSizeIn%s->rawlen) ccerr(argument_list_error);\
               break;\
    case LTOR: i = con->contract.EqpSizeOut;\
               if ((s=getStructFromTag(con->contract.strTagOut)) == NULL) break;\
               if ((i=i/s->rawlen) > s->num) ccerr(out_of_range);\
               if (con->contract.EqpSizeOut%s->rawlen) ccerr(argument_list_error);\
               break;\
    case NONE: i = con->contract.EqpSizeOut;\
               if ((s=getStructFromTag(con->contract.strTagOut)) == NULL) break;\
               if ((i=i/s->rawlen) > s->num) ccerr(out_of_range);\
               if (con->contract.EqpSizeOut%s->rawlen) ccerr(argument_list_error);\
               break;\
  }\
}

#define PrepPCHeader(pD,cns,con) {\
  if ((cns)->client->protocol == 4) {\
    Pheader = (ProducerHeaderStruct4 *)pD;\
    Pheader->msgsize        = msgsize;\
    Pheader->CompletionCode = (cns)->status.statusCode;\
    Pheader->timestamp      = RPCtimestamp;\
    Pheader->starttime      = (cns)->status.starttime;\
    Pheader->SubscriptionID = (cns)->status.id;\
    Pheader->counter        = (cns)->status.counter;\
  }\
  else {\
    PheaderEx = (ProducerHeaderStruct *)pD;\
    PheaderEx->msgsize        = msgsize;\
    PheaderEx->CompletionCode = (cns)->status.statusCode;\
    PheaderEx->timestampMSEC  = RPCtimestampMSEC;\
    PheaderEx->EqpFormat      = (con).EqpFormatOut;\
    PheaderEx->timestamp      = RPCtimestamp;\
    PheaderEx->ClnStarttime   = (cns)->status.starttime;\
    PheaderEx->SubscriptionID = (cns)->status.id;\
    PheaderEx->counter        = (BYTE)(cns)->status.counter;\
    PheaderEx->blknum         = (cns)->status.blknum;\
    PheaderEx->numblks        = (cns)->status.numblks;\
    PheaderEx->mtu            = (cns)->status.mtu;\
  }\
}

#define PrepSubHeader(p,dat) {\
  if (p == 4) {\
    reg = (struct subscription4 *)dat;\
    memset(regEx,0,sizeof(struct subscription));\
    regEx->msgsize = reg->msgsize;\
    regEx->PollingRate = reg->PollingRate;\
    regEx->id = reg->id;\
    regEx->mode = reg->mode;\
    regEx->starttime = reg->starttime;\
    regEx->numblks = 1;\
    regEx->blknum = 1;\
    regEx->mtu = reg->msgsize;\
    strncpy(regEx->contract.EqpName,reg->contract.EqpName,8);\
    strncpy(regEx->contract.EqpProperty,reg->contract.Property,12);\
    regEx->contract.EqpSizeOut = abs(reg->contract.EqpSize);\
    regEx->contract.EqpSizeIn = reg->contract.EqpSize < 0 ? abs(reg->contract.EqpSize): 0;\
    regEx->contract.EqpAccess = reg->contract.EqpSize < 0 ? CA_WRITE|CA_READ : CA_READ;\
    if (reg->contract.EqpFormat == 1) reg->contract.EqpFormat = CF_TEXT;\
    regEx->contract.EqpFormatOut = BFMT(reg->contract.EqpFormat);\
    regEx->contract.EqpFormatIn = reg->contract.EqpSize < 0 ? regEx->contract.EqpFormatOut : BFMT(CF_NULL);\
    sprintf(regEx->contract.EqpDeviceName,"#%d",reg->contract.EqpNumber);\
  }\
  else regEx = (struct subscription *)dat;\
}

#define AssignOutgoingSubscription(p,buf) {\
 if (p == 4) {\
   s = (struct subscription4 *)buf;\
   s->msgsize = SUBSCRIPTION4_SIZE + dsize;\
   s->PollingRate = 0;\
   s->id = 0;\
   s->mode = SINGLE;\
   s->starttime = time(NULL);\
   strncpy(s->contract.EqpName,name,EQP_NAME_SIZE);\
   strncpy(s->contract.Property,prop,12);\
   s->contract.EqpSize = sizeOut;\
   if (access & CA_WRITE) s->contract.EqpSize *= -1;\
   s->contract.EqpFormat = formatOut;\
   s->contract.EqpNumber = EqNo;\
 } else {\
   sEx = (struct subscription *)buf;\
   sEx->msgsize = SUBSCRIPTION_SIZE + dsize;\
   sEx->PollingRate = 0;\
   sEx->id = 0;\
   sEx->blknum = 1;\
   sEx->numblks = 1;\
   sEx->blkid = 0;\
   sEx->mtu = IPX_BUFFER_SIZE-SUBSCRIPTION_SIZE-HEADERSTRUCT_SIZE;\
   sEx->mode = SINGLE;\
   sEx->starttime = time(NULL);\
   strncpy(sEx->contract.EqpName,name,EQP_NAME_SIZE);\
   strncpy(sEx->contract.EqpProperty,prop,EQP_PROP_SIZE);\
   strncpy(sEx->contract.EqpDeviceName,dev,EQP_DEVICE_SIZE);\
   sEx->contract.EqpSizeOut = sizeOut;\
   sEx->contract.EqpSizeIn = sizeIn;\
   sEx->contract.EqpAccess = (BYTE)access;\
   sEx->contract.EqpFormatOut = (BYTE)BFMT(formatOut);\
   sEx->contract.EqpFormatIn = (BYTE)BFMT(formatIn);\
   strncpy(sEx->contract.strTagIn,"",8);\
   strncpy(sEx->contract.strTagOut,"",8);\
 }\
}
#define PrepIncomingSubscription(p,dat) {\
 if (p == 4) {\
   Pheader = (ProducerHeaderStruct4 *)dat;\
   PheaderEx->msgsize = Pheader->msgsize;\
   PheaderEx->SubscriptionID = Pheader->SubscriptionID;\
   PheaderEx->numblks = 1;\
   PheaderEx->blknum  = 1;\
   PheaderEx->mtu = UDP_BUFFER_SIZE;\
   PheaderEx->timestampMSEC = 0;\
   PheaderEx->CompletionCode = Pheader->CompletionCode;\
   PheaderEx->EqpFormat = (BYTE)BFMT(formatOut);\
   PheaderEx->counter = (BYTE)Pheader->counter;\
   PheaderEx->timestamp = Pheader->timestamp;\
   PheaderEx->ClnStarttime = Pheader->starttime;\
 }\
 else PheaderEx = (ProducerHeaderStruct *)dat;\
}

