#include "project.def"
#include <windows.h>
#include <windowsx.h>
#include <stdlib.h>
#include <stdio.h>
#include <malloc.h>
#include <ctype.h>
#include <time.h>
#include "errors.h"
#include "database.h"
#include "shmalloc.h"

SECURITY_ATTRIBUTES mmfSA;

HANDLE mmfalloc(char *tag,int SizeInBytes,BYTE **lpView,int *mmfFlag)
{
  HANDLE hFileMap;
  int MMFattached = 0;
  char msg[256];
  static int done = 0;

  if (!done)
  {
    done = TRUE;
    mmfSA.nLength = sizeof(mmfSA);
    mmfSA.lpSecurityDescriptor = NULL;
    mmfSA.bInheritHandle = TRUE;
  }

  if (tag == NULL || strlen(tag) == 0) return NULL;
  if ((hFileMap=CreateFileMapping(hSHARE,&mmfSA,PAGE_READWRITE,0,SizeInBytes,tag)) != NULL)
  {
    MMFattached = (GetLastError() == ERROR_ALREADY_EXISTS);
    if ((*lpView=(BYTE *)MapViewOfFile(hFileMap,FILE_MAP_WRITE,0,0,0)) == NULL)
    {
      sprintf(msg,"mmfalloc shm error: %s (%x)",tag,GetLastError());
      MessageBox(NULL,msg,"",IDOK);
      CloseHandle(hFileMap);
      return NULL;
    }
  }
  if (mmfFlag) *mmfFlag = MMFattached;
  return hFileMap;
}

int mmfInit(void)
{
  mmfSA.nLength = sizeof(mmfSA);
  mmfSA.lpSecurityDescriptor = NULL;
  mmfSA.bInheritHandle = TRUE;
  return 0;
}
extern HANDLE hDLLWnd;
int shmSndDataGram(char *tag,BYTE *data,int size,HANDLE *h)
{
  shmDataGram *dg = NULL;
  int cc,rsize,MMFattached=0;
  char *c, msg[256];
  HANDLE hWnd;

  if ((c=strchr(tag,':')) == NULL) return -1; c++;
  hWnd = (HANDLE)atoi(c);
  rsize = sizeof(shmDataGram) + size;

  if ((*h=mmfalloc(tag,rsize,(BYTE **)&dg,&MMFattached)) == NULL)
  {
    sprintf(msg,"shmSndDataGram error: %s (%x)",tag,GetLastError());
    MessageBox(NULL,msg,"",IDOK);
    *h = 0;
    return -1;
  }
  dg->payload = (BYTE *)dg + 28;
  memcpy(dg->payload,data,size);
  dg->size = size;
  dg->dirty = TRUE;
  cc = SendMessage(hWnd,WM_READ_LCL,size,(long)hDLLWnd);
  if (MMFattached) shmFreeDataGram(dg,*h);
  return cc;
}
shmDataGram *shmGetDataGram(char *tag,int size,HANDLE *h)
{
  shmDataGram *dg = NULL;
  int rsize,MMFattached=0;
  char msg[256];

  rsize = sizeof(shmDataGram) + size;

  if ((*h=mmfalloc(tag,rsize,(BYTE **)&dg,&MMFattached)) == NULL)
  {
    sprintf(msg,"shmGetDataGram shm error: %s (%x)",tag,GetLastError());
    MessageBox(NULL,msg,"",IDOK);
    *h = 0;
    return NULL;
  }
  dg->payload = (BYTE *)dg + 28;
  return dg;
}
void shmFreeDataGram(shmDataGram *dg,HANDLE h)
{
  if (h == 0) return;
  UnmapViewOfFile(dg);
  CloseHandle(h);
}
BYTE *shmDataBlockAlloc(char *tag,int size,HANDLE *hBlock)
{
  BYTE *d = NULL;
  int MMFattached=0;
  char msg[256];

  if ((*hBlock=mmfalloc(tag,size,&d,&MMFattached)) == NULL)
  {
	 sprintf(msg,"shm error: %s",tag);
	 MessageBox(NULL,msg,"",IDOK);
	 *hBlock = 0;
	 return NULL;
  }
  return d;
}
void shmDataBlockFree(BYTE *d,HANDLE hBlock)
{
  if (hBlock == 0) return;
  UnmapViewOfFile(d);
  CloseHandle(hBlock);
}
