Attribute VB_Name = "screenShot"
' this code here is a part of a bigger program, posted by CL (I do not know, who CL is)
' to:  http://www.visualbasicforum.com
' I took only some  procedures, which were needed to obtian a screen shot.
' Karol, 30.05.2005.

Option Explicit

Const RC_PALETTE As Long = &H100
'what's the size of the palette?
Const SIZEPALETTE As Long = 104
'device have raster capabilities?
Const RASTERCAPS As Long = 38

'individual entry in a LOGPALETTE palPalEntry
Private Type PALETTEENTRY
    peRed As Byte
    peGreen As Byte
    peBlue As Byte
    peFlags As Byte
End Type

'array of colors that is available to the output device
Private Type LOGPALETTE
    palVersion As Integer
    palNumEntries As Integer
    palPalEntry(255) As PALETTEENTRY ' Enough for 256 colors
End Type

'Globally Unique ID
Private Type GUID
    Data1 As Long
    Data2 As Integer
    Data3 As Integer
    Data4(7) As Byte
End Type

'Structure to define a bitmap picture
Private Type PicBmp
    size As Long
    Type As Long
    hBmp As Long
    hPal As Long
    Reserved As Long
End Type

'creates a new picture object initialized according to a PICTDESC structure
Public Declare Function OleCreatePictureIndirect Lib "olepro32.dll" (PicDesc As PicBmp, RefIID As GUID, ByVal fPictureOwnsHandle As Long, IPic As IPicture) As Long
'creates a memory device context (DC) compatible with the specified device
Public Declare Function CreateCompatibleDC Lib "GDI32" (ByVal hdc As Long) As Long
'creates a bitmap compatible with the device that is associated with the specified device context
Public Declare Function CreateCompatibleBitmap Lib "GDI32" (ByVal hdc As Long, ByVal nWidth As Long, ByVal nHeight As Long) As Long
'selects an object into the specified device context
Public Declare Function SelectObject Lib "GDI32" (ByVal hdc As Long, ByVal hObject As Long) As Long
'retrieves device-specific information about a specified device
Public Declare Function GetDeviceCaps Lib "GDI32" (ByVal hdc As Long, ByVal iCapabilitiy As Long) As Long
'retrieves a range of palette entries from the system palette that is associated with the specified device context
Public Declare Function GetSystemPaletteEntries Lib "GDI32" (ByVal hdc As Long, ByVal wStartIndex As Long, ByVal wNumEntries As Long, lpPaletteEntries As PALETTEENTRY) As Long
'creates a logical color palette
Public Declare Function CreatePalette Lib "GDI32" (lpLogPalette As LOGPALETTE) As Long
'selects the specified logical palette into a device context
Public Declare Function SelectPalette Lib "GDI32" (ByVal hdc As Long, ByVal hPalette As Long, ByVal bForceBackground As Long) As Long
'maps palette entries from the current logical palette to the system palette
Public Declare Function RealizePalette Lib "GDI32" (ByVal hdc As Long) As Long
'performs a bit-block transfer of the color data corresponding to a rectangle of pixels from the specified source device context into a destination device context
Public Declare Function BitBlt Lib "GDI32" (ByVal hDestDC As Long, ByVal X As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal XSrc As Long, ByVal YSrc As Long, ByVal dwRop As Long) As Long
'deletes the specified device context (DC)
Public Declare Function DeleteDC Lib "GDI32" (ByVal hdc As Long) As Long
'retrieves a handle of a display device context (DC) for the client area of the specified window
Public Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long


Public Function getScreenShot() As Picture
    On Error GoTo err_handler
    Dim hdc As Long
    Dim pictureWidth As Long, pictureHeight As Long
    Dim pictureLeft As Long, pictureTop As Long
    
    hdc = GetDC(0)
    'Set width of picture
    pictureWidth = Screen.Width / Screen.TwipsPerPixelX
    'Set height of picture
    pictureHeight = Screen.Height / Screen.TwipsPerPixelY
    'Set X value of where to capture the picture
    pictureLeft = 0
    'Set Y value of where to capture the picture
    pictureTop = 0
    
    Set getScreenShot = hDCToPicture(hdc, pictureLeft, pictureTop, pictureWidth, pictureHeight)
    
    Exit Function
err_handler:
    putlog ("--- getScreenShot(): " + err.Description)
End Function


Private Function hDCToPicture(ByVal hDCSrc As Long, ByVal LeftSrc As Long, ByVal TopSrc As Long, ByVal WidthSrc As Long, ByVal HeightSrc As Long) As Picture
    On Error GoTo err_handler
    Dim hDCMemory As Long, hBmp As Long, hBmpPrev As Long, r As Long
    Dim hPal As Long, hPalPrev As Long, RasterCapsScrn As Long, HasPaletteScrn As Long
    Dim PaletteSizeScrn As Long, LogPal As LOGPALETTE

    'Create a compatible device context
    hDCMemory = CreateCompatibleDC(hDCSrc)
    'Create a compatible bitmap
    hBmp = CreateCompatibleBitmap(hDCSrc, WidthSrc, HeightSrc)
    'Select the compatible bitmap into our compatible device context
    hBmpPrev = SelectObject(hDCMemory, hBmp)

    'Raster capabilities?
    RasterCapsScrn = GetDeviceCaps(hDCSrc, RASTERCAPS) ' Raster
    'Does our picture use a palette?
    HasPaletteScrn = RasterCapsScrn And RC_PALETTE ' Palette
    'What's the size of that palette?
    PaletteSizeScrn = GetDeviceCaps(hDCSrc, SIZEPALETTE) ' Size of

    If HasPaletteScrn And (PaletteSizeScrn = 256) Then
        'Set the palette version
        LogPal.palVersion = &H300
        'Number of palette entries
        LogPal.palNumEntries = 256
        'Retrieve the system palette entries
        r = GetSystemPaletteEntries(hDCSrc, 0, 256, LogPal.palPalEntry(0))
        'Create the palette
        hPal = CreatePalette(LogPal)
        'Select the palette
        hPalPrev = SelectPalette(hDCMemory, hPal, 0)
        'Realize the palette
        r = RealizePalette(hDCMemory)
    End If

    'Copy the source image to our compatible device context
    r = BitBlt(hDCMemory, 0, 0, WidthSrc, HeightSrc, hDCSrc, LeftSrc, TopSrc, vbSrcCopy)

    'Restore the old bitmap
    hBmp = SelectObject(hDCMemory, hBmpPrev)

    If HasPaletteScrn And (PaletteSizeScrn = 256) Then
        'Select the palette
        hPal = SelectPalette(hDCMemory, hPalPrev, 0)
    End If

    'Delete our memory DC
    r = DeleteDC(hDCMemory)
    
    'Return the picture to the calling function
    Set hDCToPicture = CreateBitmapPicture(hBmp, hPal)
    Exit Function
    
err_handler:
    putlog ("hDCToPicture(): " + err.Description)
End Function


Function CreateBitmapPicture(ByVal hBmp As Long, ByVal hPal As Long) As Picture
    On Error GoTo err_handler
    Dim r As Long, pic As PicBmp, IPic As IPicture, IID_IDispatch As GUID

    'Fill GUID info
    With IID_IDispatch
        .Data1 = &H20400
        .Data4(0) = &HC0
        .Data4(7) = &H46
    End With

    'Fill picture info
    With pic
        .size = Len(pic) ' Length of structure
        .Type = vbPicTypeBitmap ' Type of Picture (bitmap)
        .hBmp = hBmp ' Handle to bitmap
        .hPal = hPal ' Handle to palette (may be null)
    End With

    'Create the picture
    r = OleCreatePictureIndirect(pic, IID_IDispatch, 1, IPic)

    'Return the new picture
    Set CreateBitmapPicture = IPic
    
    Exit Function
    
err_handler:
    putlog ("CreateBitmapPicture (): " + err.Description)
End Function

