Attribute VB_Name = "wdog"
Option Explicit

#Const WINDOWS95 = False

Public Const GWL_STYLE = (-16)
Public Const WS_VISIBLE = &H10000000
Public Const WS_BORDER = &H800000

Public Const LOGBOOK_ENTRY_PROHIBIT_TIME = 600
Public Const MAX_NOT_ACTIVE_COUNTER = 3
Public Const MAX_WAIT_FOR_INPUT_IDLE = 120 * 1000& '120 seconds
Public Const MAX_WAIT_FOR_SINGLE_OBJECT = 1000& ' 1 second

Public Type T_RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Public Type T_BITMAPINFOHEADER
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type

Public Type T_RGBQUAD
    rgbBlue As Byte
    rgbGreen As Byte
    rgbRed As Byte
    rgbReserved As Byte
End Type

Public Type T_BITMAPINFO
    bmiHeader As T_BITMAPINFOHEADER
    bmiColors As T_RGBQUAD
End Type


Public Type NET_PROCINFO
    name As String * 256
    running As Integer
    auto_restart As Integer
    started As Long
    stopped As Long
    'attached As Long
    check_hbeat As Integer
    Reserved As Integer
End Type

Public Type PROCESS_DEF
    phandle As Long
    thandle As Long
    pid As Long
    tid As Long
    name As String
    alias As String
    running As Boolean
    auto_restart As Boolean
    notActiveCounter As Integer
    maxNotActiveCounter As Integer
    started As Date
    stopped As Date
    attached As Date
    hMainWindow As Long
    hMailslot As Long
    hwnds As Collection
    heart_beat As Long
    check_hbeat As Boolean
    request_to_check_hbeat As Boolean
    use_NotPostedCheck As Boolean
    NotPostedCheck_serverName As String
    mustBeRunningProcess As String   ' process, which must be running before this process start
    logBookEntryProhibitTime As Long ' just to limit number of error messages in the logbook, if application crashes every start
    lastLogBookEntryTime As Long
    logBookName As String
    waitForInputIdleTimeout As Long
    waitForSingleObjectTimeout As Long
    notPostedErrorCounter As Long
    workingDirectory As String
End Type

Public Type PROCESS_INFORMATION
    hProcess As Long
    hThread As Long
    dwProcessId As Long
    dwThreadId As Long
End Type

Public Type STARTUP_INFO
    cb As Long
    lpReserved As String
    lpDesktop As String
    lpTitle As String
    dwX As Long
    dwY As Long
    dwXSize As Long
    dwYSize As Long
    dwXCountChars As Long
    dwYCountChars As Long
    dwFillAttribute As Long
    dwFlags As Long
    wShowWindow As Integer
    cbReserved2 As Integer
    lpReserved2 As Long
    hStdInput As Long
    hStdOutput As Long
    hStdError As Long
End Type

Public Type SECURITY_ATTRIBUTES
   nLength As Long
   lpSecurityDescriptor As Long
   bInheritHandle As Long
End Type

Type OVERLAPPED
    Internal As Long
    InternalHigh As Long
    Offset As Long
    OffsetHigh As Long
    hEvent As Long
End Type


Public Declare Function CallNamedPipe Lib "kernel32" Alias _
      "CallNamedPipeA" ( _
      ByVal lpNamedPipeName As String, _
      lpInBuffer As Any, _
      ByVal nInBufferSize As Long, _
      lpOutBuffer As Any, _
      ByVal nOutBufferSize As Long, _
      lpBytesRead As Long, _
      ByVal nTimeout As Long) As Long

Public Declare Function CreateProcess Lib "kernel32" _
        Alias "CreateProcessA" _
                 (ByVal lpApplicationName As String, _
                 ByVal lpCommandLine As String, _
                 lpProcessAttributes As Any, _
                 lpThreadAttributes As Any, _
                 ByVal bInheritHandles As Long, _
                 ByVal dwCreationFlags As Long, _
                 lpEnvironment As Any, _
                 ByVal lpCurrentDriectory As String, _
                 lpStartupInfo As STARTUP_INFO, _
                 lpProcessInformation As PROCESS_INFORMATION) As Long

Public Declare Function OpenProcess Lib "kernel32.dll" _
                 (ByVal dwAccess As Long, _
                 ByVal bInherit As Long, _
                 ByVal dwProcessId As Long) As Long

Public Declare Function TerminateProcess Lib "kernel32" _
                 (ByVal hProcess As Long, _
                 ByVal uExitCode As Long) As Long

Public Declare Function CloseHandle Lib "kernel32" _
                 (ByVal hObject As Long) As Long

Public Declare Function WaitForSingleObject Lib "kernel32" _
    (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long

Public Declare Function waitForInputIdle Lib "user32" Alias "WaitForInputIdle" (ByVal hProcess As Long, ByVal miliseconds As Long) As Long
#If Not WINDOWS95 Then
Public Declare Function GetModuleBaseName Lib "PSAPI.DLL" Alias "GetModuleBaseNameA" (ByVal hProcess As Long, ByVal hModule As Long, ByVal lpBaseName As String, ByVal nSize As Long) As Long
Public Declare Function GetModuleFileNameEx Lib "PSAPI.DLL" Alias "GetModuleFileNameExA" (ByVal hProcess As Long, ByVal hModule As Long, ByVal lpFileName As String, ByVal nSize As Long) As Long
Public Declare Function EnumProcessModules Lib "PSAPI.DLL" (ByVal hProcess As Long, hModule As Long, ByVal cb As Long, cbNeeded As Long) As Long
Public Declare Function EnumProcesses Lib "PSAPI.DLL" (idProcess As Long, ByVal cBytes As Long, cbNeeded As Long) As Long
#End If

Public Declare Function SetDIBitsToDevice Lib "GDI32" (ByVal hdc As Long, ByVal X As Long, ByVal y As _
        Long, ByVal srcRectWidth As Long, ByVal srcRectHeight As Long, ByVal srcX As Long, ByVal srcY As Long, ByVal firstScanLineInArray As _
        Long, ByVal numberOfscanLines As Long, BitsArray As Any, BitsInfo As T_BITMAPINFO, ByVal wUsage As Long) As Long
Public Declare Function GetSystemMetrics Lib "user32" (ByVal nIndex As Long) As Long
Public Declare Function DeleteDC Lib "GDI32" (ByVal hdc As Long) As Long
Public Declare Function DeleteObject Lib "GDI32" (ByVal hObject As Long) As Long
Public Declare Function GetDIBits Lib "gdi32.dll" (ByVal aHDC As Long, ByVal hBitmap As Long, _
                                                   ByVal nStartScan As Long, ByVal nNumScans As Long, _
                                                   lpBits As Any, lpBI As T_BITMAPINFO, ByVal wUsage As Long) As Long
Public Declare Function BitBlt Lib "GDI32" (ByVal hDCDest As Long, ByVal XDest As Long, ByVal YDest As Long, ByVal _
        nWidth As Long, ByVal nHeight As Long, ByVal hDCSrc As Long, ByVal XSrc As Long, ByVal YSrc As Long, ByVal dwRop As Long) As Long
Public Declare Function SelectObject Lib "GDI32" (ByVal hdc As Long, ByVal hObject As Long) As Long
Public Declare Function CreateDIBSection Lib "gdi32.dll" (ByVal hdc As Long, pBitmapInfo As T_BITMAPINFO, _
                                                   ByVal un As Long, ByVal lplpVoid As Long, _
                                                   ByVal handle As Long, ByVal dw As Long) As Long
Public Declare Function ReleaseDC Lib "user32" (ByVal hWnd As Long, ByVal hdc As Long) As Long
Public Declare Function CreateCompatibleDC Lib "GDI32" (ByVal hdc As Long) As Long
Public Declare Function GetDC Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function GetDesktopWindow Lib "user32" () As Long
Public Declare Function GetStartupInfo Lib "kernel32" Alias "GetStartupInfoA" (StartupInfo As STARTUP_INFO) As Long
Public Declare Function GetWindowModuleFileName Lib "user32" (ByVal hWnd As Long, ByVal lpFileName As String, ByVal maxLen As Integer) As Long
Public Declare Function EnumWindows Lib "user32" (ByVal lpEnumFunc As Long, ByVal lParam As Long) As Long
Public Declare Function GetLastError Lib "kernel32" () As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function GetParent Lib "user32" (ByVal hWnd As Long) As Long
Public Declare Function GetWindowThreadProcessId Lib "user32" (ByVal hWnd As Long, lpdwProcessId As Long) As Long
Public Declare Function SendMessageTimeout Lib "user32" _
                        Alias "SendMessageTimeoutA" (ByVal hWnd As Long, _
                        ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long, _
                        ByVal fuFlags As Long, ByVal uTimeout As Long, _
                        pdwResult As Long) As Long
Public Declare Function CreateMailslot Lib "kernel32" _
                        Alias "CreateMailslotA" (ByVal name As String, _
                        ByVal maxMsgSize As Long, ByVal readTimeout As Long, _
                        ByVal securityAttr As Long) As Long  '''SECURITY_ATTRIBUTES) As Long
Declare Function GetMailslotInfo Lib "kernel32" (ByVal hMailslot As Long, lpMaxMessageSize As Long, _
                                                 lpNextSize As Long, lpMessageCount As Long, _
                                                 lpReadTimeout As Long) As Long
Declare Function SetMailslotInfo Lib "kernel32" (ByVal hMailslot As Long, _
                                                 ByVal lReadTimeout As Long) As Long
Public Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" _
        (ByVal lpFileName As String, ByVal _
        dwDesiredAccess As Long, ByVal dwShareMode As Long, _
        lpSecurityAttributes As SECURITY_ATTRIBUTES, _
        ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, _
        ByVal hTemplateFile As Long) As Long
Public Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, lpBuffer As Byte, _
                                                 ByVal nNumberOfBytesToRead As Long, _
                                                 lpNumberOfBytesRead As Long, _
                                                 ByVal lpOverlapped_passNULL As Long) As Long
Public Declare Function WriteFile Lib "kernel32" _
                                         (ByVal hFile As Long, ByVal lpBuffer As String, _
                                          ByVal nNumberOfBytesToWrite As Long, _
                                          lpNumberOfBytesWritten As Long, _
                                          ByVal lpOverlapped As Long) As Long

Public Declare Function WaitNamedPipe Lib "kernel32" Alias "WaitNamedPipeA" (ByVal lpNamedPipeName As String, ByVal nTimeout As Long) As Long


Declare Function QueryDosDevice Lib "kernel32" Alias "QueryDosDeviceA" (ByVal lpDeviceName As String, ByVal lpTargetPath As String, ByVal ucchMax As Long) As Long

 Declare Function GetDriveType Lib "kernel32" Alias _
"GetDriveTypeA" ( _
    ByVal nDrive As String) As Long

Declare Function GetLogicalDriveStrings Lib "kernel32" _
    Alias "GetLogicalDriveStringsA" (ByVal nBufferLength As Long, _
    ByVal lpBuffer As String) As Long

Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" _
                            (ByVal hWnd As Long, ByVal wIndx As Long) As Long



'API constants

Public Const DRIVE_CDROM As Long = 5
Public Const DRIVE_FIXED As Long = 3
Public Const DRIVE_RAMDISK As Long = 6
Public Const DRIVE_REMOTE As Long = 4
Public Const DRIVE_REMOVABLE As Long = 2

' system metrics
Public Const SM_XVIRTUALSCREEN = 76    'virtual desktop left
Public Const SM_YVIRTUALSCREEN = 77    'virtual top
Public Const SM_CXVIRTUALSCREEN = 78   'virtual width
Public Const SM_CYVIRTUALSCREEN = 79   'virtual height
Public Const SM_CMONITORS = 80         'number of monitors
Public Const SM_SAMEDISPLAYFORMAT = 81
  
Public Const DIB_RGB_COLORS As Long = 0
Public Const BI_RGB As Long = 0
Public Const FILE_SHARE_READ = &H1
Public Const FILE_SHARE_WRITE = &H2
Public Const OPEN_EXISTING = 3
Public Const FILE_ATTRIBUTE_NORMAL = &H80
Public Const GENERIC_READ = &H80000000
Public Const GENERIC_WRITE = &H40000000
Public Const GENERIC_EXECUTE = &H20000000
Public Const GENERIC_ALL = &H10000000

Public Const SMTO_BLOCK = &H1
Public Const SMTO_ABORTIFHUNG = &H2
Public Const NORMAL_PRIORITY_CLASS = &H20&
Public Const WM_CLOSE = &H10
Public Const WM_NULL = &H0
Public Const WM_DESTROY = &H2

Public Const PROCESS_TERMINATE As Long = 1
Public Const STANDARD_RIGHTS_REQUIRED = &HF0000
Public Const SYNCHRONIZE = &H100000
Public Const PROCESS_VM_READ = &H10
Public Const PROCESS_QUERY_INFORMATION = &H400
Public Const PROCESS_ALL_ACCESS As Long = STANDARD_RIGHTS_REQUIRED Or SYNCHRONIZE Or &HFFF

Public Const WAIT_FAILED = -1&
Public Const WAIT_OBJECT_0 = 0
Public Const WAIT_ABONDONED = &H80&
Public Const WAIT_ABONDONED_0 = &H80&
Public Const WAIT_TIMEOUT = &H102&


Public Const NMPWAIT_NOWAIT = 1
Public Const NMPWAIT_USE_DEFAULT_WAIT = 0
Public Const NMPWAIT_WAIT_FOREVER = -1

Public Const ERROR_TIMEOUT = &H5B4&   '1460 dec

Public Const MAILSLOT_NO_MESSAGE = (-1)
Public Const MAILSLOT_WAIT_FOREVER = (-1)

Public Const MAX_PATH = 260
Public Const MAX_SCREEN_DUMPS = 3

Public IsNT As Boolean ' = true, if operating system is WinNT/Win2000
Public Net_ProcDef As NET_PROCINFO
Public Nproc As Long
Public ProcList() As PROCESS_DEF
Public ConfigFilePath As String
Public MaintenanceMode As Boolean

Public Function findAllWindowsCallBack(ByVal hWnd As Long, ByVal pd_indx As Long) As Long
Dim lParent    As Long
Dim lThreadId  As Long
Dim lProcessId As Long
Dim err As Long
Dim windowStyle As Long

findAllWindowsCallBack = 1  ' continue EnumWindows
lThreadId = GetWindowThreadProcessId(hWnd, lProcessId)
'ignore threadID
If ProcList(pd_indx).pid = lProcessId Then
    lParent = GetParent(hWnd)
    If lParent = 0 Then
        err = GetLastError()
        If err <> 0 Then putlog ("findAllWindowsCallBack() error: " + str(err))
        windowStyle = GetWindowLong(hWnd, GWL_STYLE)  'added by Karol, 08.03.2006
        windowStyle = windowStyle And (WS_VISIBLE Or WS_BORDER) 'added by Karol, 08.03.2006
        If (windowStyle = (WS_VISIBLE Or WS_BORDER)) Then   'added by Karol, 08.03.2006
            ProcList(pd_indx).hwnds.Add hWnd
        End If 'added by Karol, 08.03.2006
    End If
End If

End Function

Public Function findMainWindowCallBack(ByVal hWnd As Long, ByVal pd_indx As Long) As Long
Dim lParent    As Long
Dim lThreadId  As Long
Dim lProcessId As Long
Dim windowStyle As Long
Dim err As Long
'
' This callback function is called by Windows (from the EnumWindows
' API call) for EVERY top-level window that exists.  It populates a
' collection with the handles of all parent windows owned by the
' process that we started.
'
findMainWindowCallBack = 1   ' continue EnumWindows
lThreadId = GetWindowThreadProcessId(hWnd, lProcessId)

If (ProcList(pd_indx).pid = lProcessId) And _
   (ProcList(pd_indx).tid = lThreadId) Then
    lParent = GetParent(hWnd)
    If lParent = 0 Then
        err = GetLastError()
        If err <> 0 Then putlog ("findMainWindowCallBack() error:" + str(err))
        windowStyle = GetWindowLong(hWnd, GWL_STYLE)  'added by Karol, 08.03.2006
        windowStyle = windowStyle And (WS_VISIBLE Or WS_BORDER) 'added by Karol, 08.03.2006
        If (windowStyle = (WS_VISIBLE Or WS_BORDER)) Then   'added by Karol, 08.03.2006
            ProcList(pd_indx).hMainWindow = hWnd
        End If 'added by Karol, 08.03.2006
    End If
End If

End Function

Public Function findWindows(pd_indx As Long) As Boolean
'
' The EnumWindows function enumerates all top-level windows
' by passing the handle of each window, in turn, to an
' application-defined callback function. EnumWindows
' continues until the last top-level window is enumerated or
' the callback function returns FALSE.
'
Call EnumWindows(AddressOf findAllWindowsCallBack, pd_indx)
End Function

Public Function findMainWindow(pd_indx As Long) As Boolean
Call EnumWindows(AddressOf findMainWindowCallBack, pd_indx)
End Function

'
'  SOME OTHER FUNCTIONS
'
Public Sub putlog(txt As String)
    Call MAIN.LOG.LOG(txt)
    Call feclog(txt)
End Sub

Public Function Trim0(sName As String) As String
' Keep left portion of string sName up to first 0. Useful with Win API null terminated strings.
    Dim X As Integer
    X = InStr(sName, Chr$(0))
    If X > 0 Then Trim0 = Left$(sName, X - 1) Else Trim0 = sName
End Function

'add horizontal scroll to list box
''API/Global Declarations
' Declare Function SendMessage Lib "user32" Alias_
' "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long,_
' ByVal wParam As Long, lParam As Long) As Long
'
'       Const WM_USER = &H400
'       Const LB_SETHORIZONTALEXTENT = WM_USER + 21'

 'Call this procedure everytime the content of the listbox has changed
' Sub CheckListBox()

 '      Dim i%, res&
  '     Dim Scrollwidth&
'
 '  For i% = 0 To Form1.List1.ListCount
  '    If Form1.TextWidth(Form1.List1.List(i%)) > Scrollwidth& Then_
 'Scrollwidth& = Form1.TextWidth(Form1.List1.List(i%))
  ' Next i%

 'res& = SendMessage(Form1.List1.hwnd, LB_SETHORIZONTALEXTENT, _
 'Scrollwidth&, 0&)
 'End Sub
 


